// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8AnimationEventInit.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8EventInit.h"

namespace blink {

void V8AnimationEventInit::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, AnimationEventInit& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    V8EventInit::toImpl(isolate, v8Value, impl, exceptionState);
    if (exceptionState.hadException())
        return;

    v8::TryCatch block;
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> animationNameValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "animationName")).ToLocal(&animationNameValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (animationNameValue.IsEmpty() || animationNameValue->IsUndefined()) {
            // Do nothing.
        } else {
            V8StringResource<> animationName = animationNameValue;
            if (!animationName.prepare(exceptionState))
                return;
            impl.setAnimationName(animationName);
        }
    }

    {
        v8::Local<v8::Value> elapsedTimeValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "elapsedTime")).ToLocal(&elapsedTimeValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (elapsedTimeValue.IsEmpty() || elapsedTimeValue->IsUndefined()) {
            // Do nothing.
        } else {
            double elapsedTime = toRestrictedDouble(isolate, elapsedTimeValue, exceptionState);
            if (exceptionState.hadException())
                return;
            impl.setElapsedTime(elapsedTime);
        }
    }

}

v8::Local<v8::Value> toV8(const AnimationEventInit& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8EventInit(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    if (!toV8AnimationEventInit(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8AnimationEventInit(const AnimationEventInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasAnimationName()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "animationName"), v8String(isolate, impl.animationName()))))
            return false;
    } else {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "animationName"), v8String(isolate, String("")))))
            return false;
    }

    if (impl.hasElapsedTime()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "elapsedTime"), v8::Number::New(isolate, impl.elapsedTime()))))
            return false;
    } else {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "elapsedTime"), v8::Number::New(isolate, 0))))
            return false;
    }

    return true;
}

AnimationEventInit NativeValueTraits<AnimationEventInit>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    AnimationEventInit impl;
    V8AnimationEventInit::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
