// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8CustomEventInit.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/ScriptValue.h"
#include "bindings/core/v8/V8EventInit.h"

namespace blink {

void V8CustomEventInit::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, CustomEventInit& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    V8EventInit::toImpl(isolate, v8Value, impl, exceptionState);
    if (exceptionState.hadException())
        return;

    v8::TryCatch block;
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> detailValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "detail")).ToLocal(&detailValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (detailValue.IsEmpty() || detailValue->IsUndefined()) {
            // Do nothing.
        } else {
            ScriptValue detail = ScriptValue(ScriptState::current(isolate), detailValue);
            impl.setDetail(detail);
        }
    }

}

v8::Local<v8::Value> toV8(const CustomEventInit& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8EventInit(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    if (!toV8CustomEventInit(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8CustomEventInit(const CustomEventInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasDetail()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "detail"), impl.detail().v8Value())))
            return false;
    } else {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "detail"), v8::Null(isolate))))
            return false;
    }

    return true;
}

CustomEventInit NativeValueTraits<CustomEventInit>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    CustomEventInit impl;
    V8CustomEventInit::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
