// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8ElementRegistrationOptions.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/ScriptValue.h"

namespace blink {

void V8ElementRegistrationOptions::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, ElementRegistrationOptions& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    v8::TryCatch block;
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> extendsValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "extends")).ToLocal(&extendsValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (extendsValue.IsEmpty() || extendsValue->IsUndefined()) {
            // Do nothing.
        } else if (extendsValue->IsNull()) {
            impl.setExtendsToNull();
        } else {
            V8StringResource<> extends = extendsValue;
            if (!extends.prepare(exceptionState))
                return;
            impl.setExtends(extends);
        }
    }

    {
        v8::Local<v8::Value> prototypeValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "prototype")).ToLocal(&prototypeValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (prototypeValue.IsEmpty() || prototypeValue->IsUndefined()) {
            // Do nothing.
        } else if (prototypeValue->IsNull()) {
            impl.setPrototypeToNull();
        } else {
            ScriptValue prototype = ScriptValue(ScriptState::current(isolate), prototypeValue);
            if (!prototype.isObject()) {
                exceptionState.throwTypeError("member prototype is not an object.");
                return;
            }
            impl.setPrototype(prototype);
        }
    }

}

v8::Local<v8::Value> toV8(const ElementRegistrationOptions& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8ElementRegistrationOptions(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8ElementRegistrationOptions(const ElementRegistrationOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasExtends()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "extends"), v8String(isolate, impl.extends()))))
            return false;
    } else {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "extends"), v8::Null(isolate))))
            return false;
    }

    if (impl.hasPrototype()) {
        ASSERT(impl.prototype().isObject());
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "prototype"), impl.prototype().v8Value())))
            return false;
    } else {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "prototype"), v8::Null(isolate))))
            return false;
    }

    return true;
}

ElementRegistrationOptions NativeValueTraits<ElementRegistrationOptions>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    ElementRegistrationOptions impl;
    V8ElementRegistrationOptions::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
