// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8PerformanceNavigation.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "core/dom/ContextFeatures.h"
#include "core/dom/Document.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/TraceEvent.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8PerformanceNavigation::wrapperTypeInfo = { gin::kEmbedderBlink, V8PerformanceNavigation::domTemplate, V8PerformanceNavigation::refObject, V8PerformanceNavigation::derefObject, V8PerformanceNavigation::trace, 0, 0, V8PerformanceNavigation::preparePrototypeObject, V8PerformanceNavigation::installConditionallyEnabledProperties, "PerformanceNavigation", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent, WrapperTypeInfo::GarbageCollectedObject };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in PerformanceNavigation.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& PerformanceNavigation::s_wrapperTypeInfo = V8PerformanceNavigation::wrapperTypeInfo;

namespace PerformanceNavigationV8Internal {

static void typeAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    v8::Local<v8::Object> holder = info.Holder();
    PerformanceNavigation* impl = V8PerformanceNavigation::toImpl(holder);
    v8SetReturnValueUnsigned(info, impl->type());
}

static void typeAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMGetter");
    PerformanceNavigationV8Internal::typeAttributeGetter(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void redirectCountAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    v8::Local<v8::Object> holder = info.Holder();
    PerformanceNavigation* impl = V8PerformanceNavigation::toImpl(holder);
    v8SetReturnValueUnsigned(info, impl->redirectCount());
}

static void redirectCountAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMGetter");
    PerformanceNavigationV8Internal::redirectCountAttributeGetter(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

} // namespace PerformanceNavigationV8Internal

static const V8DOMConfiguration::AccessorConfiguration V8PerformanceNavigationAccessors[] = {
    {"type", PerformanceNavigationV8Internal::typeAttributeGetterCallback, 0, 0, 0, 0, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"redirectCount", PerformanceNavigationV8Internal::redirectCountAttributeGetterCallback, 0, 0, 0, 0, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

static void installV8PerformanceNavigationTemplate(v8::Local<v8::FunctionTemplate> functionTemplate, v8::Isolate* isolate)
{
    functionTemplate->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "PerformanceNavigation", v8::Local<v8::FunctionTemplate>(), V8PerformanceNavigation::internalFieldCount,
        0, 0,
        V8PerformanceNavigationAccessors, WTF_ARRAY_LENGTH(V8PerformanceNavigationAccessors),
        0, 0);
    v8::Local<v8::ObjectTemplate> instanceTemplate = functionTemplate->InstanceTemplate();
    ALLOW_UNUSED_LOCAL(instanceTemplate);
    v8::Local<v8::ObjectTemplate> prototypeTemplate = functionTemplate->PrototypeTemplate();
    ALLOW_UNUSED_LOCAL(prototypeTemplate);
    static const V8DOMConfiguration::ConstantConfiguration V8PerformanceNavigationConstants[] = {
        {"TYPE_NAVIGATE", 0, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedShort},
        {"TYPE_RELOAD", 1, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedShort},
        {"TYPE_BACK_FORWARD", 2, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedShort},
        {"TYPE_RESERVED", 255, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedShort},
    };
    V8DOMConfiguration::installConstants(isolate, functionTemplate, prototypeTemplate, V8PerformanceNavigationConstants, WTF_ARRAY_LENGTH(V8PerformanceNavigationConstants));
    static_assert(0 == PerformanceNavigation::TYPE_NAVIGATE, "the value of PerformanceNavigation_TYPE_NAVIGATE does not match with implementation");
    static_assert(1 == PerformanceNavigation::TYPE_RELOAD, "the value of PerformanceNavigation_TYPE_RELOAD does not match with implementation");
    static_assert(2 == PerformanceNavigation::TYPE_BACK_FORWARD, "the value of PerformanceNavigation_TYPE_BACK_FORWARD does not match with implementation");
    static_assert(255 == PerformanceNavigation::TYPE_RESERVED, "the value of PerformanceNavigation_TYPE_RESERVED does not match with implementation");

    // Custom toString template
    functionTemplate->Set(v8AtomicString(isolate, "toString"), V8PerIsolateData::from(isolate)->toStringTemplate());
}

v8::Local<v8::FunctionTemplate> V8PerformanceNavigation::domTemplate(v8::Isolate* isolate)
{
    return V8DOMConfiguration::domClassTemplate(isolate, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8PerformanceNavigationTemplate);
}

bool V8PerformanceNavigation::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8PerformanceNavigation::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

PerformanceNavigation* V8PerformanceNavigation::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value)
{
    return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : 0;
}

void V8PerformanceNavigation::refObject(ScriptWrappable* scriptWrappable)
{
}

void V8PerformanceNavigation::derefObject(ScriptWrappable* scriptWrappable)
{
}

} // namespace blink
