// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8ScrollOptions.h"

#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8ScrollOptions::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, ScrollOptions& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    v8::TryCatch block;
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> behaviorValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "behavior")).ToLocal(&behaviorValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (behaviorValue.IsEmpty() || behaviorValue->IsUndefined()) {
            // Do nothing.
        } else {
            V8StringResource<> behavior = behaviorValue;
            if (!behavior.prepare(exceptionState))
                return;
            static const char* validValues[] = {
                "auto",
                "instant",
                "smooth",
            };
            if (!isValidEnum(behavior, validValues, WTF_ARRAY_LENGTH(validValues), "ScrollBehavior", exceptionState))
                return;
            impl.setBehavior(behavior);
        }
    }

}

v8::Local<v8::Value> toV8(const ScrollOptions& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8ScrollOptions(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8ScrollOptions(const ScrollOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasBehavior()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "behavior"), v8String(isolate, impl.behavior()))))
            return false;
    } else {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "behavior"), v8String(isolate, String("auto")))))
            return false;
    }

    return true;
}

ScrollOptions NativeValueTraits<ScrollOptions>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    ScrollOptions impl;
    V8ScrollOptions::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
