// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8StateOptions.h"

#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8StateOptions::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, StateOptions& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    v8::TryCatch block;
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> scrollRestorationValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "scrollRestoration")).ToLocal(&scrollRestorationValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (scrollRestorationValue.IsEmpty() || scrollRestorationValue->IsUndefined()) {
            // Do nothing.
        } else {
            V8StringResource<> scrollRestoration = scrollRestorationValue;
            if (!scrollRestoration.prepare(exceptionState))
                return;
            static const char* validValues[] = {
                "auto",
                "manual",
            };
            if (!isValidEnum(scrollRestoration, validValues, WTF_ARRAY_LENGTH(validValues), "ScrollRestoration", exceptionState))
                return;
            impl.setScrollRestoration(scrollRestoration);
        }
    }

}

v8::Local<v8::Value> toV8(const StateOptions& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8StateOptions(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8StateOptions(const StateOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasScrollRestoration()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "scrollRestoration"), v8String(isolate, impl.scrollRestoration()))))
            return false;
    } else {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "scrollRestoration"), v8String(isolate, String("auto")))))
            return false;
    }

    return true;
}

StateOptions NativeValueTraits<StateOptions>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    StateOptions impl;
    V8StateOptions::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
