// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8TrackEventInit.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/UnionTypesCore.h"
#include "bindings/core/v8/V8AudioTrack.h"
#include "bindings/core/v8/V8EventInit.h"
#include "bindings/core/v8/V8TextTrack.h"
#include "bindings/core/v8/V8VideoTrack.h"

namespace blink {

void V8TrackEventInit::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, TrackEventInit& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    V8EventInit::toImpl(isolate, v8Value, impl, exceptionState);
    if (exceptionState.hadException())
        return;

    v8::TryCatch block;
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> trackValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "track")).ToLocal(&trackValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (trackValue.IsEmpty() || trackValue->IsUndefined()) {
            // Do nothing.
        } else if (trackValue->IsNull()) {
            impl.setTrackToNull();
        } else {
            VideoTrackOrAudioTrackOrTextTrack track;
            V8VideoTrackOrAudioTrackOrTextTrack::toImpl(isolate, trackValue, track, exceptionState);
            if (exceptionState.hadException())
                return;
            impl.setTrack(track);
        }
    }

}

v8::Local<v8::Value> toV8(const TrackEventInit& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8EventInit(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    if (!toV8TrackEventInit(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8TrackEventInit(const TrackEventInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasTrack()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "track"), toV8(impl.track(), creationContext, isolate))))
            return false;
    }

    return true;
}

TrackEventInit NativeValueTraits<TrackEventInit>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    TrackEventInit impl;
    V8TrackEventInit::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
