// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8BluetoothGATTRemoteServer.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/ScriptPromise.h"
#include "bindings/core/v8/ScriptState.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "bindings/modules/v8/UnionTypesModules.h"
#include "core/dom/ContextFeatures.h"
#include "core/dom/Document.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/TraceEvent.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8BluetoothGATTRemoteServer::wrapperTypeInfo = { gin::kEmbedderBlink, V8BluetoothGATTRemoteServer::domTemplate, V8BluetoothGATTRemoteServer::refObject, V8BluetoothGATTRemoteServer::derefObject, V8BluetoothGATTRemoteServer::trace, 0, 0, V8BluetoothGATTRemoteServer::preparePrototypeObject, V8BluetoothGATTRemoteServer::installConditionallyEnabledProperties, "BluetoothGATTRemoteServer", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent, WrapperTypeInfo::GarbageCollectedObject };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in BluetoothGATTRemoteServer.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& BluetoothGATTRemoteServer::s_wrapperTypeInfo = V8BluetoothGATTRemoteServer::wrapperTypeInfo;

namespace BluetoothGATTRemoteServerV8Internal {

static void connectedAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    v8::Local<v8::Object> holder = info.Holder();
    BluetoothGATTRemoteServer* impl = V8BluetoothGATTRemoteServer::toImpl(holder);
    v8SetReturnValueBool(info, impl->connected());
}

static void connectedAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMGetter");
    BluetoothGATTRemoteServerV8Internal::connectedAttributeGetter(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getPrimaryServiceMethodPromise(const v8::FunctionCallbackInfo<v8::Value>& info, ExceptionState& exceptionState)
{
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        return;
    }
    BluetoothGATTRemoteServer* impl = V8BluetoothGATTRemoteServer::toImpl(info.Holder());
    StringOrUnsignedLong service;
    {
        V8StringOrUnsignedLong::toImpl(info.GetIsolate(), info[0], service, exceptionState);
        if (exceptionState.hadException())
            return;
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptPromise result = impl->getPrimaryService(scriptState, service, exceptionState);
    if (exceptionState.hadException()) {
        return;
    }
    v8SetReturnValue(info, result.v8Value());
}

static void getPrimaryServiceMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getPrimaryService", "BluetoothGATTRemoteServer", info.Holder(), info.GetIsolate());
    getPrimaryServiceMethodPromise(info, exceptionState);
    if (exceptionState.hadException())
        v8SetReturnValue(info, exceptionState.reject(ScriptState::current(info.GetIsolate())).v8Value());
}

static void getPrimaryServiceMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    BluetoothGATTRemoteServerV8Internal::getPrimaryServiceMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

} // namespace BluetoothGATTRemoteServerV8Internal

static const V8DOMConfiguration::AccessorConfiguration V8BluetoothGATTRemoteServerAccessors[] = {
    {"connected", BluetoothGATTRemoteServerV8Internal::connectedAttributeGetterCallback, 0, 0, 0, 0, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

static const V8DOMConfiguration::MethodConfiguration V8BluetoothGATTRemoteServerMethods[] = {
    {"getPrimaryService", BluetoothGATTRemoteServerV8Internal::getPrimaryServiceMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
};

static void installV8BluetoothGATTRemoteServerTemplate(v8::Local<v8::FunctionTemplate> functionTemplate, v8::Isolate* isolate)
{
    functionTemplate->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    if (!RuntimeEnabledFeatures::webBluetoothEnabled())
        defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "BluetoothGATTRemoteServer", v8::Local<v8::FunctionTemplate>(), V8BluetoothGATTRemoteServer::internalFieldCount, 0, 0, 0, 0, 0, 0);
    else
        defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "BluetoothGATTRemoteServer", v8::Local<v8::FunctionTemplate>(), V8BluetoothGATTRemoteServer::internalFieldCount,
            0, 0,
            V8BluetoothGATTRemoteServerAccessors, WTF_ARRAY_LENGTH(V8BluetoothGATTRemoteServerAccessors),
            V8BluetoothGATTRemoteServerMethods, WTF_ARRAY_LENGTH(V8BluetoothGATTRemoteServerMethods));
    v8::Local<v8::ObjectTemplate> instanceTemplate = functionTemplate->InstanceTemplate();
    ALLOW_UNUSED_LOCAL(instanceTemplate);
    v8::Local<v8::ObjectTemplate> prototypeTemplate = functionTemplate->PrototypeTemplate();
    ALLOW_UNUSED_LOCAL(prototypeTemplate);

    // Custom toString template
    functionTemplate->Set(v8AtomicString(isolate, "toString"), V8PerIsolateData::from(isolate)->toStringTemplate());
}

v8::Local<v8::FunctionTemplate> V8BluetoothGATTRemoteServer::domTemplate(v8::Isolate* isolate)
{
    return V8DOMConfiguration::domClassTemplate(isolate, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8BluetoothGATTRemoteServerTemplate);
}

bool V8BluetoothGATTRemoteServer::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8BluetoothGATTRemoteServer::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

BluetoothGATTRemoteServer* V8BluetoothGATTRemoteServer::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value)
{
    return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : 0;
}

void V8BluetoothGATTRemoteServer::refObject(ScriptWrappable* scriptWrappable)
{
}

void V8BluetoothGATTRemoteServer::derefObject(ScriptWrappable* scriptWrappable)
{
}

} // namespace blink
