// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8CredentialsContainer.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/ScriptPromise.h"
#include "bindings/core/v8/ScriptState.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "bindings/modules/v8/V8Credential.h"
#include "bindings/modules/v8/V8CredentialRequestOptions.h"
#include "core/dom/ContextFeatures.h"
#include "core/dom/Document.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/TraceEvent.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8CredentialsContainer::wrapperTypeInfo = { gin::kEmbedderBlink, V8CredentialsContainer::domTemplate, V8CredentialsContainer::refObject, V8CredentialsContainer::derefObject, V8CredentialsContainer::trace, 0, 0, V8CredentialsContainer::preparePrototypeObject, V8CredentialsContainer::installConditionallyEnabledProperties, "CredentialsContainer", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent, WrapperTypeInfo::GarbageCollectedObject };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in CredentialsContainer.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& CredentialsContainer::s_wrapperTypeInfo = V8CredentialsContainer::wrapperTypeInfo;

namespace CredentialsContainerV8Internal {

static void requestMethodPromise(const v8::FunctionCallbackInfo<v8::Value>& info, ExceptionState& exceptionState)
{
    CredentialsContainer* impl = V8CredentialsContainer::toImpl(info.Holder());
    CredentialRequestOptions options;
    {
        if (!isUndefinedOrNull(info[0]) && !info[0]->IsObject()) {
            exceptionState.throwTypeError("parameter 1 ('options') is not an object.");
            return;
        }
        V8CredentialRequestOptions::toImpl(info.GetIsolate(), info[0], options, exceptionState);
        if (exceptionState.hadException())
            return;
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptPromise result = impl->request(scriptState, options);
    v8SetReturnValue(info, result.v8Value());
}

static void requestMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "request", "CredentialsContainer", info.Holder(), info.GetIsolate());
    requestMethodPromise(info, exceptionState);
    if (exceptionState.hadException())
        v8SetReturnValue(info, exceptionState.reject(ScriptState::current(info.GetIsolate())).v8Value());
}

static void requestMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    CredentialsContainerV8Internal::requestMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void notifySignedInMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        v8SetReturnValue(info, ScriptPromise::rejectRaw(ScriptState::current(info.GetIsolate()), createMinimumArityTypeErrorForMethod(info.GetIsolate(), "notifySignedIn", "CredentialsContainer", 1, info.Length())));
        return;
    }
    CredentialsContainer* impl = V8CredentialsContainer::toImpl(info.Holder());
    Credential* credential;
    {
        credential = V8Credential::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!credential) {
            v8SetReturnValue(info, ScriptPromise::rejectRaw(ScriptState::current(info.GetIsolate()), V8ThrowException::createTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("notifySignedIn", "CredentialsContainer", "parameter 1 is not of type 'Credential'."))));
            return;
        }
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptPromise result = impl->notifySignedIn(scriptState, credential);
    v8SetReturnValue(info, result.v8Value());
}

static void notifySignedInMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    CredentialsContainerV8Internal::notifySignedInMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void requireUserMediationMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    CredentialsContainer* impl = V8CredentialsContainer::toImpl(info.Holder());
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptPromise result = impl->requireUserMediation(scriptState);
    v8SetReturnValue(info, result.v8Value());
}

static void requireUserMediationMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    CredentialsContainerV8Internal::requireUserMediationMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

} // namespace CredentialsContainerV8Internal

static const V8DOMConfiguration::MethodConfiguration V8CredentialsContainerMethods[] = {
    {"request", CredentialsContainerV8Internal::requestMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts},
    {"notifySignedIn", CredentialsContainerV8Internal::notifySignedInMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"requireUserMediation", CredentialsContainerV8Internal::requireUserMediationMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts},
};

static void installV8CredentialsContainerTemplate(v8::Local<v8::FunctionTemplate> functionTemplate, v8::Isolate* isolate)
{
    functionTemplate->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    if (!RuntimeEnabledFeatures::credentialManagerEnabled())
        defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "CredentialsContainer", v8::Local<v8::FunctionTemplate>(), V8CredentialsContainer::internalFieldCount, 0, 0, 0, 0, 0, 0);
    else
        defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "CredentialsContainer", v8::Local<v8::FunctionTemplate>(), V8CredentialsContainer::internalFieldCount,
            0, 0,
            0, 0,
            V8CredentialsContainerMethods, WTF_ARRAY_LENGTH(V8CredentialsContainerMethods));
    v8::Local<v8::ObjectTemplate> instanceTemplate = functionTemplate->InstanceTemplate();
    ALLOW_UNUSED_LOCAL(instanceTemplate);
    v8::Local<v8::ObjectTemplate> prototypeTemplate = functionTemplate->PrototypeTemplate();
    ALLOW_UNUSED_LOCAL(prototypeTemplate);

    // Custom toString template
    functionTemplate->Set(v8AtomicString(isolate, "toString"), V8PerIsolateData::from(isolate)->toStringTemplate());
}

v8::Local<v8::FunctionTemplate> V8CredentialsContainer::domTemplate(v8::Isolate* isolate)
{
    return V8DOMConfiguration::domClassTemplate(isolate, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8CredentialsContainerTemplate);
}

bool V8CredentialsContainer::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8CredentialsContainer::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

CredentialsContainer* V8CredentialsContainer::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value)
{
    return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : 0;
}

void V8CredentialsContainer::refObject(ScriptWrappable* scriptWrappable)
{
}

void V8CredentialsContainer::derefObject(ScriptWrappable* scriptWrappable)
{
}

} // namespace blink
