// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8DeprecatedStorageQuota.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "bindings/modules/v8/V8StorageErrorCallback.h"
#include "bindings/modules/v8/V8StorageQuotaCallback.h"
#include "bindings/modules/v8/V8StorageUsageCallback.h"
#include "core/dom/ContextFeatures.h"
#include "core/dom/Document.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/TraceEvent.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8DeprecatedStorageQuota::wrapperTypeInfo = { gin::kEmbedderBlink, V8DeprecatedStorageQuota::domTemplate, V8DeprecatedStorageQuota::refObject, V8DeprecatedStorageQuota::derefObject, V8DeprecatedStorageQuota::trace, 0, 0, V8DeprecatedStorageQuota::preparePrototypeObject, V8DeprecatedStorageQuota::installConditionallyEnabledProperties, "DeprecatedStorageQuota", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent, WrapperTypeInfo::GarbageCollectedObject };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in DeprecatedStorageQuota.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& DeprecatedStorageQuota::s_wrapperTypeInfo = V8DeprecatedStorageQuota::wrapperTypeInfo;

namespace DeprecatedStorageQuotaV8Internal {

static void queryUsageAndQuotaMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "queryUsageAndQuota", "DeprecatedStorageQuota", 1, info.Length()), info.GetIsolate());
        return;
    }
    DeprecatedStorageQuota* impl = V8DeprecatedStorageQuota::toImpl(info.Holder());
    StorageUsageCallback* usageCallback;
    StorageErrorCallback* errorCallback;
    {
        if (info.Length() <= 0 || !info[0]->IsFunction()) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("queryUsageAndQuota", "DeprecatedStorageQuota", "The callback provided as parameter 1 is not a function."));
            return;
        }
        usageCallback = V8StorageUsageCallback::create(v8::Local<v8::Function>::Cast(info[0]), ScriptState::current(info.GetIsolate()));
        if (!isUndefinedOrNull(info[1])) {
            if (!info[1]->IsFunction()) {
                V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("queryUsageAndQuota", "DeprecatedStorageQuota", "The callback provided as parameter 2 is not a function."));
                return;
            }
            errorCallback = V8StorageErrorCallback::create(v8::Local<v8::Function>::Cast(info[1]), ScriptState::current(info.GetIsolate()));
        } else {
            errorCallback = nullptr;
        }
    }
    ExecutionContext* executionContext = currentExecutionContext(info.GetIsolate());
    impl->queryUsageAndQuota(executionContext, usageCallback, errorCallback);
}

static void queryUsageAndQuotaMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    DeprecatedStorageQuotaV8Internal::queryUsageAndQuotaMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void requestQuotaMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "requestQuota", "DeprecatedStorageQuota", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    DeprecatedStorageQuota* impl = V8DeprecatedStorageQuota::toImpl(info.Holder());
    unsigned long long newQuotaInBytes;
    StorageQuotaCallback* quotaCallback;
    StorageErrorCallback* errorCallback;
    {
        newQuotaInBytes = toUInt64(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        if (!isUndefinedOrNull(info[1])) {
            if (!info[1]->IsFunction()) {
                exceptionState.throwTypeError("The callback provided as parameter 2 is not a function.");
                exceptionState.throwIfNeeded();
                return;
            }
            quotaCallback = V8StorageQuotaCallback::create(v8::Local<v8::Function>::Cast(info[1]), ScriptState::current(info.GetIsolate()));
        } else {
            quotaCallback = nullptr;
        }
        if (!isUndefinedOrNull(info[2])) {
            if (!info[2]->IsFunction()) {
                exceptionState.throwTypeError("The callback provided as parameter 3 is not a function.");
                exceptionState.throwIfNeeded();
                return;
            }
            errorCallback = V8StorageErrorCallback::create(v8::Local<v8::Function>::Cast(info[2]), ScriptState::current(info.GetIsolate()));
        } else {
            errorCallback = nullptr;
        }
    }
    ExecutionContext* executionContext = currentExecutionContext(info.GetIsolate());
    impl->requestQuota(executionContext, newQuotaInBytes, quotaCallback, errorCallback);
}

static void requestQuotaMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    DeprecatedStorageQuotaV8Internal::requestQuotaMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

} // namespace DeprecatedStorageQuotaV8Internal

static const V8DOMConfiguration::MethodConfiguration V8DeprecatedStorageQuotaMethods[] = {
    {"queryUsageAndQuota", DeprecatedStorageQuotaV8Internal::queryUsageAndQuotaMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"requestQuota", DeprecatedStorageQuotaV8Internal::requestQuotaMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
};

static void installV8DeprecatedStorageQuotaTemplate(v8::Local<v8::FunctionTemplate> functionTemplate, v8::Isolate* isolate)
{
    functionTemplate->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "DeprecatedStorageQuota", v8::Local<v8::FunctionTemplate>(), V8DeprecatedStorageQuota::internalFieldCount,
        0, 0,
        0, 0,
        V8DeprecatedStorageQuotaMethods, WTF_ARRAY_LENGTH(V8DeprecatedStorageQuotaMethods));
    v8::Local<v8::ObjectTemplate> instanceTemplate = functionTemplate->InstanceTemplate();
    ALLOW_UNUSED_LOCAL(instanceTemplate);
    v8::Local<v8::ObjectTemplate> prototypeTemplate = functionTemplate->PrototypeTemplate();
    ALLOW_UNUSED_LOCAL(prototypeTemplate);

    // Custom toString template
    functionTemplate->Set(v8AtomicString(isolate, "toString"), V8PerIsolateData::from(isolate)->toStringTemplate());
}

v8::Local<v8::FunctionTemplate> V8DeprecatedStorageQuota::domTemplate(v8::Isolate* isolate)
{
    return V8DOMConfiguration::domClassTemplate(isolate, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8DeprecatedStorageQuotaTemplate);
}

bool V8DeprecatedStorageQuota::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8DeprecatedStorageQuota::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

DeprecatedStorageQuota* V8DeprecatedStorageQuota::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value)
{
    return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : 0;
}

void V8DeprecatedStorageQuota::refObject(ScriptWrappable* scriptWrappable)
{
}

void V8DeprecatedStorageQuota::derefObject(ScriptWrappable* scriptWrappable)
{
}

} // namespace blink
