// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8DirectoryReaderSync.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "bindings/modules/v8/V8EntrySync.h"
#include "core/dom/ContextFeatures.h"
#include "core/dom/Document.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/TraceEvent.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8DirectoryReaderSync::wrapperTypeInfo = { gin::kEmbedderBlink, V8DirectoryReaderSync::domTemplate, V8DirectoryReaderSync::refObject, V8DirectoryReaderSync::derefObject, V8DirectoryReaderSync::trace, 0, 0, V8DirectoryReaderSync::preparePrototypeObject, V8DirectoryReaderSync::installConditionallyEnabledProperties, "DirectoryReaderSync", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent, WrapperTypeInfo::GarbageCollectedObject };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in DirectoryReaderSync.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& DirectoryReaderSync::s_wrapperTypeInfo = V8DirectoryReaderSync::wrapperTypeInfo;

namespace DirectoryReaderSyncV8Internal {

static void readEntriesMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "readEntries", "DirectoryReaderSync", info.Holder(), info.GetIsolate());
    DirectoryReaderSync* impl = V8DirectoryReaderSync::toImpl(info.Holder());
    HeapVector<Member<EntrySync>> result = impl->readEntries(exceptionState);
    if (exceptionState.hadException()) {
        exceptionState.throwIfNeeded();
        return;
    }
    v8SetReturnValue(info, toV8(result, info.Holder(), info.GetIsolate()));
}

static void readEntriesMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    DirectoryReaderSyncV8Internal::readEntriesMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

} // namespace DirectoryReaderSyncV8Internal

static const V8DOMConfiguration::MethodConfiguration V8DirectoryReaderSyncMethods[] = {
    {"readEntries", DirectoryReaderSyncV8Internal::readEntriesMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts},
};

static void installV8DirectoryReaderSyncTemplate(v8::Local<v8::FunctionTemplate> functionTemplate, v8::Isolate* isolate)
{
    functionTemplate->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "DirectoryReaderSync", v8::Local<v8::FunctionTemplate>(), V8DirectoryReaderSync::internalFieldCount,
        0, 0,
        0, 0,
        V8DirectoryReaderSyncMethods, WTF_ARRAY_LENGTH(V8DirectoryReaderSyncMethods));
    v8::Local<v8::ObjectTemplate> instanceTemplate = functionTemplate->InstanceTemplate();
    ALLOW_UNUSED_LOCAL(instanceTemplate);
    v8::Local<v8::ObjectTemplate> prototypeTemplate = functionTemplate->PrototypeTemplate();
    ALLOW_UNUSED_LOCAL(prototypeTemplate);

    // Custom toString template
    functionTemplate->Set(v8AtomicString(isolate, "toString"), V8PerIsolateData::from(isolate)->toStringTemplate());
}

v8::Local<v8::FunctionTemplate> V8DirectoryReaderSync::domTemplate(v8::Isolate* isolate)
{
    return V8DOMConfiguration::domClassTemplate(isolate, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8DirectoryReaderSyncTemplate);
}

bool V8DirectoryReaderSync::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8DirectoryReaderSync::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

DirectoryReaderSync* V8DirectoryReaderSync::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value)
{
    return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : 0;
}

void V8DirectoryReaderSync::refObject(ScriptWrappable* scriptWrappable)
{
}

void V8DirectoryReaderSync::derefObject(ScriptWrappable* scriptWrappable)
{
}

} // namespace blink
