// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8FederatedCredentialRequestOptions.h"

#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8FederatedCredentialRequestOptions::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, FederatedCredentialRequestOptions& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    v8::TryCatch block;
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> protocolsValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "protocols")).ToLocal(&protocolsValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (protocolsValue.IsEmpty() || protocolsValue->IsUndefined()) {
            // Do nothing.
        } else {
            Vector<String> protocols = toImplArray<Vector<String>>(protocolsValue, 0, isolate, exceptionState);
            if (exceptionState.hadException())
                return;
            impl.setProtocols(protocols);
        }
    }

    {
        v8::Local<v8::Value> providersValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "providers")).ToLocal(&providersValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (providersValue.IsEmpty() || providersValue->IsUndefined()) {
            // Do nothing.
        } else {
            Vector<String> providers = toImplArray<Vector<String>>(providersValue, 0, isolate, exceptionState);
            if (exceptionState.hadException())
                return;
            impl.setProviders(providers);
        }
    }

}

v8::Local<v8::Value> toV8(const FederatedCredentialRequestOptions& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8FederatedCredentialRequestOptions(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8FederatedCredentialRequestOptions(const FederatedCredentialRequestOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasProtocols()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "protocols"), toV8(impl.protocols(), creationContext, isolate))))
            return false;
    }

    if (impl.hasProviders()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "providers"), toV8(impl.providers(), creationContext, isolate))))
            return false;
    }

    return true;
}

FederatedCredentialRequestOptions NativeValueTraits<FederatedCredentialRequestOptions>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    FederatedCredentialRequestOptions impl;
    V8FederatedCredentialRequestOptions::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
