// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8GamepadEventInit.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8EventInit.h"
#include "bindings/modules/v8/V8Gamepad.h"

namespace blink {

void V8GamepadEventInit::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, GamepadEventInit& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    V8EventInit::toImpl(isolate, v8Value, impl, exceptionState);
    if (exceptionState.hadException())
        return;

    v8::TryCatch block;
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> gamepadValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "gamepad")).ToLocal(&gamepadValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (gamepadValue.IsEmpty() || gamepadValue->IsUndefined()) {
            // Do nothing.
        } else {
            Gamepad* gamepad = V8Gamepad::toImplWithTypeCheck(isolate, gamepadValue);
            if (!gamepad && !gamepadValue->IsNull()) {
                exceptionState.throwTypeError("member gamepad is not of type Gamepad.");
                return;
            }
            impl.setGamepad(gamepad);
        }
    }

}

v8::Local<v8::Value> toV8(const GamepadEventInit& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8EventInit(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    if (!toV8GamepadEventInit(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8GamepadEventInit(const GamepadEventInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasGamepad()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "gamepad"), toV8(impl.gamepad(), creationContext, isolate))))
            return false;
    }

    return true;
}

GamepadEventInit NativeValueTraits<GamepadEventInit>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    GamepadEventInit impl;
    V8GamepadEventInit::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
