// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8LocallyStoredCredentialData.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/modules/v8/V8CredentialData.h"

namespace blink {

void V8LocallyStoredCredentialData::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, LocallyStoredCredentialData& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    V8CredentialData::toImpl(isolate, v8Value, impl, exceptionState);
    if (exceptionState.hadException())
        return;

    v8::TryCatch block;
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> iconURLValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "iconURL")).ToLocal(&iconURLValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (iconURLValue.IsEmpty() || iconURLValue->IsUndefined()) {
            // Do nothing.
        } else {
            V8StringResource<> iconURL = iconURLValue;
            if (!iconURL.prepare(exceptionState))
                return;
            impl.setIconURL(iconURL);
        }
    }

    {
        v8::Local<v8::Value> nameValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "name")).ToLocal(&nameValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (nameValue.IsEmpty() || nameValue->IsUndefined()) {
            // Do nothing.
        } else {
            V8StringResource<> name = nameValue;
            if (!name.prepare(exceptionState))
                return;
            impl.setName(name);
        }
    }

}

v8::Local<v8::Value> toV8(const LocallyStoredCredentialData& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8CredentialData(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    if (!toV8LocallyStoredCredentialData(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8LocallyStoredCredentialData(const LocallyStoredCredentialData& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasIconURL()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "iconURL"), v8String(isolate, impl.iconURL()))))
            return false;
    }

    if (impl.hasName()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "name"), v8String(isolate, impl.name()))))
            return false;
    }

    return true;
}

LocallyStoredCredentialData NativeValueTraits<LocallyStoredCredentialData>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    LocallyStoredCredentialData impl;
    V8LocallyStoredCredentialData::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
