// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8MediaKeySystemAccess.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/ScriptPromise.h"
#include "bindings/core/v8/ScriptState.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "bindings/modules/v8/V8MediaKeySystemConfiguration.h"
#include "core/dom/ContextFeatures.h"
#include "core/dom/Document.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/TraceEvent.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8MediaKeySystemAccess::wrapperTypeInfo = { gin::kEmbedderBlink, V8MediaKeySystemAccess::domTemplate, V8MediaKeySystemAccess::refObject, V8MediaKeySystemAccess::derefObject, V8MediaKeySystemAccess::trace, 0, 0, V8MediaKeySystemAccess::preparePrototypeObject, V8MediaKeySystemAccess::installConditionallyEnabledProperties, "MediaKeySystemAccess", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent, WrapperTypeInfo::GarbageCollectedObject };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in MediaKeySystemAccess.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& MediaKeySystemAccess::s_wrapperTypeInfo = V8MediaKeySystemAccess::wrapperTypeInfo;

namespace MediaKeySystemAccessV8Internal {

static void keySystemAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    v8::Local<v8::Object> holder = info.Holder();
    MediaKeySystemAccess* impl = V8MediaKeySystemAccess::toImpl(holder);
    v8SetReturnValueString(info, impl->keySystem(), info.GetIsolate());
}

static void keySystemAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMGetter");
    MediaKeySystemAccessV8Internal::keySystemAttributeGetter(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getConfigurationMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    MediaKeySystemAccess* impl = V8MediaKeySystemAccess::toImpl(info.Holder());
    MediaKeySystemConfiguration result;
    impl->getConfiguration(result);
    v8SetReturnValue(info, result);
}

static void getConfigurationMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    MediaKeySystemAccessV8Internal::getConfigurationMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void createMediaKeysMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    MediaKeySystemAccess* impl = V8MediaKeySystemAccess::toImpl(info.Holder());
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptPromise result = impl->createMediaKeys(scriptState);
    v8SetReturnValue(info, result.v8Value());
}

static void createMediaKeysMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    MediaKeySystemAccessV8Internal::createMediaKeysMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

} // namespace MediaKeySystemAccessV8Internal

static const V8DOMConfiguration::AccessorConfiguration V8MediaKeySystemAccessAccessors[] = {
    {"keySystem", MediaKeySystemAccessV8Internal::keySystemAttributeGetterCallback, 0, 0, 0, 0, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

static const V8DOMConfiguration::MethodConfiguration V8MediaKeySystemAccessMethods[] = {
    {"getConfiguration", MediaKeySystemAccessV8Internal::getConfigurationMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts},
    {"createMediaKeys", MediaKeySystemAccessV8Internal::createMediaKeysMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts},
};

static void installV8MediaKeySystemAccessTemplate(v8::Local<v8::FunctionTemplate> functionTemplate, v8::Isolate* isolate)
{
    functionTemplate->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    if (!RuntimeEnabledFeatures::encryptedMediaEnabled())
        defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "MediaKeySystemAccess", v8::Local<v8::FunctionTemplate>(), V8MediaKeySystemAccess::internalFieldCount, 0, 0, 0, 0, 0, 0);
    else
        defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "MediaKeySystemAccess", v8::Local<v8::FunctionTemplate>(), V8MediaKeySystemAccess::internalFieldCount,
            0, 0,
            V8MediaKeySystemAccessAccessors, WTF_ARRAY_LENGTH(V8MediaKeySystemAccessAccessors),
            V8MediaKeySystemAccessMethods, WTF_ARRAY_LENGTH(V8MediaKeySystemAccessMethods));
    v8::Local<v8::ObjectTemplate> instanceTemplate = functionTemplate->InstanceTemplate();
    ALLOW_UNUSED_LOCAL(instanceTemplate);
    v8::Local<v8::ObjectTemplate> prototypeTemplate = functionTemplate->PrototypeTemplate();
    ALLOW_UNUSED_LOCAL(prototypeTemplate);

    // Custom toString template
    functionTemplate->Set(v8AtomicString(isolate, "toString"), V8PerIsolateData::from(isolate)->toStringTemplate());
}

v8::Local<v8::FunctionTemplate> V8MediaKeySystemAccess::domTemplate(v8::Isolate* isolate)
{
    return V8DOMConfiguration::domClassTemplate(isolate, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8MediaKeySystemAccessTemplate);
}

bool V8MediaKeySystemAccess::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8MediaKeySystemAccess::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

MediaKeySystemAccess* V8MediaKeySystemAccess::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value)
{
    return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : 0;
}

void V8MediaKeySystemAccess::refObject(ScriptWrappable* scriptWrappable)
{
}

void V8MediaKeySystemAccess::derefObject(ScriptWrappable* scriptWrappable)
{
}

} // namespace blink
