// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8NotificationEventInit.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/modules/v8/V8ExtendableEventInit.h"
#include "bindings/modules/v8/V8Notification.h"

namespace blink {

void V8NotificationEventInit::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, NotificationEventInit& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    V8ExtendableEventInit::toImpl(isolate, v8Value, impl, exceptionState);
    if (exceptionState.hadException())
        return;

    v8::TryCatch block;
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> notificationValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "notification")).ToLocal(&notificationValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (notificationValue.IsEmpty() || notificationValue->IsUndefined()) {
            // Do nothing.
        } else {
            Notification* notification = V8Notification::toImplWithTypeCheck(isolate, notificationValue);
            if (!notification && !notificationValue->IsNull()) {
                exceptionState.throwTypeError("member notification is not of type Notification.");
                return;
            }
            impl.setNotification(notification);
        }
    }

}

v8::Local<v8::Value> toV8(const NotificationEventInit& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8ExtendableEventInit(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    if (!toV8NotificationEventInit(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8NotificationEventInit(const NotificationEventInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasNotification()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "notification"), toV8(impl.notification(), creationContext, isolate))))
            return false;
    }

    return true;
}

NotificationEventInit NativeValueTraits<NotificationEventInit>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    NotificationEventInit impl;
    V8NotificationEventInit::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
