// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8PasswordCredentialData.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/modules/v8/V8LocallyStoredCredentialData.h"

namespace blink {

void V8PasswordCredentialData::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, PasswordCredentialData& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    V8LocallyStoredCredentialData::toImpl(isolate, v8Value, impl, exceptionState);
    if (exceptionState.hadException())
        return;

    v8::TryCatch block;
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> passwordValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "password")).ToLocal(&passwordValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (passwordValue.IsEmpty() || passwordValue->IsUndefined()) {
            // Do nothing.
        } else {
            V8StringResource<> password = passwordValue;
            if (!password.prepare(exceptionState))
                return;
            impl.setPassword(password);
        }
    }

}

v8::Local<v8::Value> toV8(const PasswordCredentialData& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8LocallyStoredCredentialData(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    if (!toV8PasswordCredentialData(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8PasswordCredentialData(const PasswordCredentialData& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasPassword()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "password"), v8String(isolate, impl.password()))))
            return false;
    }

    return true;
}

PasswordCredentialData NativeValueTraits<PasswordCredentialData>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    PasswordCredentialData impl;
    V8PasswordCredentialData::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
