// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8PeriodicSyncEventInit.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/modules/v8/V8ExtendableEventInit.h"
#include "bindings/modules/v8/V8PeriodicSyncRegistration.h"

namespace blink {

void V8PeriodicSyncEventInit::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, PeriodicSyncEventInit& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    V8ExtendableEventInit::toImpl(isolate, v8Value, impl, exceptionState);
    if (exceptionState.hadException())
        return;

    v8::TryCatch block;
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> registrationValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "registration")).ToLocal(&registrationValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (registrationValue.IsEmpty() || registrationValue->IsUndefined()) {
            exceptionState.throwTypeError("required member registration is undefined.");
            return;
        } else {
            PeriodicSyncRegistration* registration = V8PeriodicSyncRegistration::toImplWithTypeCheck(isolate, registrationValue);
            if (!registration && !registrationValue->IsNull()) {
                exceptionState.throwTypeError("member registration is not of type PeriodicSyncRegistration.");
                return;
            }
            impl.setRegistration(registration);
        }
    }

}

v8::Local<v8::Value> toV8(const PeriodicSyncEventInit& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8ExtendableEventInit(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    if (!toV8PeriodicSyncEventInit(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8PeriodicSyncEventInit(const PeriodicSyncEventInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasRegistration()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "registration"), toV8(impl.registration(), creationContext, isolate))))
            return false;
    } else {
        ASSERT_NOT_REACHED();
    }

    return true;
}

PeriodicSyncEventInit NativeValueTraits<PeriodicSyncEventInit>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    PeriodicSyncEventInit impl;
    V8PeriodicSyncEventInit::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
