// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8PeriodicSyncRegistration.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/ScriptPromise.h"
#include "bindings/core/v8/ScriptState.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "core/dom/ContextFeatures.h"
#include "core/dom/Document.h"
#include "core/inspector/ConsoleMessage.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/TraceEvent.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8PeriodicSyncRegistration::wrapperTypeInfo = { gin::kEmbedderBlink, V8PeriodicSyncRegistration::domTemplate, V8PeriodicSyncRegistration::refObject, V8PeriodicSyncRegistration::derefObject, V8PeriodicSyncRegistration::trace, 0, 0, V8PeriodicSyncRegistration::preparePrototypeObject, V8PeriodicSyncRegistration::installConditionallyEnabledProperties, "PeriodicSyncRegistration", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Independent, WrapperTypeInfo::GarbageCollectedObject };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in PeriodicSyncRegistration.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& PeriodicSyncRegistration::s_wrapperTypeInfo = V8PeriodicSyncRegistration::wrapperTypeInfo;

namespace PeriodicSyncRegistrationV8Internal {

static void tagAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    v8::Local<v8::Object> holder = info.Holder();
    PeriodicSyncRegistration* impl = V8PeriodicSyncRegistration::toImpl(holder);
    v8SetReturnValueString(info, impl->tag(), info.GetIsolate());
}

static void tagAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMGetter");
    PeriodicSyncRegistrationV8Internal::tagAttributeGetter(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void minPeriodAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    v8::Local<v8::Object> holder = info.Holder();
    PeriodicSyncRegistration* impl = V8PeriodicSyncRegistration::toImpl(holder);
    v8SetReturnValueUnsigned(info, impl->minPeriod());
}

static void minPeriodAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMGetter");
    PeriodicSyncRegistrationV8Internal::minPeriodAttributeGetter(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void networkStateAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    v8::Local<v8::Object> holder = info.Holder();
    PeriodicSyncRegistration* impl = V8PeriodicSyncRegistration::toImpl(holder);
    v8SetReturnValueString(info, impl->networkState(), info.GetIsolate());
}

static void networkStateAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMGetter");
    PeriodicSyncRegistrationV8Internal::networkStateAttributeGetter(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void powerStateAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    v8::Local<v8::Object> holder = info.Holder();
    PeriodicSyncRegistration* impl = V8PeriodicSyncRegistration::toImpl(holder);
    v8SetReturnValueString(info, impl->powerState(), info.GetIsolate());
}

static void powerStateAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMGetter");
    PeriodicSyncRegistrationV8Internal::powerStateAttributeGetter(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void unregisterMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    PeriodicSyncRegistration* impl = V8PeriodicSyncRegistration::toImpl(info.Holder());
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptPromise result = impl->unregister(scriptState);
    v8SetReturnValue(info, result.v8Value());
}

static void unregisterMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    PeriodicSyncRegistrationV8Internal::unregisterMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

} // namespace PeriodicSyncRegistrationV8Internal

static const V8DOMConfiguration::MethodConfiguration V8PeriodicSyncRegistrationMethods[] = {
    {"unregister", PeriodicSyncRegistrationV8Internal::unregisterMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts},
};

static void installV8PeriodicSyncRegistrationTemplate(v8::Local<v8::FunctionTemplate> functionTemplate, v8::Isolate* isolate)
{
    functionTemplate->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    if (!RuntimeEnabledFeatures::backgroundSyncEnabled())
        defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "PeriodicSyncRegistration", v8::Local<v8::FunctionTemplate>(), V8PeriodicSyncRegistration::internalFieldCount, 0, 0, 0, 0, 0, 0);
    else
        defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "PeriodicSyncRegistration", v8::Local<v8::FunctionTemplate>(), V8PeriodicSyncRegistration::internalFieldCount,
            0, 0,
            0, 0,
            V8PeriodicSyncRegistrationMethods, WTF_ARRAY_LENGTH(V8PeriodicSyncRegistrationMethods));
    v8::Local<v8::ObjectTemplate> instanceTemplate = functionTemplate->InstanceTemplate();
    ALLOW_UNUSED_LOCAL(instanceTemplate);
    v8::Local<v8::ObjectTemplate> prototypeTemplate = functionTemplate->PrototypeTemplate();
    ALLOW_UNUSED_LOCAL(prototypeTemplate);
    if (RuntimeEnabledFeatures::backgroundSyncV2Enabled()) {
        static const V8DOMConfiguration::AccessorConfiguration accessorConfiguration =\
        {"tag", PeriodicSyncRegistrationV8Internal::tagAttributeGetterCallback, 0, 0, 0, 0, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder};
        V8DOMConfiguration::installAccessor(isolate, instanceTemplate, prototypeTemplate, functionTemplate, defaultSignature, accessorConfiguration);
    }
    if (RuntimeEnabledFeatures::backgroundSyncV2Enabled()) {
        static const V8DOMConfiguration::AccessorConfiguration accessorConfiguration =\
        {"minPeriod", PeriodicSyncRegistrationV8Internal::minPeriodAttributeGetterCallback, 0, 0, 0, 0, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder};
        V8DOMConfiguration::installAccessor(isolate, instanceTemplate, prototypeTemplate, functionTemplate, defaultSignature, accessorConfiguration);
    }
    if (RuntimeEnabledFeatures::backgroundSyncV2Enabled()) {
        static const V8DOMConfiguration::AccessorConfiguration accessorConfiguration =\
        {"networkState", PeriodicSyncRegistrationV8Internal::networkStateAttributeGetterCallback, 0, 0, 0, 0, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder};
        V8DOMConfiguration::installAccessor(isolate, instanceTemplate, prototypeTemplate, functionTemplate, defaultSignature, accessorConfiguration);
    }
    if (RuntimeEnabledFeatures::backgroundSyncV2Enabled()) {
        static const V8DOMConfiguration::AccessorConfiguration accessorConfiguration =\
        {"powerState", PeriodicSyncRegistrationV8Internal::powerStateAttributeGetterCallback, 0, 0, 0, 0, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder};
        V8DOMConfiguration::installAccessor(isolate, instanceTemplate, prototypeTemplate, functionTemplate, defaultSignature, accessorConfiguration);
    }

    // Custom toString template
    functionTemplate->Set(v8AtomicString(isolate, "toString"), V8PerIsolateData::from(isolate)->toStringTemplate());
}

v8::Local<v8::FunctionTemplate> V8PeriodicSyncRegistration::domTemplate(v8::Isolate* isolate)
{
    return V8DOMConfiguration::domClassTemplate(isolate, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8PeriodicSyncRegistrationTemplate);
}

bool V8PeriodicSyncRegistration::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8PeriodicSyncRegistration::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

PeriodicSyncRegistration* V8PeriodicSyncRegistration::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value)
{
    return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : 0;
}

void V8PeriodicSyncRegistration::refObject(ScriptWrappable* scriptWrappable)
{
}

void V8PeriodicSyncRegistration::derefObject(ScriptWrappable* scriptWrappable)
{
}

} // namespace blink
