// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8RTCIceCandidateInit.h"

#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8RTCIceCandidateInit::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, RTCIceCandidateInit& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    v8::TryCatch block;
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> candidateValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "candidate")).ToLocal(&candidateValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (candidateValue.IsEmpty() || candidateValue->IsUndefined()) {
            // Do nothing.
        } else {
            V8StringResource<> candidate = candidateValue;
            if (!candidate.prepare(exceptionState))
                return;
            impl.setCandidate(candidate);
        }
    }

    {
        v8::Local<v8::Value> sdpMLineIndexValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "sdpMLineIndex")).ToLocal(&sdpMLineIndexValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (sdpMLineIndexValue.IsEmpty() || sdpMLineIndexValue->IsUndefined()) {
            // Do nothing.
        } else {
            unsigned sdpMLineIndex = toUInt16(isolate, sdpMLineIndexValue, NormalConversion, exceptionState);
            if (exceptionState.hadException())
                return;
            impl.setSdpMLineIndex(sdpMLineIndex);
        }
    }

    {
        v8::Local<v8::Value> sdpMidValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "sdpMid")).ToLocal(&sdpMidValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (sdpMidValue.IsEmpty() || sdpMidValue->IsUndefined()) {
            // Do nothing.
        } else {
            V8StringResource<> sdpMid = sdpMidValue;
            if (!sdpMid.prepare(exceptionState))
                return;
            impl.setSdpMid(sdpMid);
        }
    }

}

v8::Local<v8::Value> toV8(const RTCIceCandidateInit& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8RTCIceCandidateInit(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8RTCIceCandidateInit(const RTCIceCandidateInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasCandidate()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "candidate"), v8String(isolate, impl.candidate()))))
            return false;
    }

    if (impl.hasSdpMLineIndex()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "sdpMLineIndex"), v8::Integer::NewFromUnsigned(isolate, impl.sdpMLineIndex()))))
            return false;
    }

    if (impl.hasSdpMid()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "sdpMid"), v8String(isolate, impl.sdpMid()))))
            return false;
    }

    return true;
}

RTCIceCandidateInit NativeValueTraits<RTCIceCandidateInit>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    RTCIceCandidateInit impl;
    V8RTCIceCandidateInit::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
