// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8RegistrationOptions.h"

#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8RegistrationOptions::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, RegistrationOptions& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    v8::TryCatch block;
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> scopeValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "scope")).ToLocal(&scopeValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (scopeValue.IsEmpty() || scopeValue->IsUndefined()) {
            // Do nothing.
        } else {
            V8StringResource<> scope = toUSVString(isolate, scopeValue, exceptionState);
            if (exceptionState.hadException())
                return;
            impl.setScope(scope);
        }
    }

}

v8::Local<v8::Value> toV8(const RegistrationOptions& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8RegistrationOptions(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8RegistrationOptions(const RegistrationOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasScope()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "scope"), v8String(isolate, impl.scope()))))
            return false;
    }

    return true;
}

RegistrationOptions NativeValueTraits<RegistrationOptions>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    RegistrationOptions impl;
    V8RegistrationOptions::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
