// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8ServicePortConnectResponse.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/ScriptValue.h"

namespace blink {

void V8ServicePortConnectResponse::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, ServicePortConnectResponse& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    v8::TryCatch block;
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> acceptValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "accept")).ToLocal(&acceptValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (acceptValue.IsEmpty() || acceptValue->IsUndefined()) {
            // Do nothing.
        } else {
            bool accept = toBoolean(isolate, acceptValue, exceptionState);
            if (exceptionState.hadException())
                return;
            impl.setAccept(accept);
        }
    }

    {
        v8::Local<v8::Value> dataValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "data")).ToLocal(&dataValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (dataValue.IsEmpty() || dataValue->IsUndefined()) {
            // Do nothing.
        } else {
            ScriptValue data = ScriptValue(ScriptState::current(isolate), dataValue);
            impl.setData(data);
        }
    }

    {
        v8::Local<v8::Value> nameValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "name")).ToLocal(&nameValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (nameValue.IsEmpty() || nameValue->IsUndefined()) {
            // Do nothing.
        } else {
            V8StringResource<> name = nameValue;
            if (!name.prepare(exceptionState))
                return;
            impl.setName(name);
        }
    }

}

v8::Local<v8::Value> toV8(const ServicePortConnectResponse& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8ServicePortConnectResponse(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8ServicePortConnectResponse(const ServicePortConnectResponse& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasAccept()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "accept"), v8Boolean(impl.accept(), isolate))))
            return false;
    }

    if (impl.hasData()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "data"), impl.data().v8Value())))
            return false;
    }

    if (impl.hasName()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "name"), v8String(isolate, impl.name()))))
            return false;
    }

    return true;
}

ServicePortConnectResponse NativeValueTraits<ServicePortConnectResponse>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    ServicePortConnectResponse impl;
    V8ServicePortConnectResponse::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
