// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8SpeechRecognitionErrorInit.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8EventInit.h"

namespace blink {

void V8SpeechRecognitionErrorInit::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, SpeechRecognitionErrorInit& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    V8EventInit::toImpl(isolate, v8Value, impl, exceptionState);
    if (exceptionState.hadException())
        return;

    v8::TryCatch block;
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> errorValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "error")).ToLocal(&errorValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (errorValue.IsEmpty() || errorValue->IsUndefined()) {
            // Do nothing.
        } else {
            V8StringResource<> error = errorValue;
            if (!error.prepare(exceptionState))
                return;
            impl.setError(error);
        }
    }

    {
        v8::Local<v8::Value> messageValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "message")).ToLocal(&messageValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (messageValue.IsEmpty() || messageValue->IsUndefined()) {
            // Do nothing.
        } else {
            V8StringResource<> message = messageValue;
            if (!message.prepare(exceptionState))
                return;
            impl.setMessage(message);
        }
    }

}

v8::Local<v8::Value> toV8(const SpeechRecognitionErrorInit& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8EventInit(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    if (!toV8SpeechRecognitionErrorInit(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8SpeechRecognitionErrorInit(const SpeechRecognitionErrorInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasError()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "error"), v8String(isolate, impl.error()))))
            return false;
    }

    if (impl.hasMessage()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "message"), v8String(isolate, impl.message()))))
            return false;
    }

    return true;
}

SpeechRecognitionErrorInit NativeValueTraits<SpeechRecognitionErrorInit>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    SpeechRecognitionErrorInit impl;
    V8SpeechRecognitionErrorInit::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
