// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8TextDecoderOptions.h"

#include "bindings/core/v8/ExceptionState.h"

namespace blink {

void V8TextDecoderOptions::toImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, TextDecoderOptions& impl, ExceptionState& exceptionState)
{
    if (isUndefinedOrNull(v8Value))
        return;
    if (!v8Value->IsObject()) {
        exceptionState.throwTypeError("cannot convert to dictionary.");
        return;
    }

    v8::TryCatch block;
    v8::Local<v8::Object> v8Object;
    if (!v8Call(v8Value->ToObject(isolate->GetCurrentContext()), v8Object, block)) {
        exceptionState.rethrowV8Exception(block.Exception());
        return;
    }
    {
        v8::Local<v8::Value> fatalValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "fatal")).ToLocal(&fatalValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (fatalValue.IsEmpty() || fatalValue->IsUndefined()) {
            // Do nothing.
        } else {
            bool fatal = toBoolean(isolate, fatalValue, exceptionState);
            if (exceptionState.hadException())
                return;
            impl.setFatal(fatal);
        }
    }

    {
        v8::Local<v8::Value> ignoreBOMValue;
        if (!v8Object->Get(isolate->GetCurrentContext(), v8String(isolate, "ignoreBOM")).ToLocal(&ignoreBOMValue)) {
            exceptionState.rethrowV8Exception(block.Exception());
            return;
        }
        if (ignoreBOMValue.IsEmpty() || ignoreBOMValue->IsUndefined()) {
            // Do nothing.
        } else {
            bool ignoreBOM = toBoolean(isolate, ignoreBOMValue, exceptionState);
            if (exceptionState.hadException())
                return;
            impl.setIgnoreBOM(ignoreBOM);
        }
    }

}

v8::Local<v8::Value> toV8(const TextDecoderOptions& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
    if (!toV8TextDecoderOptions(impl, v8Object, creationContext, isolate))
        return v8::Local<v8::Value>();
    return v8Object;
}

bool toV8TextDecoderOptions(const TextDecoderOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate)
{
    if (impl.hasFatal()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "fatal"), v8Boolean(impl.fatal(), isolate))))
            return false;
    } else {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "fatal"), v8Boolean(false, isolate))))
            return false;
    }

    if (impl.hasIgnoreBOM()) {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "ignoreBOM"), v8Boolean(impl.ignoreBOM(), isolate))))
            return false;
    } else {
        if (!v8CallBoolean(dictionary->CreateDataProperty(isolate->GetCurrentContext(), v8String(isolate, "ignoreBOM"), v8Boolean(false, isolate))))
            return false;
    }

    return true;
}

TextDecoderOptions NativeValueTraits<TextDecoderOptions>::nativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState)
{
    TextDecoderOptions impl;
    V8TextDecoderOptions::toImpl(isolate, value, impl, exceptionState);
    return impl;
}

} // namespace blink
