// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8WebGLDebugShaders.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8GCController.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "bindings/modules/v8/V8WebGLShader.h"
#include "core/dom/ContextFeatures.h"
#include "core/dom/Document.h"
#include "core/dom/Element.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/TraceEvent.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8WebGLDebugShaders::wrapperTypeInfo = { gin::kEmbedderBlink, V8WebGLDebugShaders::domTemplate, V8WebGLDebugShaders::refObject, V8WebGLDebugShaders::derefObject, V8WebGLDebugShaders::trace, 0, V8WebGLDebugShaders::visitDOMWrapper, V8WebGLDebugShaders::preparePrototypeObject, V8WebGLDebugShaders::installConditionallyEnabledProperties, "WebGLDebugShaders", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Dependent, WrapperTypeInfo::WillBeGarbageCollectedObject };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in WebGLDebugShaders.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& WebGLDebugShaders::s_wrapperTypeInfo = V8WebGLDebugShaders::wrapperTypeInfo;

namespace WebGLDebugShadersV8Internal {

static void getTranslatedShaderSourceMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "getTranslatedShaderSource", "WebGLDebugShaders", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGLDebugShaders* impl = V8WebGLDebugShaders::toImpl(info.Holder());
    WebGLShader* shader;
    {
        shader = V8WebGLShader::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!shader && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getTranslatedShaderSource", "WebGLDebugShaders", "parameter 1 is not of type 'WebGLShader'."));
            return;
        }
    }
    v8SetReturnValueStringOrNull(info, impl->getTranslatedShaderSource(shader), info.GetIsolate());
}

static void getTranslatedShaderSourceMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGLDebugShadersV8Internal::getTranslatedShaderSourceMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

} // namespace WebGLDebugShadersV8Internal

void V8WebGLDebugShaders::visitDOMWrapper(v8::Isolate* isolate, ScriptWrappable* scriptWrappable, const v8::Persistent<v8::Object>& wrapper)
{
    WebGLDebugShaders* impl = scriptWrappable->toImpl<WebGLDebugShaders>();
    // The canvas() method may return a reference or a pointer.
    if (Node* owner = WTF::getPtr(impl->canvas())) {
        Node* root = V8GCController::opaqueRootForGC(isolate, owner);
        isolate->SetReferenceFromGroup(v8::UniqueId(reinterpret_cast<intptr_t>(root)), wrapper);
        return;
    }
}

static const V8DOMConfiguration::MethodConfiguration V8WebGLDebugShadersMethods[] = {
    {"getTranslatedShaderSource", WebGLDebugShadersV8Internal::getTranslatedShaderSourceMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
};

static void installV8WebGLDebugShadersTemplate(v8::Local<v8::FunctionTemplate> functionTemplate, v8::Isolate* isolate)
{
    functionTemplate->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "WebGLDebugShaders", v8::Local<v8::FunctionTemplate>(), V8WebGLDebugShaders::internalFieldCount,
        0, 0,
        0, 0,
        V8WebGLDebugShadersMethods, WTF_ARRAY_LENGTH(V8WebGLDebugShadersMethods));
    v8::Local<v8::ObjectTemplate> instanceTemplate = functionTemplate->InstanceTemplate();
    ALLOW_UNUSED_LOCAL(instanceTemplate);
    v8::Local<v8::ObjectTemplate> prototypeTemplate = functionTemplate->PrototypeTemplate();
    ALLOW_UNUSED_LOCAL(prototypeTemplate);

    // Custom toString template
    functionTemplate->Set(v8AtomicString(isolate, "toString"), V8PerIsolateData::from(isolate)->toStringTemplate());
}

v8::Local<v8::FunctionTemplate> V8WebGLDebugShaders::domTemplate(v8::Isolate* isolate)
{
    return V8DOMConfiguration::domClassTemplate(isolate, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8WebGLDebugShadersTemplate);
}

bool V8WebGLDebugShaders::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8WebGLDebugShaders::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

WebGLDebugShaders* V8WebGLDebugShaders::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value)
{
    return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : 0;
}

void V8WebGLDebugShaders::refObject(ScriptWrappable* scriptWrappable)
{
#if !ENABLE(OILPAN)
    scriptWrappable->toImpl<WebGLDebugShaders>()->ref();
#endif
}

void V8WebGLDebugShaders::derefObject(ScriptWrappable* scriptWrappable)
{
#if !ENABLE(OILPAN)
    scriptWrappable->toImpl<WebGLDebugShaders>()->deref();
#endif
}

} // namespace blink
