// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "content/common/background_sync_service.mojom.h"

#include <math.h>

#include "mojo/public/cpp/bindings/lib/array_serialization.h"
#include "mojo/public/cpp/bindings/lib/bindings_serialization.h"
#include "mojo/public/cpp/bindings/lib/bounds_checker.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/map_serialization.h"
#include "mojo/public/cpp/bindings/lib/message_builder.h"
#include "mojo/public/cpp/bindings/lib/string_serialization.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "mojo/public/cpp/environment/lib/scoped_task_tracking.h"
#include "mojo/public/cpp/environment/logging.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
namespace content {

namespace internal {
namespace {

#pragma pack(push, 1)
const uint32_t kBackgroundSyncService_Register_Name = 0;

class BackgroundSyncService_Register_Params_Data {
 public:
  static BackgroundSyncService_Register_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  mojo::internal::StructPointer<content::internal::SyncRegistration_Data> options;
  int64_t service_worker_registration_id;

 private:
  BackgroundSyncService_Register_Params_Data();
  ~BackgroundSyncService_Register_Params_Data() = delete;
};
static_assert(sizeof(BackgroundSyncService_Register_Params_Data) == 24,
              "Bad sizeof(BackgroundSyncService_Register_Params_Data)");


// static
BackgroundSyncService_Register_Params_Data* BackgroundSyncService_Register_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(BackgroundSyncService_Register_Params_Data))) BackgroundSyncService_Register_Params_Data();
}

// static
bool BackgroundSyncService_Register_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const BackgroundSyncService_Register_Params_Data* object = static_cast<const BackgroundSyncService_Register_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!object->options.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null options field in BackgroundSyncService_Register_Params struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->options.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  if (!content::SyncRegistration::Data_::Validate(
          mojo::internal::DecodePointerRaw(&object->options.offset),
          bounds_checker)) {
    return false;
  }

  return true;
}

void BackgroundSyncService_Register_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&options, handles);
}

void BackgroundSyncService_Register_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&options, handles);
}

BackgroundSyncService_Register_Params_Data::BackgroundSyncService_Register_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

class BackgroundSyncService_Register_ResponseParams_Data {
 public:
  static BackgroundSyncService_Register_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  int32_t err;
  uint8_t pad0_[4];
  mojo::internal::StructPointer<content::internal::SyncRegistration_Data> options;

 private:
  BackgroundSyncService_Register_ResponseParams_Data();
  ~BackgroundSyncService_Register_ResponseParams_Data() = delete;
};
static_assert(sizeof(BackgroundSyncService_Register_ResponseParams_Data) == 24,
              "Bad sizeof(BackgroundSyncService_Register_ResponseParams_Data)");


// static
BackgroundSyncService_Register_ResponseParams_Data* BackgroundSyncService_Register_ResponseParams_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(BackgroundSyncService_Register_ResponseParams_Data))) BackgroundSyncService_Register_ResponseParams_Data();
}

// static
bool BackgroundSyncService_Register_ResponseParams_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const BackgroundSyncService_Register_ResponseParams_Data* object = static_cast<const BackgroundSyncService_Register_ResponseParams_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!object->options.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null options field in BackgroundSyncService_Register_ResponseParams struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->options.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  if (!content::SyncRegistration::Data_::Validate(
          mojo::internal::DecodePointerRaw(&object->options.offset),
          bounds_checker)) {
    return false;
  }

  return true;
}

void BackgroundSyncService_Register_ResponseParams_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&options, handles);
}

void BackgroundSyncService_Register_ResponseParams_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&options, handles);
}

BackgroundSyncService_Register_ResponseParams_Data::BackgroundSyncService_Register_ResponseParams_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kBackgroundSyncService_GetRegistration_Name = 1;

class BackgroundSyncService_GetRegistration_Params_Data {
 public:
  static BackgroundSyncService_GetRegistration_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  int32_t periodicity;
  uint8_t pad0_[4];
  mojo::internal::StringPointer tag;
  int64_t service_worker_registration_id;

 private:
  BackgroundSyncService_GetRegistration_Params_Data();
  ~BackgroundSyncService_GetRegistration_Params_Data() = delete;
};
static_assert(sizeof(BackgroundSyncService_GetRegistration_Params_Data) == 32,
              "Bad sizeof(BackgroundSyncService_GetRegistration_Params_Data)");


// static
BackgroundSyncService_GetRegistration_Params_Data* BackgroundSyncService_GetRegistration_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(BackgroundSyncService_GetRegistration_Params_Data))) BackgroundSyncService_GetRegistration_Params_Data();
}

// static
bool BackgroundSyncService_GetRegistration_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const BackgroundSyncService_GetRegistration_Params_Data* object = static_cast<const BackgroundSyncService_GetRegistration_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 32 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!object->tag.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null tag field in BackgroundSyncService_GetRegistration_Params struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->tag.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams tag_validate_params(
      0, false, nullptr);
  if (!mojo::String::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->tag.offset),
              bounds_checker, &tag_validate_params)) {
    return false;
  }

  return true;
}

void BackgroundSyncService_GetRegistration_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&tag, handles);
}

void BackgroundSyncService_GetRegistration_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&tag, handles);
}

BackgroundSyncService_GetRegistration_Params_Data::BackgroundSyncService_GetRegistration_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

class BackgroundSyncService_GetRegistration_ResponseParams_Data {
 public:
  static BackgroundSyncService_GetRegistration_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  int32_t err;
  uint8_t pad0_[4];
  mojo::internal::StructPointer<content::internal::SyncRegistration_Data> registration;

 private:
  BackgroundSyncService_GetRegistration_ResponseParams_Data();
  ~BackgroundSyncService_GetRegistration_ResponseParams_Data() = delete;
};
static_assert(sizeof(BackgroundSyncService_GetRegistration_ResponseParams_Data) == 24,
              "Bad sizeof(BackgroundSyncService_GetRegistration_ResponseParams_Data)");


// static
BackgroundSyncService_GetRegistration_ResponseParams_Data* BackgroundSyncService_GetRegistration_ResponseParams_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(BackgroundSyncService_GetRegistration_ResponseParams_Data))) BackgroundSyncService_GetRegistration_ResponseParams_Data();
}

// static
bool BackgroundSyncService_GetRegistration_ResponseParams_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const BackgroundSyncService_GetRegistration_ResponseParams_Data* object = static_cast<const BackgroundSyncService_GetRegistration_ResponseParams_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidateEncodedPointer(&object->registration.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  if (!content::SyncRegistration::Data_::Validate(
          mojo::internal::DecodePointerRaw(&object->registration.offset),
          bounds_checker)) {
    return false;
  }

  return true;
}

void BackgroundSyncService_GetRegistration_ResponseParams_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&registration, handles);
}

void BackgroundSyncService_GetRegistration_ResponseParams_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&registration, handles);
}

BackgroundSyncService_GetRegistration_ResponseParams_Data::BackgroundSyncService_GetRegistration_ResponseParams_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kBackgroundSyncService_GetRegistrations_Name = 2;

class BackgroundSyncService_GetRegistrations_Params_Data {
 public:
  static BackgroundSyncService_GetRegistrations_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  int32_t periodicity;
  uint8_t pad0_[4];
  int64_t service_worker_registration_id;

 private:
  BackgroundSyncService_GetRegistrations_Params_Data();
  ~BackgroundSyncService_GetRegistrations_Params_Data() = delete;
};
static_assert(sizeof(BackgroundSyncService_GetRegistrations_Params_Data) == 24,
              "Bad sizeof(BackgroundSyncService_GetRegistrations_Params_Data)");


// static
BackgroundSyncService_GetRegistrations_Params_Data* BackgroundSyncService_GetRegistrations_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(BackgroundSyncService_GetRegistrations_Params_Data))) BackgroundSyncService_GetRegistrations_Params_Data();
}

// static
bool BackgroundSyncService_GetRegistrations_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const BackgroundSyncService_GetRegistrations_Params_Data* object = static_cast<const BackgroundSyncService_GetRegistrations_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void BackgroundSyncService_GetRegistrations_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
}

void BackgroundSyncService_GetRegistrations_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
}

BackgroundSyncService_GetRegistrations_Params_Data::BackgroundSyncService_GetRegistrations_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

class BackgroundSyncService_GetRegistrations_ResponseParams_Data {
 public:
  static BackgroundSyncService_GetRegistrations_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  int32_t err;
  uint8_t pad0_[4];
  mojo::internal::ArrayPointer<content::internal::SyncRegistration_Data*> registrations;

 private:
  BackgroundSyncService_GetRegistrations_ResponseParams_Data();
  ~BackgroundSyncService_GetRegistrations_ResponseParams_Data() = delete;
};
static_assert(sizeof(BackgroundSyncService_GetRegistrations_ResponseParams_Data) == 24,
              "Bad sizeof(BackgroundSyncService_GetRegistrations_ResponseParams_Data)");


// static
BackgroundSyncService_GetRegistrations_ResponseParams_Data* BackgroundSyncService_GetRegistrations_ResponseParams_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(BackgroundSyncService_GetRegistrations_ResponseParams_Data))) BackgroundSyncService_GetRegistrations_ResponseParams_Data();
}

// static
bool BackgroundSyncService_GetRegistrations_ResponseParams_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const BackgroundSyncService_GetRegistrations_ResponseParams_Data* object = static_cast<const BackgroundSyncService_GetRegistrations_ResponseParams_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!object->registrations.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null registrations field in BackgroundSyncService_GetRegistrations_ResponseParams struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->registrations.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams registrations_validate_params(
      0, false, nullptr);
  if (!mojo::Array<content::SyncRegistrationPtr>::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->registrations.offset),
              bounds_checker, &registrations_validate_params)) {
    return false;
  }

  return true;
}

void BackgroundSyncService_GetRegistrations_ResponseParams_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&registrations, handles);
}

void BackgroundSyncService_GetRegistrations_ResponseParams_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&registrations, handles);
}

BackgroundSyncService_GetRegistrations_ResponseParams_Data::BackgroundSyncService_GetRegistrations_ResponseParams_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kBackgroundSyncService_Unregister_Name = 3;

class BackgroundSyncService_Unregister_Params_Data {
 public:
  static BackgroundSyncService_Unregister_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  int32_t periodicity;
  uint8_t pad0_[4];
  int64_t id;
  mojo::internal::StringPointer tag;
  int64_t service_worker_registration_id;

 private:
  BackgroundSyncService_Unregister_Params_Data();
  ~BackgroundSyncService_Unregister_Params_Data() = delete;
};
static_assert(sizeof(BackgroundSyncService_Unregister_Params_Data) == 40,
              "Bad sizeof(BackgroundSyncService_Unregister_Params_Data)");


// static
BackgroundSyncService_Unregister_Params_Data* BackgroundSyncService_Unregister_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(BackgroundSyncService_Unregister_Params_Data))) BackgroundSyncService_Unregister_Params_Data();
}

// static
bool BackgroundSyncService_Unregister_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const BackgroundSyncService_Unregister_Params_Data* object = static_cast<const BackgroundSyncService_Unregister_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 40 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!object->tag.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null tag field in BackgroundSyncService_Unregister_Params struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->tag.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams tag_validate_params(
      0, false, nullptr);
  if (!mojo::String::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->tag.offset),
              bounds_checker, &tag_validate_params)) {
    return false;
  }

  return true;
}

void BackgroundSyncService_Unregister_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&tag, handles);
}

void BackgroundSyncService_Unregister_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&tag, handles);
}

BackgroundSyncService_Unregister_Params_Data::BackgroundSyncService_Unregister_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

class BackgroundSyncService_Unregister_ResponseParams_Data {
 public:
  static BackgroundSyncService_Unregister_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  int32_t err;
  uint8_t padfinal_[4];

 private:
  BackgroundSyncService_Unregister_ResponseParams_Data();
  ~BackgroundSyncService_Unregister_ResponseParams_Data() = delete;
};
static_assert(sizeof(BackgroundSyncService_Unregister_ResponseParams_Data) == 16,
              "Bad sizeof(BackgroundSyncService_Unregister_ResponseParams_Data)");


// static
BackgroundSyncService_Unregister_ResponseParams_Data* BackgroundSyncService_Unregister_ResponseParams_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(BackgroundSyncService_Unregister_ResponseParams_Data))) BackgroundSyncService_Unregister_ResponseParams_Data();
}

// static
bool BackgroundSyncService_Unregister_ResponseParams_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const BackgroundSyncService_Unregister_ResponseParams_Data* object = static_cast<const BackgroundSyncService_Unregister_ResponseParams_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void BackgroundSyncService_Unregister_ResponseParams_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
}

void BackgroundSyncService_Unregister_ResponseParams_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
}

BackgroundSyncService_Unregister_ResponseParams_Data::BackgroundSyncService_Unregister_ResponseParams_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kBackgroundSyncService_GetPermissionStatus_Name = 4;

class BackgroundSyncService_GetPermissionStatus_Params_Data {
 public:
  static BackgroundSyncService_GetPermissionStatus_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  int32_t periodicity;
  uint8_t pad0_[4];
  int64_t service_worker_registration_id;

 private:
  BackgroundSyncService_GetPermissionStatus_Params_Data();
  ~BackgroundSyncService_GetPermissionStatus_Params_Data() = delete;
};
static_assert(sizeof(BackgroundSyncService_GetPermissionStatus_Params_Data) == 24,
              "Bad sizeof(BackgroundSyncService_GetPermissionStatus_Params_Data)");


// static
BackgroundSyncService_GetPermissionStatus_Params_Data* BackgroundSyncService_GetPermissionStatus_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(BackgroundSyncService_GetPermissionStatus_Params_Data))) BackgroundSyncService_GetPermissionStatus_Params_Data();
}

// static
bool BackgroundSyncService_GetPermissionStatus_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const BackgroundSyncService_GetPermissionStatus_Params_Data* object = static_cast<const BackgroundSyncService_GetPermissionStatus_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void BackgroundSyncService_GetPermissionStatus_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
}

void BackgroundSyncService_GetPermissionStatus_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
}

BackgroundSyncService_GetPermissionStatus_Params_Data::BackgroundSyncService_GetPermissionStatus_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

class BackgroundSyncService_GetPermissionStatus_ResponseParams_Data {
 public:
  static BackgroundSyncService_GetPermissionStatus_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  int32_t err;
  int32_t status;

 private:
  BackgroundSyncService_GetPermissionStatus_ResponseParams_Data();
  ~BackgroundSyncService_GetPermissionStatus_ResponseParams_Data() = delete;
};
static_assert(sizeof(BackgroundSyncService_GetPermissionStatus_ResponseParams_Data) == 16,
              "Bad sizeof(BackgroundSyncService_GetPermissionStatus_ResponseParams_Data)");


// static
BackgroundSyncService_GetPermissionStatus_ResponseParams_Data* BackgroundSyncService_GetPermissionStatus_ResponseParams_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(BackgroundSyncService_GetPermissionStatus_ResponseParams_Data))) BackgroundSyncService_GetPermissionStatus_ResponseParams_Data();
}

// static
bool BackgroundSyncService_GetPermissionStatus_ResponseParams_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const BackgroundSyncService_GetPermissionStatus_ResponseParams_Data* object = static_cast<const BackgroundSyncService_GetPermissionStatus_ResponseParams_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void BackgroundSyncService_GetPermissionStatus_ResponseParams_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
}

void BackgroundSyncService_GetPermissionStatus_ResponseParams_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
}

BackgroundSyncService_GetPermissionStatus_ResponseParams_Data::BackgroundSyncService_GetPermissionStatus_ResponseParams_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kBackgoundSyncServiceClient_Sync_Name = 0;

class BackgoundSyncServiceClient_Sync_Params_Data {
 public:
  static BackgoundSyncServiceClient_Sync_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  mojo::internal::StructPointer<content::internal::SyncRegistration_Data> event;

 private:
  BackgoundSyncServiceClient_Sync_Params_Data();
  ~BackgoundSyncServiceClient_Sync_Params_Data() = delete;
};
static_assert(sizeof(BackgoundSyncServiceClient_Sync_Params_Data) == 16,
              "Bad sizeof(BackgoundSyncServiceClient_Sync_Params_Data)");


// static
BackgoundSyncServiceClient_Sync_Params_Data* BackgoundSyncServiceClient_Sync_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(BackgoundSyncServiceClient_Sync_Params_Data))) BackgoundSyncServiceClient_Sync_Params_Data();
}

// static
bool BackgoundSyncServiceClient_Sync_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const BackgoundSyncServiceClient_Sync_Params_Data* object = static_cast<const BackgoundSyncServiceClient_Sync_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!object->event.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null event field in BackgoundSyncServiceClient_Sync_Params struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->event.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  if (!content::SyncRegistration::Data_::Validate(
          mojo::internal::DecodePointerRaw(&object->event.offset),
          bounds_checker)) {
    return false;
  }

  return true;
}

void BackgoundSyncServiceClient_Sync_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&event, handles);
}

void BackgoundSyncServiceClient_Sync_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&event, handles);
}

BackgoundSyncServiceClient_Sync_Params_Data::BackgoundSyncServiceClient_Sync_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}


#pragma pack(pop)

}  // namespace



}  // namespace internal
MOJO_STATIC_CONST_MEMBER_DEFINITION const char BackgroundSyncService::Name_[] = "content::BackgroundSyncService";
MOJO_STATIC_CONST_MEMBER_DEFINITION const uint32_t BackgroundSyncService::Version_;
class BackgroundSyncService_Register_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  BackgroundSyncService_Register_ForwardToCallback(
      const BackgroundSyncService::RegisterCallback& callback)
      : callback_(callback) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  BackgroundSyncService::RegisterCallback callback_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(BackgroundSyncService_Register_ForwardToCallback);
};
bool BackgroundSyncService_Register_ForwardToCallback::Accept(
    mojo::Message* message) {
  internal::BackgroundSyncService_Register_ResponseParams_Data* params =
      reinterpret_cast<internal::BackgroundSyncService_Register_ResponseParams_Data*>(
          message->mutable_payload());

  params->DecodePointersAndHandles(message->mutable_handles());
  
  BackgroundSyncError p_err{};
  content::SyncRegistrationPtr p_options{};
  do {
    // NOTE: The memory backing |params| may has be smaller than
    // |sizeof(*params)| if the message comes from an older version.
    p_err = static_cast<BackgroundSyncError>(params->err);
    Deserialize_(params->options.ptr, &p_options);
  } while (false);
  callback_.Run(p_err, p_options.Pass());
  return true;
}
class BackgroundSyncService_GetRegistration_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  BackgroundSyncService_GetRegistration_ForwardToCallback(
      const BackgroundSyncService::GetRegistrationCallback& callback)
      : callback_(callback) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  BackgroundSyncService::GetRegistrationCallback callback_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(BackgroundSyncService_GetRegistration_ForwardToCallback);
};
bool BackgroundSyncService_GetRegistration_ForwardToCallback::Accept(
    mojo::Message* message) {
  internal::BackgroundSyncService_GetRegistration_ResponseParams_Data* params =
      reinterpret_cast<internal::BackgroundSyncService_GetRegistration_ResponseParams_Data*>(
          message->mutable_payload());

  params->DecodePointersAndHandles(message->mutable_handles());
  
  BackgroundSyncError p_err{};
  content::SyncRegistrationPtr p_registration{};
  do {
    // NOTE: The memory backing |params| may has be smaller than
    // |sizeof(*params)| if the message comes from an older version.
    p_err = static_cast<BackgroundSyncError>(params->err);
    Deserialize_(params->registration.ptr, &p_registration);
  } while (false);
  callback_.Run(p_err, p_registration.Pass());
  return true;
}
class BackgroundSyncService_GetRegistrations_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  BackgroundSyncService_GetRegistrations_ForwardToCallback(
      const BackgroundSyncService::GetRegistrationsCallback& callback)
      : callback_(callback) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  BackgroundSyncService::GetRegistrationsCallback callback_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(BackgroundSyncService_GetRegistrations_ForwardToCallback);
};
bool BackgroundSyncService_GetRegistrations_ForwardToCallback::Accept(
    mojo::Message* message) {
  internal::BackgroundSyncService_GetRegistrations_ResponseParams_Data* params =
      reinterpret_cast<internal::BackgroundSyncService_GetRegistrations_ResponseParams_Data*>(
          message->mutable_payload());

  params->DecodePointersAndHandles(message->mutable_handles());
  
  BackgroundSyncError p_err{};
  mojo::Array<content::SyncRegistrationPtr> p_registrations{};
  do {
    // NOTE: The memory backing |params| may has be smaller than
    // |sizeof(*params)| if the message comes from an older version.
    p_err = static_cast<BackgroundSyncError>(params->err);
    Deserialize_(params->registrations.ptr, &p_registrations);
  } while (false);
  callback_.Run(p_err, p_registrations.Pass());
  return true;
}
class BackgroundSyncService_Unregister_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  BackgroundSyncService_Unregister_ForwardToCallback(
      const BackgroundSyncService::UnregisterCallback& callback)
      : callback_(callback) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  BackgroundSyncService::UnregisterCallback callback_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(BackgroundSyncService_Unregister_ForwardToCallback);
};
bool BackgroundSyncService_Unregister_ForwardToCallback::Accept(
    mojo::Message* message) {
  internal::BackgroundSyncService_Unregister_ResponseParams_Data* params =
      reinterpret_cast<internal::BackgroundSyncService_Unregister_ResponseParams_Data*>(
          message->mutable_payload());

  params->DecodePointersAndHandles(message->mutable_handles());
  
  BackgroundSyncError p_err{};
  do {
    // NOTE: The memory backing |params| may has be smaller than
    // |sizeof(*params)| if the message comes from an older version.
    p_err = static_cast<BackgroundSyncError>(params->err);
  } while (false);
  callback_.Run(p_err);
  return true;
}
class BackgroundSyncService_GetPermissionStatus_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  BackgroundSyncService_GetPermissionStatus_ForwardToCallback(
      const BackgroundSyncService::GetPermissionStatusCallback& callback)
      : callback_(callback) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  BackgroundSyncService::GetPermissionStatusCallback callback_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(BackgroundSyncService_GetPermissionStatus_ForwardToCallback);
};
bool BackgroundSyncService_GetPermissionStatus_ForwardToCallback::Accept(
    mojo::Message* message) {
  internal::BackgroundSyncService_GetPermissionStatus_ResponseParams_Data* params =
      reinterpret_cast<internal::BackgroundSyncService_GetPermissionStatus_ResponseParams_Data*>(
          message->mutable_payload());

  params->DecodePointersAndHandles(message->mutable_handles());
  
  BackgroundSyncError p_err{};
  content::PermissionStatus p_status{};
  do {
    // NOTE: The memory backing |params| may has be smaller than
    // |sizeof(*params)| if the message comes from an older version.
    p_err = static_cast<BackgroundSyncError>(params->err);
    p_status = static_cast<content::PermissionStatus>(params->status);
  } while (false);
  callback_.Run(p_err, p_status);
  return true;
}

BackgroundSyncServiceProxy::BackgroundSyncServiceProxy(mojo::MessageReceiverWithResponder* receiver)
    : ControlMessageProxy(receiver) {
}
void BackgroundSyncServiceProxy::Register(
    content::SyncRegistrationPtr in_options, int64_t in_service_worker_registration_id, const RegisterCallback& callback) {
  size_t size = sizeof(internal::BackgroundSyncService_Register_Params_Data);
  size += GetSerializedSize_(in_options);
  mojo::internal::RequestMessageBuilder builder(internal::kBackgroundSyncService_Register_Name, size);

  internal::BackgroundSyncService_Register_Params_Data* params =
      internal::BackgroundSyncService_Register_Params_Data::New(builder.buffer());
  Serialize_(mojo::internal::Forward(in_options), builder.buffer(), &params->options.ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->options.ptr,
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null options in BackgroundSyncService.Register request");
  params->service_worker_registration_id = in_service_worker_registration_id;
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  mojo::MessageReceiver* responder =
      new BackgroundSyncService_Register_ForwardToCallback(callback);
  if (!receiver_->AcceptWithResponder(&message, responder))
    delete responder;
}
void BackgroundSyncServiceProxy::GetRegistration(
    content::BackgroundSyncPeriodicity in_periodicity, const mojo::String& in_tag, int64_t in_service_worker_registration_id, const GetRegistrationCallback& callback) {
  size_t size = sizeof(internal::BackgroundSyncService_GetRegistration_Params_Data);
  size += GetSerializedSize_(in_tag);
  mojo::internal::RequestMessageBuilder builder(internal::kBackgroundSyncService_GetRegistration_Name, size);

  internal::BackgroundSyncService_GetRegistration_Params_Data* params =
      internal::BackgroundSyncService_GetRegistration_Params_Data::New(builder.buffer());
  params->periodicity = in_periodicity;
  Serialize_(mojo::internal::Forward(in_tag), builder.buffer(), &params->tag.ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->tag.ptr,
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null tag in BackgroundSyncService.GetRegistration request");
  params->service_worker_registration_id = in_service_worker_registration_id;
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  mojo::MessageReceiver* responder =
      new BackgroundSyncService_GetRegistration_ForwardToCallback(callback);
  if (!receiver_->AcceptWithResponder(&message, responder))
    delete responder;
}
void BackgroundSyncServiceProxy::GetRegistrations(
    content::BackgroundSyncPeriodicity in_periodicity, int64_t in_service_worker_registration_id, const GetRegistrationsCallback& callback) {
  size_t size = sizeof(internal::BackgroundSyncService_GetRegistrations_Params_Data);
  mojo::internal::RequestMessageBuilder builder(internal::kBackgroundSyncService_GetRegistrations_Name, size);

  internal::BackgroundSyncService_GetRegistrations_Params_Data* params =
      internal::BackgroundSyncService_GetRegistrations_Params_Data::New(builder.buffer());
  params->periodicity = in_periodicity;
  params->service_worker_registration_id = in_service_worker_registration_id;
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  mojo::MessageReceiver* responder =
      new BackgroundSyncService_GetRegistrations_ForwardToCallback(callback);
  if (!receiver_->AcceptWithResponder(&message, responder))
    delete responder;
}
void BackgroundSyncServiceProxy::Unregister(
    content::BackgroundSyncPeriodicity in_periodicity, int64_t in_id, const mojo::String& in_tag, int64_t in_service_worker_registration_id, const UnregisterCallback& callback) {
  size_t size = sizeof(internal::BackgroundSyncService_Unregister_Params_Data);
  size += GetSerializedSize_(in_tag);
  mojo::internal::RequestMessageBuilder builder(internal::kBackgroundSyncService_Unregister_Name, size);

  internal::BackgroundSyncService_Unregister_Params_Data* params =
      internal::BackgroundSyncService_Unregister_Params_Data::New(builder.buffer());
  params->periodicity = in_periodicity;
  params->id = in_id;
  Serialize_(mojo::internal::Forward(in_tag), builder.buffer(), &params->tag.ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->tag.ptr,
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null tag in BackgroundSyncService.Unregister request");
  params->service_worker_registration_id = in_service_worker_registration_id;
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  mojo::MessageReceiver* responder =
      new BackgroundSyncService_Unregister_ForwardToCallback(callback);
  if (!receiver_->AcceptWithResponder(&message, responder))
    delete responder;
}
void BackgroundSyncServiceProxy::GetPermissionStatus(
    content::BackgroundSyncPeriodicity in_periodicity, int64_t in_service_worker_registration_id, const GetPermissionStatusCallback& callback) {
  size_t size = sizeof(internal::BackgroundSyncService_GetPermissionStatus_Params_Data);
  mojo::internal::RequestMessageBuilder builder(internal::kBackgroundSyncService_GetPermissionStatus_Name, size);

  internal::BackgroundSyncService_GetPermissionStatus_Params_Data* params =
      internal::BackgroundSyncService_GetPermissionStatus_Params_Data::New(builder.buffer());
  params->periodicity = in_periodicity;
  params->service_worker_registration_id = in_service_worker_registration_id;
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  mojo::MessageReceiver* responder =
      new BackgroundSyncService_GetPermissionStatus_ForwardToCallback(callback);
  if (!receiver_->AcceptWithResponder(&message, responder))
    delete responder;
}
class BackgroundSyncService_Register_ProxyToResponder
    : public BackgroundSyncService::RegisterCallback::Runnable {
 public:
  ~BackgroundSyncService_Register_ProxyToResponder() override {
    // Is the Mojo application destroying the callback without running it
    // and without first closing the pipe?
    bool callback_was_dropped = responder_ && responder_->IsValid();
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    delete responder_;
    MOJO_DCHECK(!callback_was_dropped)  << "The callback passed to "
        "BackgroundSyncService::Register(p_options.Pass(), p_service_worker_registration_id, callback) "
        "was never run.";
  }

  BackgroundSyncService_Register_ProxyToResponder(
      uint64_t request_id,
      mojo::MessageReceiverWithStatus* responder)
      : request_id_(request_id),
        responder_(responder) {
  }

  void Run(BackgroundSyncError in_err, content::SyncRegistrationPtr in_options) const override;

 private:
  uint64_t request_id_;
  mutable mojo::MessageReceiverWithStatus* responder_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(BackgroundSyncService_Register_ProxyToResponder);
};
void BackgroundSyncService_Register_ProxyToResponder::Run(
    BackgroundSyncError in_err, content::SyncRegistrationPtr in_options) const {
  size_t size = sizeof(internal::BackgroundSyncService_Register_ResponseParams_Data);
  size += GetSerializedSize_(in_options);
  mojo::internal::ResponseMessageBuilder builder(
      internal::kBackgroundSyncService_Register_Name, size, request_id_);
  internal::BackgroundSyncService_Register_ResponseParams_Data* params =
      internal::BackgroundSyncService_Register_ResponseParams_Data::New(builder.buffer());
  params->err = in_err;
  Serialize_(mojo::internal::Forward(in_options), builder.buffer(), &params->options.ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->options.ptr,
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null options in BackgroundSyncService.Register response");
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = responder_->Accept(&message);
  MOJO_ALLOW_UNUSED_LOCAL(ok);
  // TODO(darin): !ok returned here indicates a malformed message, and that may
  // be good reason to close the connection. However, we don't have a way to do
  // that from here. We should add a way.
  delete responder_;
  responder_ = nullptr;
}
class BackgroundSyncService_GetRegistration_ProxyToResponder
    : public BackgroundSyncService::GetRegistrationCallback::Runnable {
 public:
  ~BackgroundSyncService_GetRegistration_ProxyToResponder() override {
    // Is the Mojo application destroying the callback without running it
    // and without first closing the pipe?
    bool callback_was_dropped = responder_ && responder_->IsValid();
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    delete responder_;
    MOJO_DCHECK(!callback_was_dropped)  << "The callback passed to "
        "BackgroundSyncService::GetRegistration(p_periodicity, p_tag, p_service_worker_registration_id, callback) "
        "was never run.";
  }

  BackgroundSyncService_GetRegistration_ProxyToResponder(
      uint64_t request_id,
      mojo::MessageReceiverWithStatus* responder)
      : request_id_(request_id),
        responder_(responder) {
  }

  void Run(BackgroundSyncError in_err, content::SyncRegistrationPtr in_registration) const override;

 private:
  uint64_t request_id_;
  mutable mojo::MessageReceiverWithStatus* responder_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(BackgroundSyncService_GetRegistration_ProxyToResponder);
};
void BackgroundSyncService_GetRegistration_ProxyToResponder::Run(
    BackgroundSyncError in_err, content::SyncRegistrationPtr in_registration) const {
  size_t size = sizeof(internal::BackgroundSyncService_GetRegistration_ResponseParams_Data);
  size += GetSerializedSize_(in_registration);
  mojo::internal::ResponseMessageBuilder builder(
      internal::kBackgroundSyncService_GetRegistration_Name, size, request_id_);
  internal::BackgroundSyncService_GetRegistration_ResponseParams_Data* params =
      internal::BackgroundSyncService_GetRegistration_ResponseParams_Data::New(builder.buffer());
  params->err = in_err;
  Serialize_(mojo::internal::Forward(in_registration), builder.buffer(), &params->registration.ptr);
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = responder_->Accept(&message);
  MOJO_ALLOW_UNUSED_LOCAL(ok);
  // TODO(darin): !ok returned here indicates a malformed message, and that may
  // be good reason to close the connection. However, we don't have a way to do
  // that from here. We should add a way.
  delete responder_;
  responder_ = nullptr;
}
class BackgroundSyncService_GetRegistrations_ProxyToResponder
    : public BackgroundSyncService::GetRegistrationsCallback::Runnable {
 public:
  ~BackgroundSyncService_GetRegistrations_ProxyToResponder() override {
    // Is the Mojo application destroying the callback without running it
    // and without first closing the pipe?
    bool callback_was_dropped = responder_ && responder_->IsValid();
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    delete responder_;
    MOJO_DCHECK(!callback_was_dropped)  << "The callback passed to "
        "BackgroundSyncService::GetRegistrations(p_periodicity, p_service_worker_registration_id, callback) "
        "was never run.";
  }

  BackgroundSyncService_GetRegistrations_ProxyToResponder(
      uint64_t request_id,
      mojo::MessageReceiverWithStatus* responder)
      : request_id_(request_id),
        responder_(responder) {
  }

  void Run(BackgroundSyncError in_err, mojo::Array<content::SyncRegistrationPtr> in_registrations) const override;

 private:
  uint64_t request_id_;
  mutable mojo::MessageReceiverWithStatus* responder_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(BackgroundSyncService_GetRegistrations_ProxyToResponder);
};
void BackgroundSyncService_GetRegistrations_ProxyToResponder::Run(
    BackgroundSyncError in_err, mojo::Array<content::SyncRegistrationPtr> in_registrations) const {
  size_t size = sizeof(internal::BackgroundSyncService_GetRegistrations_ResponseParams_Data);
  size += GetSerializedSize_(in_registrations);
  mojo::internal::ResponseMessageBuilder builder(
      internal::kBackgroundSyncService_GetRegistrations_Name, size, request_id_);
  internal::BackgroundSyncService_GetRegistrations_ResponseParams_Data* params =
      internal::BackgroundSyncService_GetRegistrations_ResponseParams_Data::New(builder.buffer());
  params->err = in_err;
  const mojo::internal::ArrayValidateParams registrations_validate_params(
      0, false, nullptr);
  mojo::SerializeArray_(mojo::internal::Forward(in_registrations), builder.buffer(),
      &params->registrations.ptr, &registrations_validate_params);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->registrations.ptr,
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null registrations in BackgroundSyncService.GetRegistrations response");
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = responder_->Accept(&message);
  MOJO_ALLOW_UNUSED_LOCAL(ok);
  // TODO(darin): !ok returned here indicates a malformed message, and that may
  // be good reason to close the connection. However, we don't have a way to do
  // that from here. We should add a way.
  delete responder_;
  responder_ = nullptr;
}
class BackgroundSyncService_Unregister_ProxyToResponder
    : public BackgroundSyncService::UnregisterCallback::Runnable {
 public:
  ~BackgroundSyncService_Unregister_ProxyToResponder() override {
    // Is the Mojo application destroying the callback without running it
    // and without first closing the pipe?
    bool callback_was_dropped = responder_ && responder_->IsValid();
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    delete responder_;
    MOJO_DCHECK(!callback_was_dropped)  << "The callback passed to "
        "BackgroundSyncService::Unregister(p_periodicity, p_id, p_tag, p_service_worker_registration_id, callback) "
        "was never run.";
  }

  BackgroundSyncService_Unregister_ProxyToResponder(
      uint64_t request_id,
      mojo::MessageReceiverWithStatus* responder)
      : request_id_(request_id),
        responder_(responder) {
  }

  void Run(BackgroundSyncError in_err) const override;

 private:
  uint64_t request_id_;
  mutable mojo::MessageReceiverWithStatus* responder_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(BackgroundSyncService_Unregister_ProxyToResponder);
};
void BackgroundSyncService_Unregister_ProxyToResponder::Run(
    BackgroundSyncError in_err) const {
  size_t size = sizeof(internal::BackgroundSyncService_Unregister_ResponseParams_Data);
  mojo::internal::ResponseMessageBuilder builder(
      internal::kBackgroundSyncService_Unregister_Name, size, request_id_);
  internal::BackgroundSyncService_Unregister_ResponseParams_Data* params =
      internal::BackgroundSyncService_Unregister_ResponseParams_Data::New(builder.buffer());
  params->err = in_err;
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = responder_->Accept(&message);
  MOJO_ALLOW_UNUSED_LOCAL(ok);
  // TODO(darin): !ok returned here indicates a malformed message, and that may
  // be good reason to close the connection. However, we don't have a way to do
  // that from here. We should add a way.
  delete responder_;
  responder_ = nullptr;
}
class BackgroundSyncService_GetPermissionStatus_ProxyToResponder
    : public BackgroundSyncService::GetPermissionStatusCallback::Runnable {
 public:
  ~BackgroundSyncService_GetPermissionStatus_ProxyToResponder() override {
    // Is the Mojo application destroying the callback without running it
    // and without first closing the pipe?
    bool callback_was_dropped = responder_ && responder_->IsValid();
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    delete responder_;
    MOJO_DCHECK(!callback_was_dropped)  << "The callback passed to "
        "BackgroundSyncService::GetPermissionStatus(p_periodicity, p_service_worker_registration_id, callback) "
        "was never run.";
  }

  BackgroundSyncService_GetPermissionStatus_ProxyToResponder(
      uint64_t request_id,
      mojo::MessageReceiverWithStatus* responder)
      : request_id_(request_id),
        responder_(responder) {
  }

  void Run(BackgroundSyncError in_err, content::PermissionStatus in_status) const override;

 private:
  uint64_t request_id_;
  mutable mojo::MessageReceiverWithStatus* responder_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(BackgroundSyncService_GetPermissionStatus_ProxyToResponder);
};
void BackgroundSyncService_GetPermissionStatus_ProxyToResponder::Run(
    BackgroundSyncError in_err, content::PermissionStatus in_status) const {
  size_t size = sizeof(internal::BackgroundSyncService_GetPermissionStatus_ResponseParams_Data);
  mojo::internal::ResponseMessageBuilder builder(
      internal::kBackgroundSyncService_GetPermissionStatus_Name, size, request_id_);
  internal::BackgroundSyncService_GetPermissionStatus_ResponseParams_Data* params =
      internal::BackgroundSyncService_GetPermissionStatus_ResponseParams_Data::New(builder.buffer());
  params->err = in_err;
  params->status = in_status;
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = responder_->Accept(&message);
  MOJO_ALLOW_UNUSED_LOCAL(ok);
  // TODO(darin): !ok returned here indicates a malformed message, and that may
  // be good reason to close the connection. However, we don't have a way to do
  // that from here. We should add a way.
  delete responder_;
  responder_ = nullptr;
}

BackgroundSyncServiceStub::BackgroundSyncServiceStub()
    : sink_(nullptr),
      control_message_handler_(BackgroundSyncService::Version_) {
}

BackgroundSyncServiceStub::~BackgroundSyncServiceStub() {}

bool BackgroundSyncServiceStub::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return control_message_handler_.Accept(message);
  switch (message->header()->name) {
    case internal::kBackgroundSyncService_Register_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.content.BackgroundSyncService.Register", __FILE__, __LINE__);
      break;
    }
    case internal::kBackgroundSyncService_GetRegistration_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.content.BackgroundSyncService.GetRegistration", __FILE__, __LINE__);
      break;
    }
    case internal::kBackgroundSyncService_GetRegistrations_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.content.BackgroundSyncService.GetRegistrations", __FILE__, __LINE__);
      break;
    }
    case internal::kBackgroundSyncService_Unregister_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.content.BackgroundSyncService.Unregister", __FILE__, __LINE__);
      break;
    }
    case internal::kBackgroundSyncService_GetPermissionStatus_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.content.BackgroundSyncService.GetPermissionStatus", __FILE__, __LINE__);
      break;
    }
  }
  return false;
}

bool BackgroundSyncServiceStub::AcceptWithResponder(
    mojo::Message* message, mojo::MessageReceiverWithStatus* responder) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return control_message_handler_.AcceptWithResponder(message, responder);
  switch (message->header()->name) {
    case internal::kBackgroundSyncService_Register_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::content::BackgroundSyncService::Register", __FILE__, __LINE__);
      internal::BackgroundSyncService_Register_Params_Data* params =
          reinterpret_cast<internal::BackgroundSyncService_Register_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      BackgroundSyncService::RegisterCallback::Runnable* runnable =
          new BackgroundSyncService_Register_ProxyToResponder(
              message->request_id(), responder);
      BackgroundSyncService::RegisterCallback callback(runnable);
      
      content::SyncRegistrationPtr p_options{};
      int64_t p_service_worker_registration_id{};
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
        Deserialize_(params->options.ptr, &p_options);
        p_service_worker_registration_id = params->service_worker_registration_id;
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->Register(p_options.Pass(), p_service_worker_registration_id, callback);
      return true;
    }
    case internal::kBackgroundSyncService_GetRegistration_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::content::BackgroundSyncService::GetRegistration", __FILE__, __LINE__);
      internal::BackgroundSyncService_GetRegistration_Params_Data* params =
          reinterpret_cast<internal::BackgroundSyncService_GetRegistration_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      BackgroundSyncService::GetRegistrationCallback::Runnable* runnable =
          new BackgroundSyncService_GetRegistration_ProxyToResponder(
              message->request_id(), responder);
      BackgroundSyncService::GetRegistrationCallback callback(runnable);
      
      content::BackgroundSyncPeriodicity p_periodicity{};
      mojo::String p_tag{};
      int64_t p_service_worker_registration_id{};
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
        p_periodicity = static_cast<content::BackgroundSyncPeriodicity>(params->periodicity);
        Deserialize_(params->tag.ptr, &p_tag);
        p_service_worker_registration_id = params->service_worker_registration_id;
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->GetRegistration(p_periodicity, p_tag, p_service_worker_registration_id, callback);
      return true;
    }
    case internal::kBackgroundSyncService_GetRegistrations_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::content::BackgroundSyncService::GetRegistrations", __FILE__, __LINE__);
      internal::BackgroundSyncService_GetRegistrations_Params_Data* params =
          reinterpret_cast<internal::BackgroundSyncService_GetRegistrations_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      BackgroundSyncService::GetRegistrationsCallback::Runnable* runnable =
          new BackgroundSyncService_GetRegistrations_ProxyToResponder(
              message->request_id(), responder);
      BackgroundSyncService::GetRegistrationsCallback callback(runnable);
      
      content::BackgroundSyncPeriodicity p_periodicity{};
      int64_t p_service_worker_registration_id{};
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
        p_periodicity = static_cast<content::BackgroundSyncPeriodicity>(params->periodicity);
        p_service_worker_registration_id = params->service_worker_registration_id;
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->GetRegistrations(p_periodicity, p_service_worker_registration_id, callback);
      return true;
    }
    case internal::kBackgroundSyncService_Unregister_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::content::BackgroundSyncService::Unregister", __FILE__, __LINE__);
      internal::BackgroundSyncService_Unregister_Params_Data* params =
          reinterpret_cast<internal::BackgroundSyncService_Unregister_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      BackgroundSyncService::UnregisterCallback::Runnable* runnable =
          new BackgroundSyncService_Unregister_ProxyToResponder(
              message->request_id(), responder);
      BackgroundSyncService::UnregisterCallback callback(runnable);
      
      content::BackgroundSyncPeriodicity p_periodicity{};
      int64_t p_id{};
      mojo::String p_tag{};
      int64_t p_service_worker_registration_id{};
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
        p_periodicity = static_cast<content::BackgroundSyncPeriodicity>(params->periodicity);
        p_id = params->id;
        Deserialize_(params->tag.ptr, &p_tag);
        p_service_worker_registration_id = params->service_worker_registration_id;
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->Unregister(p_periodicity, p_id, p_tag, p_service_worker_registration_id, callback);
      return true;
    }
    case internal::kBackgroundSyncService_GetPermissionStatus_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::content::BackgroundSyncService::GetPermissionStatus", __FILE__, __LINE__);
      internal::BackgroundSyncService_GetPermissionStatus_Params_Data* params =
          reinterpret_cast<internal::BackgroundSyncService_GetPermissionStatus_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      BackgroundSyncService::GetPermissionStatusCallback::Runnable* runnable =
          new BackgroundSyncService_GetPermissionStatus_ProxyToResponder(
              message->request_id(), responder);
      BackgroundSyncService::GetPermissionStatusCallback callback(runnable);
      
      content::BackgroundSyncPeriodicity p_periodicity{};
      int64_t p_service_worker_registration_id{};
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
        p_periodicity = static_cast<content::BackgroundSyncPeriodicity>(params->periodicity);
        p_service_worker_registration_id = params->service_worker_registration_id;
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->GetPermissionStatus(p_periodicity, p_service_worker_registration_id, callback);
      return true;
    }
  }
  return false;
}

BackgroundSyncServiceRequestValidator::BackgroundSyncServiceRequestValidator(
    mojo::MessageReceiver* sink) : MessageFilter(sink) {
}

bool BackgroundSyncServiceRequestValidator::Accept(mojo::Message* message) {
  assert(sink_);

  if (mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    if (!mojo::internal::ValidateControlRequest(message))
      return false;
    return sink_->Accept(message);
  }

  switch (message->header()->name) {
    case internal::kBackgroundSyncService_Register_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::BackgroundSyncService_Register_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kBackgroundSyncService_GetRegistration_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::BackgroundSyncService_GetRegistration_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kBackgroundSyncService_GetRegistrations_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::BackgroundSyncService_GetRegistrations_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kBackgroundSyncService_Unregister_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::BackgroundSyncService_Unregister_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kBackgroundSyncService_GetPermissionStatus_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::BackgroundSyncService_GetPermissionStatus_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

BackgroundSyncServiceResponseValidator::BackgroundSyncServiceResponseValidator(
    mojo::MessageReceiver* sink) : MessageFilter(sink) {
}

bool BackgroundSyncServiceResponseValidator::Accept(mojo::Message* message) {
  assert(sink_);

  if (mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    if (!mojo::internal::ValidateControlResponse(message))
      return false;
    return sink_->Accept(message);
  }

  if (!mojo::internal::ValidateMessageIsResponse(message))
    return false;
  switch (message->header()->name) {
    case internal::kBackgroundSyncService_Register_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::BackgroundSyncService_Register_ResponseParams_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kBackgroundSyncService_GetRegistration_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::BackgroundSyncService_GetRegistration_ResponseParams_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kBackgroundSyncService_GetRegistrations_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::BackgroundSyncService_GetRegistrations_ResponseParams_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kBackgroundSyncService_Unregister_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::BackgroundSyncService_Unregister_ResponseParams_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kBackgroundSyncService_GetPermissionStatus_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::BackgroundSyncService_GetPermissionStatus_ResponseParams_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
MOJO_STATIC_CONST_MEMBER_DEFINITION const char BackgoundSyncServiceClient::Name_[] = "content::BackgoundSyncServiceClient";
MOJO_STATIC_CONST_MEMBER_DEFINITION const uint32_t BackgoundSyncServiceClient::Version_;

BackgoundSyncServiceClientProxy::BackgoundSyncServiceClientProxy(mojo::MessageReceiverWithResponder* receiver)
    : ControlMessageProxy(receiver) {
}
void BackgoundSyncServiceClientProxy::Sync(
    content::SyncRegistrationPtr in_event) {
  size_t size = sizeof(internal::BackgoundSyncServiceClient_Sync_Params_Data);
  size += GetSerializedSize_(in_event);
  mojo::internal::MessageBuilder builder(internal::kBackgoundSyncServiceClient_Sync_Name, size);

  internal::BackgoundSyncServiceClient_Sync_Params_Data* params =
      internal::BackgoundSyncServiceClient_Sync_Params_Data::New(builder.buffer());
  Serialize_(mojo::internal::Forward(in_event), builder.buffer(), &params->event.ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->event.ptr,
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null event in BackgoundSyncServiceClient.Sync request");
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = receiver_->Accept(&message);
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  MOJO_ALLOW_UNUSED_LOCAL(ok);
}

BackgoundSyncServiceClientStub::BackgoundSyncServiceClientStub()
    : sink_(nullptr),
      control_message_handler_(BackgoundSyncServiceClient::Version_) {
}

BackgoundSyncServiceClientStub::~BackgoundSyncServiceClientStub() {}

bool BackgoundSyncServiceClientStub::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return control_message_handler_.Accept(message);
  switch (message->header()->name) {
    case internal::kBackgoundSyncServiceClient_Sync_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.content.BackgoundSyncServiceClient.Sync", __FILE__, __LINE__);
      internal::BackgoundSyncServiceClient_Sync_Params_Data* params =
          reinterpret_cast<internal::BackgoundSyncServiceClient_Sync_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      
      content::SyncRegistrationPtr p_event{};
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
        Deserialize_(params->event.ptr, &p_event);
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->Sync(p_event.Pass());
      return true;
    }
  }
  return false;
}

bool BackgoundSyncServiceClientStub::AcceptWithResponder(
    mojo::Message* message, mojo::MessageReceiverWithStatus* responder) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return control_message_handler_.AcceptWithResponder(message, responder);
  switch (message->header()->name) {
    case internal::kBackgoundSyncServiceClient_Sync_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::content::BackgoundSyncServiceClient::Sync", __FILE__, __LINE__);
      break;
    }
  }
  return false;
}

BackgoundSyncServiceClientRequestValidator::BackgoundSyncServiceClientRequestValidator(
    mojo::MessageReceiver* sink) : MessageFilter(sink) {
}

bool BackgoundSyncServiceClientRequestValidator::Accept(mojo::Message* message) {
  assert(sink_);

  if (mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    if (!mojo::internal::ValidateControlRequest(message))
      return false;
    return sink_->Accept(message);
  }

  switch (message->header()->name) {
    case internal::kBackgoundSyncServiceClient_Sync_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::BackgoundSyncServiceClient_Sync_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace content

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif
