// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "content/common/presentation/presentation_service.mojom.h"

#include <math.h>

#include "mojo/public/cpp/bindings/lib/array_serialization.h"
#include "mojo/public/cpp/bindings/lib/bindings_serialization.h"
#include "mojo/public/cpp/bindings/lib/bounds_checker.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/map_serialization.h"
#include "mojo/public/cpp/bindings/lib/message_builder.h"
#include "mojo/public/cpp/bindings/lib/string_serialization.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "mojo/public/cpp/environment/lib/scoped_task_tracking.h"
#include "mojo/public/cpp/environment/logging.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
namespace presentation {

namespace internal {
namespace {

#pragma pack(push, 1)
const uint32_t kPresentationService_SetDefaultPresentationURL_Name = 0;

class PresentationService_SetDefaultPresentationURL_Params_Data {
 public:
  static PresentationService_SetDefaultPresentationURL_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  mojo::internal::StringPointer default_presentation_url;
  mojo::internal::StringPointer default_presentation_id;

 private:
  PresentationService_SetDefaultPresentationURL_Params_Data();
  ~PresentationService_SetDefaultPresentationURL_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_SetDefaultPresentationURL_Params_Data) == 24,
              "Bad sizeof(PresentationService_SetDefaultPresentationURL_Params_Data)");


// static
PresentationService_SetDefaultPresentationURL_Params_Data* PresentationService_SetDefaultPresentationURL_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationService_SetDefaultPresentationURL_Params_Data))) PresentationService_SetDefaultPresentationURL_Params_Data();
}

// static
bool PresentationService_SetDefaultPresentationURL_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationService_SetDefaultPresentationURL_Params_Data* object = static_cast<const PresentationService_SetDefaultPresentationURL_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!object->default_presentation_url.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null default_presentation_url field in PresentationService_SetDefaultPresentationURL_Params struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->default_presentation_url.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams default_presentation_url_validate_params(
      0, false, nullptr);
  if (!mojo::String::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->default_presentation_url.offset),
              bounds_checker, &default_presentation_url_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidateEncodedPointer(&object->default_presentation_id.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams default_presentation_id_validate_params(
      0, false, nullptr);
  if (!mojo::String::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->default_presentation_id.offset),
              bounds_checker, &default_presentation_id_validate_params)) {
    return false;
  }

  return true;
}

void PresentationService_SetDefaultPresentationURL_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&default_presentation_url, handles);
  mojo::internal::Encode(&default_presentation_id, handles);
}

void PresentationService_SetDefaultPresentationURL_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&default_presentation_url, handles);
  mojo::internal::Decode(&default_presentation_id, handles);
}

PresentationService_SetDefaultPresentationURL_Params_Data::PresentationService_SetDefaultPresentationURL_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kPresentationService_SetClient_Name = 1;

class PresentationService_SetClient_Params_Data {
 public:
  static PresentationService_SetClient_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data client;

 private:
  PresentationService_SetClient_Params_Data();
  ~PresentationService_SetClient_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_SetClient_Params_Data) == 16,
              "Bad sizeof(PresentationService_SetClient_Params_Data)");


// static
PresentationService_SetClient_Params_Data* PresentationService_SetClient_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationService_SetClient_Params_Data))) PresentationService_SetClient_Params_Data();
}

// static
bool PresentationService_SetClient_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationService_SetClient_Params_Data* object = static_cast<const PresentationService_SetClient_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  const mojo::Handle client_handle = object->client.handle;
  if (client_handle.value() == mojo::internal::kEncodedInvalidHandleValue) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
        "invalid client field in PresentationService_SetClient_Params struct");
    return false;
  }
  if (!bounds_checker->ClaimHandle(client_handle)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_HANDLE);
    return false;
  }

  return true;
}

void PresentationService_SetClient_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::EncodeHandle(&client, handles);
}

void PresentationService_SetClient_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::DecodeHandle(&client, handles);
}

PresentationService_SetClient_Params_Data::PresentationService_SetClient_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kPresentationService_ListenForScreenAvailability_Name = 2;

class PresentationService_ListenForScreenAvailability_Params_Data {
 public:
  static PresentationService_ListenForScreenAvailability_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;

 private:
  PresentationService_ListenForScreenAvailability_Params_Data();
  ~PresentationService_ListenForScreenAvailability_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_ListenForScreenAvailability_Params_Data) == 8,
              "Bad sizeof(PresentationService_ListenForScreenAvailability_Params_Data)");


// static
PresentationService_ListenForScreenAvailability_Params_Data* PresentationService_ListenForScreenAvailability_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationService_ListenForScreenAvailability_Params_Data))) PresentationService_ListenForScreenAvailability_Params_Data();
}

// static
bool PresentationService_ListenForScreenAvailability_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationService_ListenForScreenAvailability_Params_Data* object = static_cast<const PresentationService_ListenForScreenAvailability_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 8 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void PresentationService_ListenForScreenAvailability_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
}

void PresentationService_ListenForScreenAvailability_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
}

PresentationService_ListenForScreenAvailability_Params_Data::PresentationService_ListenForScreenAvailability_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kPresentationService_StopListeningForScreenAvailability_Name = 3;

class PresentationService_StopListeningForScreenAvailability_Params_Data {
 public:
  static PresentationService_StopListeningForScreenAvailability_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;

 private:
  PresentationService_StopListeningForScreenAvailability_Params_Data();
  ~PresentationService_StopListeningForScreenAvailability_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_StopListeningForScreenAvailability_Params_Data) == 8,
              "Bad sizeof(PresentationService_StopListeningForScreenAvailability_Params_Data)");


// static
PresentationService_StopListeningForScreenAvailability_Params_Data* PresentationService_StopListeningForScreenAvailability_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationService_StopListeningForScreenAvailability_Params_Data))) PresentationService_StopListeningForScreenAvailability_Params_Data();
}

// static
bool PresentationService_StopListeningForScreenAvailability_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationService_StopListeningForScreenAvailability_Params_Data* object = static_cast<const PresentationService_StopListeningForScreenAvailability_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 8 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void PresentationService_StopListeningForScreenAvailability_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
}

void PresentationService_StopListeningForScreenAvailability_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
}

PresentationService_StopListeningForScreenAvailability_Params_Data::PresentationService_StopListeningForScreenAvailability_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kPresentationService_ListenForDefaultSessionStart_Name = 4;

class PresentationService_ListenForDefaultSessionStart_Params_Data {
 public:
  static PresentationService_ListenForDefaultSessionStart_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;

 private:
  PresentationService_ListenForDefaultSessionStart_Params_Data();
  ~PresentationService_ListenForDefaultSessionStart_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_ListenForDefaultSessionStart_Params_Data) == 8,
              "Bad sizeof(PresentationService_ListenForDefaultSessionStart_Params_Data)");


// static
PresentationService_ListenForDefaultSessionStart_Params_Data* PresentationService_ListenForDefaultSessionStart_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationService_ListenForDefaultSessionStart_Params_Data))) PresentationService_ListenForDefaultSessionStart_Params_Data();
}

// static
bool PresentationService_ListenForDefaultSessionStart_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationService_ListenForDefaultSessionStart_Params_Data* object = static_cast<const PresentationService_ListenForDefaultSessionStart_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 8 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void PresentationService_ListenForDefaultSessionStart_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
}

void PresentationService_ListenForDefaultSessionStart_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
}

PresentationService_ListenForDefaultSessionStart_Params_Data::PresentationService_ListenForDefaultSessionStart_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

class PresentationService_ListenForDefaultSessionStart_ResponseParams_Data {
 public:
  static PresentationService_ListenForDefaultSessionStart_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  mojo::internal::StructPointer<internal::PresentationSessionInfo_Data> defaultSessionInfo;

 private:
  PresentationService_ListenForDefaultSessionStart_ResponseParams_Data();
  ~PresentationService_ListenForDefaultSessionStart_ResponseParams_Data() = delete;
};
static_assert(sizeof(PresentationService_ListenForDefaultSessionStart_ResponseParams_Data) == 16,
              "Bad sizeof(PresentationService_ListenForDefaultSessionStart_ResponseParams_Data)");


// static
PresentationService_ListenForDefaultSessionStart_ResponseParams_Data* PresentationService_ListenForDefaultSessionStart_ResponseParams_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationService_ListenForDefaultSessionStart_ResponseParams_Data))) PresentationService_ListenForDefaultSessionStart_ResponseParams_Data();
}

// static
bool PresentationService_ListenForDefaultSessionStart_ResponseParams_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationService_ListenForDefaultSessionStart_ResponseParams_Data* object = static_cast<const PresentationService_ListenForDefaultSessionStart_ResponseParams_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidateEncodedPointer(&object->defaultSessionInfo.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  if (!PresentationSessionInfo::Data_::Validate(
          mojo::internal::DecodePointerRaw(&object->defaultSessionInfo.offset),
          bounds_checker)) {
    return false;
  }

  return true;
}

void PresentationService_ListenForDefaultSessionStart_ResponseParams_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&defaultSessionInfo, handles);
}

void PresentationService_ListenForDefaultSessionStart_ResponseParams_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&defaultSessionInfo, handles);
}

PresentationService_ListenForDefaultSessionStart_ResponseParams_Data::PresentationService_ListenForDefaultSessionStart_ResponseParams_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kPresentationService_StartSession_Name = 5;

class PresentationService_StartSession_Params_Data {
 public:
  static PresentationService_StartSession_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  mojo::internal::StringPointer presentation_url;

 private:
  PresentationService_StartSession_Params_Data();
  ~PresentationService_StartSession_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_StartSession_Params_Data) == 16,
              "Bad sizeof(PresentationService_StartSession_Params_Data)");


// static
PresentationService_StartSession_Params_Data* PresentationService_StartSession_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationService_StartSession_Params_Data))) PresentationService_StartSession_Params_Data();
}

// static
bool PresentationService_StartSession_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationService_StartSession_Params_Data* object = static_cast<const PresentationService_StartSession_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!object->presentation_url.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null presentation_url field in PresentationService_StartSession_Params struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->presentation_url.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams presentation_url_validate_params(
      0, false, nullptr);
  if (!mojo::String::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->presentation_url.offset),
              bounds_checker, &presentation_url_validate_params)) {
    return false;
  }

  return true;
}

void PresentationService_StartSession_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&presentation_url, handles);
}

void PresentationService_StartSession_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&presentation_url, handles);
}

PresentationService_StartSession_Params_Data::PresentationService_StartSession_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

class PresentationService_StartSession_ResponseParams_Data {
 public:
  static PresentationService_StartSession_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  mojo::internal::StructPointer<internal::PresentationSessionInfo_Data> sessionInfo;
  mojo::internal::StructPointer<internal::PresentationError_Data> error;

 private:
  PresentationService_StartSession_ResponseParams_Data();
  ~PresentationService_StartSession_ResponseParams_Data() = delete;
};
static_assert(sizeof(PresentationService_StartSession_ResponseParams_Data) == 24,
              "Bad sizeof(PresentationService_StartSession_ResponseParams_Data)");


// static
PresentationService_StartSession_ResponseParams_Data* PresentationService_StartSession_ResponseParams_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationService_StartSession_ResponseParams_Data))) PresentationService_StartSession_ResponseParams_Data();
}

// static
bool PresentationService_StartSession_ResponseParams_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationService_StartSession_ResponseParams_Data* object = static_cast<const PresentationService_StartSession_ResponseParams_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidateEncodedPointer(&object->sessionInfo.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  if (!PresentationSessionInfo::Data_::Validate(
          mojo::internal::DecodePointerRaw(&object->sessionInfo.offset),
          bounds_checker)) {
    return false;
  }

  if (!mojo::internal::ValidateEncodedPointer(&object->error.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  if (!PresentationError::Data_::Validate(
          mojo::internal::DecodePointerRaw(&object->error.offset),
          bounds_checker)) {
    return false;
  }

  return true;
}

void PresentationService_StartSession_ResponseParams_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&sessionInfo, handles);
  mojo::internal::Encode(&error, handles);
}

void PresentationService_StartSession_ResponseParams_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&sessionInfo, handles);
  mojo::internal::Decode(&error, handles);
}

PresentationService_StartSession_ResponseParams_Data::PresentationService_StartSession_ResponseParams_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kPresentationService_JoinSession_Name = 6;

class PresentationService_JoinSession_Params_Data {
 public:
  static PresentationService_JoinSession_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  mojo::internal::StringPointer presentation_url;
  mojo::internal::StringPointer presentation_id;

 private:
  PresentationService_JoinSession_Params_Data();
  ~PresentationService_JoinSession_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_JoinSession_Params_Data) == 24,
              "Bad sizeof(PresentationService_JoinSession_Params_Data)");


// static
PresentationService_JoinSession_Params_Data* PresentationService_JoinSession_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationService_JoinSession_Params_Data))) PresentationService_JoinSession_Params_Data();
}

// static
bool PresentationService_JoinSession_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationService_JoinSession_Params_Data* object = static_cast<const PresentationService_JoinSession_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!object->presentation_url.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null presentation_url field in PresentationService_JoinSession_Params struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->presentation_url.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams presentation_url_validate_params(
      0, false, nullptr);
  if (!mojo::String::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->presentation_url.offset),
              bounds_checker, &presentation_url_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidateEncodedPointer(&object->presentation_id.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams presentation_id_validate_params(
      0, false, nullptr);
  if (!mojo::String::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->presentation_id.offset),
              bounds_checker, &presentation_id_validate_params)) {
    return false;
  }

  return true;
}

void PresentationService_JoinSession_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&presentation_url, handles);
  mojo::internal::Encode(&presentation_id, handles);
}

void PresentationService_JoinSession_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&presentation_url, handles);
  mojo::internal::Decode(&presentation_id, handles);
}

PresentationService_JoinSession_Params_Data::PresentationService_JoinSession_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

class PresentationService_JoinSession_ResponseParams_Data {
 public:
  static PresentationService_JoinSession_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  mojo::internal::StructPointer<internal::PresentationSessionInfo_Data> sessionInfo;
  mojo::internal::StructPointer<internal::PresentationError_Data> error;

 private:
  PresentationService_JoinSession_ResponseParams_Data();
  ~PresentationService_JoinSession_ResponseParams_Data() = delete;
};
static_assert(sizeof(PresentationService_JoinSession_ResponseParams_Data) == 24,
              "Bad sizeof(PresentationService_JoinSession_ResponseParams_Data)");


// static
PresentationService_JoinSession_ResponseParams_Data* PresentationService_JoinSession_ResponseParams_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationService_JoinSession_ResponseParams_Data))) PresentationService_JoinSession_ResponseParams_Data();
}

// static
bool PresentationService_JoinSession_ResponseParams_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationService_JoinSession_ResponseParams_Data* object = static_cast<const PresentationService_JoinSession_ResponseParams_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidateEncodedPointer(&object->sessionInfo.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  if (!PresentationSessionInfo::Data_::Validate(
          mojo::internal::DecodePointerRaw(&object->sessionInfo.offset),
          bounds_checker)) {
    return false;
  }

  if (!mojo::internal::ValidateEncodedPointer(&object->error.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  if (!PresentationError::Data_::Validate(
          mojo::internal::DecodePointerRaw(&object->error.offset),
          bounds_checker)) {
    return false;
  }

  return true;
}

void PresentationService_JoinSession_ResponseParams_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&sessionInfo, handles);
  mojo::internal::Encode(&error, handles);
}

void PresentationService_JoinSession_ResponseParams_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&sessionInfo, handles);
  mojo::internal::Decode(&error, handles);
}

PresentationService_JoinSession_ResponseParams_Data::PresentationService_JoinSession_ResponseParams_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kPresentationService_SendSessionMessage_Name = 7;

class PresentationService_SendSessionMessage_Params_Data {
 public:
  static PresentationService_SendSessionMessage_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  mojo::internal::StructPointer<internal::SessionMessage_Data> message_request;

 private:
  PresentationService_SendSessionMessage_Params_Data();
  ~PresentationService_SendSessionMessage_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_SendSessionMessage_Params_Data) == 16,
              "Bad sizeof(PresentationService_SendSessionMessage_Params_Data)");


// static
PresentationService_SendSessionMessage_Params_Data* PresentationService_SendSessionMessage_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationService_SendSessionMessage_Params_Data))) PresentationService_SendSessionMessage_Params_Data();
}

// static
bool PresentationService_SendSessionMessage_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationService_SendSessionMessage_Params_Data* object = static_cast<const PresentationService_SendSessionMessage_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!object->message_request.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null message_request field in PresentationService_SendSessionMessage_Params struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->message_request.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  if (!SessionMessage::Data_::Validate(
          mojo::internal::DecodePointerRaw(&object->message_request.offset),
          bounds_checker)) {
    return false;
  }

  return true;
}

void PresentationService_SendSessionMessage_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&message_request, handles);
}

void PresentationService_SendSessionMessage_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&message_request, handles);
}

PresentationService_SendSessionMessage_Params_Data::PresentationService_SendSessionMessage_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

class PresentationService_SendSessionMessage_ResponseParams_Data {
 public:
  static PresentationService_SendSessionMessage_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  PresentationService_SendSessionMessage_ResponseParams_Data();
  ~PresentationService_SendSessionMessage_ResponseParams_Data() = delete;
};
static_assert(sizeof(PresentationService_SendSessionMessage_ResponseParams_Data) == 16,
              "Bad sizeof(PresentationService_SendSessionMessage_ResponseParams_Data)");


// static
PresentationService_SendSessionMessage_ResponseParams_Data* PresentationService_SendSessionMessage_ResponseParams_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationService_SendSessionMessage_ResponseParams_Data))) PresentationService_SendSessionMessage_ResponseParams_Data();
}

// static
bool PresentationService_SendSessionMessage_ResponseParams_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationService_SendSessionMessage_ResponseParams_Data* object = static_cast<const PresentationService_SendSessionMessage_ResponseParams_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void PresentationService_SendSessionMessage_ResponseParams_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
}

void PresentationService_SendSessionMessage_ResponseParams_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
}

PresentationService_SendSessionMessage_ResponseParams_Data::PresentationService_SendSessionMessage_ResponseParams_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kPresentationService_CloseSession_Name = 8;

class PresentationService_CloseSession_Params_Data {
 public:
  static PresentationService_CloseSession_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  mojo::internal::StringPointer presentation_url;
  mojo::internal::StringPointer presentation_id;

 private:
  PresentationService_CloseSession_Params_Data();
  ~PresentationService_CloseSession_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_CloseSession_Params_Data) == 24,
              "Bad sizeof(PresentationService_CloseSession_Params_Data)");


// static
PresentationService_CloseSession_Params_Data* PresentationService_CloseSession_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationService_CloseSession_Params_Data))) PresentationService_CloseSession_Params_Data();
}

// static
bool PresentationService_CloseSession_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationService_CloseSession_Params_Data* object = static_cast<const PresentationService_CloseSession_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!object->presentation_url.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null presentation_url field in PresentationService_CloseSession_Params struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->presentation_url.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams presentation_url_validate_params(
      0, false, nullptr);
  if (!mojo::String::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->presentation_url.offset),
              bounds_checker, &presentation_url_validate_params)) {
    return false;
  }

  if (!object->presentation_id.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null presentation_id field in PresentationService_CloseSession_Params struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->presentation_id.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams presentation_id_validate_params(
      0, false, nullptr);
  if (!mojo::String::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->presentation_id.offset),
              bounds_checker, &presentation_id_validate_params)) {
    return false;
  }

  return true;
}

void PresentationService_CloseSession_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&presentation_url, handles);
  mojo::internal::Encode(&presentation_id, handles);
}

void PresentationService_CloseSession_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&presentation_url, handles);
  mojo::internal::Decode(&presentation_id, handles);
}

PresentationService_CloseSession_Params_Data::PresentationService_CloseSession_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kPresentationService_ListenForSessionStateChange_Name = 9;

class PresentationService_ListenForSessionStateChange_Params_Data {
 public:
  static PresentationService_ListenForSessionStateChange_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;

 private:
  PresentationService_ListenForSessionStateChange_Params_Data();
  ~PresentationService_ListenForSessionStateChange_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_ListenForSessionStateChange_Params_Data) == 8,
              "Bad sizeof(PresentationService_ListenForSessionStateChange_Params_Data)");


// static
PresentationService_ListenForSessionStateChange_Params_Data* PresentationService_ListenForSessionStateChange_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationService_ListenForSessionStateChange_Params_Data))) PresentationService_ListenForSessionStateChange_Params_Data();
}

// static
bool PresentationService_ListenForSessionStateChange_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationService_ListenForSessionStateChange_Params_Data* object = static_cast<const PresentationService_ListenForSessionStateChange_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 8 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void PresentationService_ListenForSessionStateChange_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
}

void PresentationService_ListenForSessionStateChange_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
}

PresentationService_ListenForSessionStateChange_Params_Data::PresentationService_ListenForSessionStateChange_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kPresentationService_ListenForSessionMessages_Name = 10;

class PresentationService_ListenForSessionMessages_Params_Data {
 public:
  static PresentationService_ListenForSessionMessages_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;

 private:
  PresentationService_ListenForSessionMessages_Params_Data();
  ~PresentationService_ListenForSessionMessages_Params_Data() = delete;
};
static_assert(sizeof(PresentationService_ListenForSessionMessages_Params_Data) == 8,
              "Bad sizeof(PresentationService_ListenForSessionMessages_Params_Data)");


// static
PresentationService_ListenForSessionMessages_Params_Data* PresentationService_ListenForSessionMessages_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationService_ListenForSessionMessages_Params_Data))) PresentationService_ListenForSessionMessages_Params_Data();
}

// static
bool PresentationService_ListenForSessionMessages_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationService_ListenForSessionMessages_Params_Data* object = static_cast<const PresentationService_ListenForSessionMessages_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 8 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void PresentationService_ListenForSessionMessages_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
}

void PresentationService_ListenForSessionMessages_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
}

PresentationService_ListenForSessionMessages_Params_Data::PresentationService_ListenForSessionMessages_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

class PresentationService_ListenForSessionMessages_ResponseParams_Data {
 public:
  static PresentationService_ListenForSessionMessages_ResponseParams_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  mojo::internal::ArrayPointer<internal::SessionMessage_Data*> messages;

 private:
  PresentationService_ListenForSessionMessages_ResponseParams_Data();
  ~PresentationService_ListenForSessionMessages_ResponseParams_Data() = delete;
};
static_assert(sizeof(PresentationService_ListenForSessionMessages_ResponseParams_Data) == 16,
              "Bad sizeof(PresentationService_ListenForSessionMessages_ResponseParams_Data)");


// static
PresentationService_ListenForSessionMessages_ResponseParams_Data* PresentationService_ListenForSessionMessages_ResponseParams_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationService_ListenForSessionMessages_ResponseParams_Data))) PresentationService_ListenForSessionMessages_ResponseParams_Data();
}

// static
bool PresentationService_ListenForSessionMessages_ResponseParams_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationService_ListenForSessionMessages_ResponseParams_Data* object = static_cast<const PresentationService_ListenForSessionMessages_ResponseParams_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!mojo::internal::ValidateEncodedPointer(&object->messages.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams messages_validate_params(
      0, false, nullptr);
  if (!mojo::Array<SessionMessagePtr>::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->messages.offset),
              bounds_checker, &messages_validate_params)) {
    return false;
  }

  return true;
}

void PresentationService_ListenForSessionMessages_ResponseParams_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&messages, handles);
}

void PresentationService_ListenForSessionMessages_ResponseParams_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&messages, handles);
}

PresentationService_ListenForSessionMessages_ResponseParams_Data::PresentationService_ListenForSessionMessages_ResponseParams_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kPresentationServiceClient_OnScreenAvailabilityNotSupported_Name = 0;

class PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data {
 public:
  static PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;

 private:
  PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data();
  ~PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data() = delete;
};
static_assert(sizeof(PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data) == 8,
              "Bad sizeof(PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data)");


// static
PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data* PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data))) PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data();
}

// static
bool PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data* object = static_cast<const PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 8 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
}

void PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
}

PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data::PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kPresentationServiceClient_OnScreenAvailabilityUpdated_Name = 1;

class PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data {
 public:
  static PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  uint8_t available : 1;
  uint8_t padfinal_[7];

 private:
  PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data();
  ~PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data() = delete;
};
static_assert(sizeof(PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data) == 16,
              "Bad sizeof(PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data)");


// static
PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data* PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data))) PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data();
}

// static
bool PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data* object = static_cast<const PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 16 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
}

void PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
}

PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data::PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kPresentationServiceClient_OnSessionStateChanged_Name = 2;

class PresentationServiceClient_OnSessionStateChanged_Params_Data {
 public:
  static PresentationServiceClient_OnSessionStateChanged_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  mojo::internal::StructPointer<internal::PresentationSessionInfo_Data> sessionInfo;
  int32_t newState;
  uint8_t padfinal_[4];

 private:
  PresentationServiceClient_OnSessionStateChanged_Params_Data();
  ~PresentationServiceClient_OnSessionStateChanged_Params_Data() = delete;
};
static_assert(sizeof(PresentationServiceClient_OnSessionStateChanged_Params_Data) == 24,
              "Bad sizeof(PresentationServiceClient_OnSessionStateChanged_Params_Data)");


// static
PresentationServiceClient_OnSessionStateChanged_Params_Data* PresentationServiceClient_OnSessionStateChanged_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationServiceClient_OnSessionStateChanged_Params_Data))) PresentationServiceClient_OnSessionStateChanged_Params_Data();
}

// static
bool PresentationServiceClient_OnSessionStateChanged_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationServiceClient_OnSessionStateChanged_Params_Data* object = static_cast<const PresentationServiceClient_OnSessionStateChanged_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!object->sessionInfo.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null sessionInfo field in PresentationServiceClient_OnSessionStateChanged_Params struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->sessionInfo.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  if (!PresentationSessionInfo::Data_::Validate(
          mojo::internal::DecodePointerRaw(&object->sessionInfo.offset),
          bounds_checker)) {
    return false;
  }

  return true;
}

void PresentationServiceClient_OnSessionStateChanged_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&sessionInfo, handles);
}

void PresentationServiceClient_OnSessionStateChanged_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&sessionInfo, handles);
}

PresentationServiceClient_OnSessionStateChanged_Params_Data::PresentationServiceClient_OnSessionStateChanged_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}


#pragma pack(pop)

}  // namespace


// static
PresentationSessionInfo_Data* PresentationSessionInfo_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationSessionInfo_Data))) PresentationSessionInfo_Data();
}

// static
bool PresentationSessionInfo_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationSessionInfo_Data* object = static_cast<const PresentationSessionInfo_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!object->url.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null url field in PresentationSessionInfo struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->url.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams url_validate_params(
      0, false, nullptr);
  if (!mojo::String::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->url.offset),
              bounds_checker, &url_validate_params)) {
    return false;
  }

  if (!object->id.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null id field in PresentationSessionInfo struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->id.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams id_validate_params(
      0, false, nullptr);
  if (!mojo::String::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->id.offset),
              bounds_checker, &id_validate_params)) {
    return false;
  }

  return true;
}

void PresentationSessionInfo_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&url, handles);
  mojo::internal::Encode(&id, handles);
}

void PresentationSessionInfo_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&url, handles);
  mojo::internal::Decode(&id, handles);
}

PresentationSessionInfo_Data::PresentationSessionInfo_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}


// static
PresentationError_Data* PresentationError_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(PresentationError_Data))) PresentationError_Data();
}

// static
bool PresentationError_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const PresentationError_Data* object = static_cast<const PresentationError_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!object->message.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null message field in PresentationError struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->message.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams message_validate_params(
      0, false, nullptr);
  if (!mojo::String::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->message.offset),
              bounds_checker, &message_validate_params)) {
    return false;
  }

  return true;
}

void PresentationError_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&message, handles);
}

void PresentationError_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&message, handles);
}

PresentationError_Data::PresentationError_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}


// static
SessionMessage_Data* SessionMessage_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(SessionMessage_Data))) SessionMessage_Data();
}

// static
bool SessionMessage_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const SessionMessage_Data* object = static_cast<const SessionMessage_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 48 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!object->presentation_url.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null presentation_url field in SessionMessage struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->presentation_url.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams presentation_url_validate_params(
      0, false, nullptr);
  if (!mojo::String::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->presentation_url.offset),
              bounds_checker, &presentation_url_validate_params)) {
    return false;
  }

  if (!object->presentation_id.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null presentation_id field in SessionMessage struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->presentation_id.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams presentation_id_validate_params(
      0, false, nullptr);
  if (!mojo::String::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->presentation_id.offset),
              bounds_checker, &presentation_id_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidateEncodedPointer(&object->message.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams message_validate_params(
      0, false, nullptr);
  if (!mojo::String::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->message.offset),
              bounds_checker, &message_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidateEncodedPointer(&object->data.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  const mojo::internal::ArrayValidateParams data_validate_params(
      0, false, nullptr);
  if (!mojo::Array<uint8_t>::Data_::Validate(
              mojo::internal::DecodePointerRaw(&object->data.offset),
              bounds_checker, &data_validate_params)) {
    return false;
  }

  return true;
}

void SessionMessage_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&presentation_url, handles);
  mojo::internal::Encode(&presentation_id, handles);
  mojo::internal::Encode(&message, handles);
  mojo::internal::Encode(&data, handles);
}

void SessionMessage_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&presentation_url, handles);
  mojo::internal::Decode(&presentation_id, handles);
  mojo::internal::Decode(&message, handles);
  mojo::internal::Decode(&data, handles);
}

SessionMessage_Data::SessionMessage_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}



}  // namespace internal// static
PresentationSessionInfoPtr PresentationSessionInfo::New() {
  PresentationSessionInfoPtr rv;
  mojo::internal::StructHelper<PresentationSessionInfo>::Initialize(&rv);
  return rv.Pass();
}

PresentationSessionInfo::PresentationSessionInfo()
    : url(),
      id() {
}

PresentationSessionInfo::~PresentationSessionInfo() {
}


PresentationSessionInfoPtr PresentationSessionInfo::Clone() const {
  PresentationSessionInfoPtr rv(New());
  rv->url = url;
  rv->id = id;
  return rv.Pass();
}


bool PresentationSessionInfo::Equals(const PresentationSessionInfo& other) const {
  if (!mojo::internal::ValueTraits<mojo::String>::Equals(this->url, other.url))
    return false;
  if (!mojo::internal::ValueTraits<mojo::String>::Equals(this->id, other.id))
    return false;
  return true;
}
// static
PresentationErrorPtr PresentationError::New() {
  PresentationErrorPtr rv;
  mojo::internal::StructHelper<PresentationError>::Initialize(&rv);
  return rv.Pass();
}

PresentationError::PresentationError()
    : error_type(),
      message() {
}

PresentationError::~PresentationError() {
}


PresentationErrorPtr PresentationError::Clone() const {
  PresentationErrorPtr rv(New());
  rv->error_type = error_type;
  rv->message = message;
  return rv.Pass();
}


bool PresentationError::Equals(const PresentationError& other) const {
  if (!mojo::internal::ValueTraits<PresentationErrorType>::Equals(this->error_type, other.error_type))
    return false;
  if (!mojo::internal::ValueTraits<mojo::String>::Equals(this->message, other.message))
    return false;
  return true;
}
// static
SessionMessagePtr SessionMessage::New() {
  SessionMessagePtr rv;
  mojo::internal::StructHelper<SessionMessage>::Initialize(&rv);
  return rv.Pass();
}

SessionMessage::SessionMessage()
    : presentation_url(),
      presentation_id(),
      type(),
      message(),
      data() {
}

SessionMessage::~SessionMessage() {
}


SessionMessagePtr SessionMessage::Clone() const {
  SessionMessagePtr rv(New());
  rv->presentation_url = presentation_url;
  rv->presentation_id = presentation_id;
  rv->type = type;
  rv->message = message;
  rv->data = data.Clone();
  return rv.Pass();
}


bool SessionMessage::Equals(const SessionMessage& other) const {
  if (!mojo::internal::ValueTraits<mojo::String>::Equals(this->presentation_url, other.presentation_url))
    return false;
  if (!mojo::internal::ValueTraits<mojo::String>::Equals(this->presentation_id, other.presentation_id))
    return false;
  if (!mojo::internal::ValueTraits<PresentationMessageType>::Equals(this->type, other.type))
    return false;
  if (!mojo::internal::ValueTraits<mojo::String>::Equals(this->message, other.message))
    return false;
  if (!mojo::internal::ValueTraits<mojo::Array<uint8_t>>::Equals(this->data, other.data))
    return false;
  return true;
}

MOJO_STATIC_CONST_MEMBER_DEFINITION const char PresentationService::Name_[] = "presentation::PresentationService";
MOJO_STATIC_CONST_MEMBER_DEFINITION const uint32_t PresentationService::Version_;
class PresentationService_ListenForDefaultSessionStart_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  PresentationService_ListenForDefaultSessionStart_ForwardToCallback(
      const PresentationService::ListenForDefaultSessionStartCallback& callback)
      : callback_(callback) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  PresentationService::ListenForDefaultSessionStartCallback callback_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(PresentationService_ListenForDefaultSessionStart_ForwardToCallback);
};
bool PresentationService_ListenForDefaultSessionStart_ForwardToCallback::Accept(
    mojo::Message* message) {
  internal::PresentationService_ListenForDefaultSessionStart_ResponseParams_Data* params =
      reinterpret_cast<internal::PresentationService_ListenForDefaultSessionStart_ResponseParams_Data*>(
          message->mutable_payload());

  params->DecodePointersAndHandles(message->mutable_handles());
  
  PresentationSessionInfoPtr p_defaultSessionInfo{};
  do {
    // NOTE: The memory backing |params| may has be smaller than
    // |sizeof(*params)| if the message comes from an older version.
    Deserialize_(params->defaultSessionInfo.ptr, &p_defaultSessionInfo);
  } while (false);
  callback_.Run(p_defaultSessionInfo.Pass());
  return true;
}
class PresentationService_StartSession_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  PresentationService_StartSession_ForwardToCallback(
      const PresentationService::StartSessionCallback& callback)
      : callback_(callback) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  PresentationService::StartSessionCallback callback_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(PresentationService_StartSession_ForwardToCallback);
};
bool PresentationService_StartSession_ForwardToCallback::Accept(
    mojo::Message* message) {
  internal::PresentationService_StartSession_ResponseParams_Data* params =
      reinterpret_cast<internal::PresentationService_StartSession_ResponseParams_Data*>(
          message->mutable_payload());

  params->DecodePointersAndHandles(message->mutable_handles());
  
  PresentationSessionInfoPtr p_sessionInfo{};
  PresentationErrorPtr p_error{};
  do {
    // NOTE: The memory backing |params| may has be smaller than
    // |sizeof(*params)| if the message comes from an older version.
    Deserialize_(params->sessionInfo.ptr, &p_sessionInfo);
    Deserialize_(params->error.ptr, &p_error);
  } while (false);
  callback_.Run(p_sessionInfo.Pass(), p_error.Pass());
  return true;
}
class PresentationService_JoinSession_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  PresentationService_JoinSession_ForwardToCallback(
      const PresentationService::JoinSessionCallback& callback)
      : callback_(callback) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  PresentationService::JoinSessionCallback callback_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(PresentationService_JoinSession_ForwardToCallback);
};
bool PresentationService_JoinSession_ForwardToCallback::Accept(
    mojo::Message* message) {
  internal::PresentationService_JoinSession_ResponseParams_Data* params =
      reinterpret_cast<internal::PresentationService_JoinSession_ResponseParams_Data*>(
          message->mutable_payload());

  params->DecodePointersAndHandles(message->mutable_handles());
  
  PresentationSessionInfoPtr p_sessionInfo{};
  PresentationErrorPtr p_error{};
  do {
    // NOTE: The memory backing |params| may has be smaller than
    // |sizeof(*params)| if the message comes from an older version.
    Deserialize_(params->sessionInfo.ptr, &p_sessionInfo);
    Deserialize_(params->error.ptr, &p_error);
  } while (false);
  callback_.Run(p_sessionInfo.Pass(), p_error.Pass());
  return true;
}
class PresentationService_SendSessionMessage_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  PresentationService_SendSessionMessage_ForwardToCallback(
      const PresentationService::SendSessionMessageCallback& callback)
      : callback_(callback) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  PresentationService::SendSessionMessageCallback callback_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(PresentationService_SendSessionMessage_ForwardToCallback);
};
bool PresentationService_SendSessionMessage_ForwardToCallback::Accept(
    mojo::Message* message) {
  internal::PresentationService_SendSessionMessage_ResponseParams_Data* params =
      reinterpret_cast<internal::PresentationService_SendSessionMessage_ResponseParams_Data*>(
          message->mutable_payload());

  params->DecodePointersAndHandles(message->mutable_handles());
  
  bool p_success{};
  do {
    // NOTE: The memory backing |params| may has be smaller than
    // |sizeof(*params)| if the message comes from an older version.
    p_success = params->success;
  } while (false);
  callback_.Run(p_success);
  return true;
}
class PresentationService_ListenForSessionMessages_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  PresentationService_ListenForSessionMessages_ForwardToCallback(
      const PresentationService::ListenForSessionMessagesCallback& callback)
      : callback_(callback) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  PresentationService::ListenForSessionMessagesCallback callback_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(PresentationService_ListenForSessionMessages_ForwardToCallback);
};
bool PresentationService_ListenForSessionMessages_ForwardToCallback::Accept(
    mojo::Message* message) {
  internal::PresentationService_ListenForSessionMessages_ResponseParams_Data* params =
      reinterpret_cast<internal::PresentationService_ListenForSessionMessages_ResponseParams_Data*>(
          message->mutable_payload());

  params->DecodePointersAndHandles(message->mutable_handles());
  
  mojo::Array<SessionMessagePtr> p_messages{};
  do {
    // NOTE: The memory backing |params| may has be smaller than
    // |sizeof(*params)| if the message comes from an older version.
    Deserialize_(params->messages.ptr, &p_messages);
  } while (false);
  callback_.Run(p_messages.Pass());
  return true;
}

PresentationServiceProxy::PresentationServiceProxy(mojo::MessageReceiverWithResponder* receiver)
    : ControlMessageProxy(receiver) {
}
void PresentationServiceProxy::SetDefaultPresentationURL(
    const mojo::String& in_default_presentation_url, const mojo::String& in_default_presentation_id) {
  size_t size = sizeof(internal::PresentationService_SetDefaultPresentationURL_Params_Data);
  size += GetSerializedSize_(in_default_presentation_url);
  size += GetSerializedSize_(in_default_presentation_id);
  mojo::internal::MessageBuilder builder(internal::kPresentationService_SetDefaultPresentationURL_Name, size);

  internal::PresentationService_SetDefaultPresentationURL_Params_Data* params =
      internal::PresentationService_SetDefaultPresentationURL_Params_Data::New(builder.buffer());
  Serialize_(mojo::internal::Forward(in_default_presentation_url), builder.buffer(), &params->default_presentation_url.ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->default_presentation_url.ptr,
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null default_presentation_url in PresentationService.SetDefaultPresentationURL request");
  Serialize_(mojo::internal::Forward(in_default_presentation_id), builder.buffer(), &params->default_presentation_id.ptr);
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = receiver_->Accept(&message);
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  MOJO_ALLOW_UNUSED_LOCAL(ok);
}
void PresentationServiceProxy::SetClient(
    PresentationServiceClientPtr in_client) {
  size_t size = sizeof(internal::PresentationService_SetClient_Params_Data);
  mojo::internal::MessageBuilder builder(internal::kPresentationService_SetClient_Name, size);

  internal::PresentationService_SetClient_Params_Data* params =
      internal::PresentationService_SetClient_Params_Data::New(builder.buffer());
  mojo::internal::InterfacePointerToData(in_client.Pass(), &params->client);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->client.handle.is_valid(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client in PresentationService.SetClient request");
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = receiver_->Accept(&message);
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  MOJO_ALLOW_UNUSED_LOCAL(ok);
}
void PresentationServiceProxy::ListenForScreenAvailability(
    ) {
  size_t size = sizeof(internal::PresentationService_ListenForScreenAvailability_Params_Data);
  mojo::internal::MessageBuilder builder(internal::kPresentationService_ListenForScreenAvailability_Name, size);

  internal::PresentationService_ListenForScreenAvailability_Params_Data* params =
      internal::PresentationService_ListenForScreenAvailability_Params_Data::New(builder.buffer());
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = receiver_->Accept(&message);
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  MOJO_ALLOW_UNUSED_LOCAL(ok);
}
void PresentationServiceProxy::StopListeningForScreenAvailability(
    ) {
  size_t size = sizeof(internal::PresentationService_StopListeningForScreenAvailability_Params_Data);
  mojo::internal::MessageBuilder builder(internal::kPresentationService_StopListeningForScreenAvailability_Name, size);

  internal::PresentationService_StopListeningForScreenAvailability_Params_Data* params =
      internal::PresentationService_StopListeningForScreenAvailability_Params_Data::New(builder.buffer());
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = receiver_->Accept(&message);
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  MOJO_ALLOW_UNUSED_LOCAL(ok);
}
void PresentationServiceProxy::ListenForDefaultSessionStart(
    const ListenForDefaultSessionStartCallback& callback) {
  size_t size = sizeof(internal::PresentationService_ListenForDefaultSessionStart_Params_Data);
  mojo::internal::RequestMessageBuilder builder(internal::kPresentationService_ListenForDefaultSessionStart_Name, size);

  internal::PresentationService_ListenForDefaultSessionStart_Params_Data* params =
      internal::PresentationService_ListenForDefaultSessionStart_Params_Data::New(builder.buffer());
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  mojo::MessageReceiver* responder =
      new PresentationService_ListenForDefaultSessionStart_ForwardToCallback(callback);
  if (!receiver_->AcceptWithResponder(&message, responder))
    delete responder;
}
void PresentationServiceProxy::StartSession(
    const mojo::String& in_presentation_url, const StartSessionCallback& callback) {
  size_t size = sizeof(internal::PresentationService_StartSession_Params_Data);
  size += GetSerializedSize_(in_presentation_url);
  mojo::internal::RequestMessageBuilder builder(internal::kPresentationService_StartSession_Name, size);

  internal::PresentationService_StartSession_Params_Data* params =
      internal::PresentationService_StartSession_Params_Data::New(builder.buffer());
  Serialize_(mojo::internal::Forward(in_presentation_url), builder.buffer(), &params->presentation_url.ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->presentation_url.ptr,
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null presentation_url in PresentationService.StartSession request");
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  mojo::MessageReceiver* responder =
      new PresentationService_StartSession_ForwardToCallback(callback);
  if (!receiver_->AcceptWithResponder(&message, responder))
    delete responder;
}
void PresentationServiceProxy::JoinSession(
    const mojo::String& in_presentation_url, const mojo::String& in_presentation_id, const JoinSessionCallback& callback) {
  size_t size = sizeof(internal::PresentationService_JoinSession_Params_Data);
  size += GetSerializedSize_(in_presentation_url);
  size += GetSerializedSize_(in_presentation_id);
  mojo::internal::RequestMessageBuilder builder(internal::kPresentationService_JoinSession_Name, size);

  internal::PresentationService_JoinSession_Params_Data* params =
      internal::PresentationService_JoinSession_Params_Data::New(builder.buffer());
  Serialize_(mojo::internal::Forward(in_presentation_url), builder.buffer(), &params->presentation_url.ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->presentation_url.ptr,
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null presentation_url in PresentationService.JoinSession request");
  Serialize_(mojo::internal::Forward(in_presentation_id), builder.buffer(), &params->presentation_id.ptr);
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  mojo::MessageReceiver* responder =
      new PresentationService_JoinSession_ForwardToCallback(callback);
  if (!receiver_->AcceptWithResponder(&message, responder))
    delete responder;
}
void PresentationServiceProxy::SendSessionMessage(
    SessionMessagePtr in_message_request, const SendSessionMessageCallback& callback) {
  size_t size = sizeof(internal::PresentationService_SendSessionMessage_Params_Data);
  size += GetSerializedSize_(in_message_request);
  mojo::internal::RequestMessageBuilder builder(internal::kPresentationService_SendSessionMessage_Name, size);

  internal::PresentationService_SendSessionMessage_Params_Data* params =
      internal::PresentationService_SendSessionMessage_Params_Data::New(builder.buffer());
  Serialize_(mojo::internal::Forward(in_message_request), builder.buffer(), &params->message_request.ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->message_request.ptr,
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null message_request in PresentationService.SendSessionMessage request");
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  mojo::MessageReceiver* responder =
      new PresentationService_SendSessionMessage_ForwardToCallback(callback);
  if (!receiver_->AcceptWithResponder(&message, responder))
    delete responder;
}
void PresentationServiceProxy::CloseSession(
    const mojo::String& in_presentation_url, const mojo::String& in_presentation_id) {
  size_t size = sizeof(internal::PresentationService_CloseSession_Params_Data);
  size += GetSerializedSize_(in_presentation_url);
  size += GetSerializedSize_(in_presentation_id);
  mojo::internal::MessageBuilder builder(internal::kPresentationService_CloseSession_Name, size);

  internal::PresentationService_CloseSession_Params_Data* params =
      internal::PresentationService_CloseSession_Params_Data::New(builder.buffer());
  Serialize_(mojo::internal::Forward(in_presentation_url), builder.buffer(), &params->presentation_url.ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->presentation_url.ptr,
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null presentation_url in PresentationService.CloseSession request");
  Serialize_(mojo::internal::Forward(in_presentation_id), builder.buffer(), &params->presentation_id.ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->presentation_id.ptr,
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null presentation_id in PresentationService.CloseSession request");
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = receiver_->Accept(&message);
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  MOJO_ALLOW_UNUSED_LOCAL(ok);
}
void PresentationServiceProxy::ListenForSessionStateChange(
    ) {
  size_t size = sizeof(internal::PresentationService_ListenForSessionStateChange_Params_Data);
  mojo::internal::MessageBuilder builder(internal::kPresentationService_ListenForSessionStateChange_Name, size);

  internal::PresentationService_ListenForSessionStateChange_Params_Data* params =
      internal::PresentationService_ListenForSessionStateChange_Params_Data::New(builder.buffer());
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = receiver_->Accept(&message);
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  MOJO_ALLOW_UNUSED_LOCAL(ok);
}
void PresentationServiceProxy::ListenForSessionMessages(
    const ListenForSessionMessagesCallback& callback) {
  size_t size = sizeof(internal::PresentationService_ListenForSessionMessages_Params_Data);
  mojo::internal::RequestMessageBuilder builder(internal::kPresentationService_ListenForSessionMessages_Name, size);

  internal::PresentationService_ListenForSessionMessages_Params_Data* params =
      internal::PresentationService_ListenForSessionMessages_Params_Data::New(builder.buffer());
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  mojo::MessageReceiver* responder =
      new PresentationService_ListenForSessionMessages_ForwardToCallback(callback);
  if (!receiver_->AcceptWithResponder(&message, responder))
    delete responder;
}
class PresentationService_ListenForDefaultSessionStart_ProxyToResponder
    : public PresentationService::ListenForDefaultSessionStartCallback::Runnable {
 public:
  ~PresentationService_ListenForDefaultSessionStart_ProxyToResponder() override {
    // Is the Mojo application destroying the callback without running it
    // and without first closing the pipe?
    bool callback_was_dropped = responder_ && responder_->IsValid();
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    delete responder_;
    MOJO_DCHECK(!callback_was_dropped)  << "The callback passed to "
        "PresentationService::ListenForDefaultSessionStart(callback) "
        "was never run.";
  }

  PresentationService_ListenForDefaultSessionStart_ProxyToResponder(
      uint64_t request_id,
      mojo::MessageReceiverWithStatus* responder)
      : request_id_(request_id),
        responder_(responder) {
  }

  void Run(PresentationSessionInfoPtr in_defaultSessionInfo) const override;

 private:
  uint64_t request_id_;
  mutable mojo::MessageReceiverWithStatus* responder_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(PresentationService_ListenForDefaultSessionStart_ProxyToResponder);
};
void PresentationService_ListenForDefaultSessionStart_ProxyToResponder::Run(
    PresentationSessionInfoPtr in_defaultSessionInfo) const {
  size_t size = sizeof(internal::PresentationService_ListenForDefaultSessionStart_ResponseParams_Data);
  size += GetSerializedSize_(in_defaultSessionInfo);
  mojo::internal::ResponseMessageBuilder builder(
      internal::kPresentationService_ListenForDefaultSessionStart_Name, size, request_id_);
  internal::PresentationService_ListenForDefaultSessionStart_ResponseParams_Data* params =
      internal::PresentationService_ListenForDefaultSessionStart_ResponseParams_Data::New(builder.buffer());
  Serialize_(mojo::internal::Forward(in_defaultSessionInfo), builder.buffer(), &params->defaultSessionInfo.ptr);
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = responder_->Accept(&message);
  MOJO_ALLOW_UNUSED_LOCAL(ok);
  // TODO(darin): !ok returned here indicates a malformed message, and that may
  // be good reason to close the connection. However, we don't have a way to do
  // that from here. We should add a way.
  delete responder_;
  responder_ = nullptr;
}
class PresentationService_StartSession_ProxyToResponder
    : public PresentationService::StartSessionCallback::Runnable {
 public:
  ~PresentationService_StartSession_ProxyToResponder() override {
    // Is the Mojo application destroying the callback without running it
    // and without first closing the pipe?
    bool callback_was_dropped = responder_ && responder_->IsValid();
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    delete responder_;
    MOJO_DCHECK(!callback_was_dropped)  << "The callback passed to "
        "PresentationService::StartSession(p_presentation_url, callback) "
        "was never run.";
  }

  PresentationService_StartSession_ProxyToResponder(
      uint64_t request_id,
      mojo::MessageReceiverWithStatus* responder)
      : request_id_(request_id),
        responder_(responder) {
  }

  void Run(PresentationSessionInfoPtr in_sessionInfo, PresentationErrorPtr in_error) const override;

 private:
  uint64_t request_id_;
  mutable mojo::MessageReceiverWithStatus* responder_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(PresentationService_StartSession_ProxyToResponder);
};
void PresentationService_StartSession_ProxyToResponder::Run(
    PresentationSessionInfoPtr in_sessionInfo, PresentationErrorPtr in_error) const {
  size_t size = sizeof(internal::PresentationService_StartSession_ResponseParams_Data);
  size += GetSerializedSize_(in_sessionInfo);
  size += GetSerializedSize_(in_error);
  mojo::internal::ResponseMessageBuilder builder(
      internal::kPresentationService_StartSession_Name, size, request_id_);
  internal::PresentationService_StartSession_ResponseParams_Data* params =
      internal::PresentationService_StartSession_ResponseParams_Data::New(builder.buffer());
  Serialize_(mojo::internal::Forward(in_sessionInfo), builder.buffer(), &params->sessionInfo.ptr);
  Serialize_(mojo::internal::Forward(in_error), builder.buffer(), &params->error.ptr);
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = responder_->Accept(&message);
  MOJO_ALLOW_UNUSED_LOCAL(ok);
  // TODO(darin): !ok returned here indicates a malformed message, and that may
  // be good reason to close the connection. However, we don't have a way to do
  // that from here. We should add a way.
  delete responder_;
  responder_ = nullptr;
}
class PresentationService_JoinSession_ProxyToResponder
    : public PresentationService::JoinSessionCallback::Runnable {
 public:
  ~PresentationService_JoinSession_ProxyToResponder() override {
    // Is the Mojo application destroying the callback without running it
    // and without first closing the pipe?
    bool callback_was_dropped = responder_ && responder_->IsValid();
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    delete responder_;
    MOJO_DCHECK(!callback_was_dropped)  << "The callback passed to "
        "PresentationService::JoinSession(p_presentation_url, p_presentation_id, callback) "
        "was never run.";
  }

  PresentationService_JoinSession_ProxyToResponder(
      uint64_t request_id,
      mojo::MessageReceiverWithStatus* responder)
      : request_id_(request_id),
        responder_(responder) {
  }

  void Run(PresentationSessionInfoPtr in_sessionInfo, PresentationErrorPtr in_error) const override;

 private:
  uint64_t request_id_;
  mutable mojo::MessageReceiverWithStatus* responder_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(PresentationService_JoinSession_ProxyToResponder);
};
void PresentationService_JoinSession_ProxyToResponder::Run(
    PresentationSessionInfoPtr in_sessionInfo, PresentationErrorPtr in_error) const {
  size_t size = sizeof(internal::PresentationService_JoinSession_ResponseParams_Data);
  size += GetSerializedSize_(in_sessionInfo);
  size += GetSerializedSize_(in_error);
  mojo::internal::ResponseMessageBuilder builder(
      internal::kPresentationService_JoinSession_Name, size, request_id_);
  internal::PresentationService_JoinSession_ResponseParams_Data* params =
      internal::PresentationService_JoinSession_ResponseParams_Data::New(builder.buffer());
  Serialize_(mojo::internal::Forward(in_sessionInfo), builder.buffer(), &params->sessionInfo.ptr);
  Serialize_(mojo::internal::Forward(in_error), builder.buffer(), &params->error.ptr);
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = responder_->Accept(&message);
  MOJO_ALLOW_UNUSED_LOCAL(ok);
  // TODO(darin): !ok returned here indicates a malformed message, and that may
  // be good reason to close the connection. However, we don't have a way to do
  // that from here. We should add a way.
  delete responder_;
  responder_ = nullptr;
}
class PresentationService_SendSessionMessage_ProxyToResponder
    : public PresentationService::SendSessionMessageCallback::Runnable {
 public:
  ~PresentationService_SendSessionMessage_ProxyToResponder() override {
    // Is the Mojo application destroying the callback without running it
    // and without first closing the pipe?
    bool callback_was_dropped = responder_ && responder_->IsValid();
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    delete responder_;
    MOJO_DCHECK(!callback_was_dropped)  << "The callback passed to "
        "PresentationService::SendSessionMessage(p_message_request.Pass(), callback) "
        "was never run.";
  }

  PresentationService_SendSessionMessage_ProxyToResponder(
      uint64_t request_id,
      mojo::MessageReceiverWithStatus* responder)
      : request_id_(request_id),
        responder_(responder) {
  }

  void Run(bool in_success) const override;

 private:
  uint64_t request_id_;
  mutable mojo::MessageReceiverWithStatus* responder_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(PresentationService_SendSessionMessage_ProxyToResponder);
};
void PresentationService_SendSessionMessage_ProxyToResponder::Run(
    bool in_success) const {
  size_t size = sizeof(internal::PresentationService_SendSessionMessage_ResponseParams_Data);
  mojo::internal::ResponseMessageBuilder builder(
      internal::kPresentationService_SendSessionMessage_Name, size, request_id_);
  internal::PresentationService_SendSessionMessage_ResponseParams_Data* params =
      internal::PresentationService_SendSessionMessage_ResponseParams_Data::New(builder.buffer());
  params->success = in_success;
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = responder_->Accept(&message);
  MOJO_ALLOW_UNUSED_LOCAL(ok);
  // TODO(darin): !ok returned here indicates a malformed message, and that may
  // be good reason to close the connection. However, we don't have a way to do
  // that from here. We should add a way.
  delete responder_;
  responder_ = nullptr;
}
class PresentationService_ListenForSessionMessages_ProxyToResponder
    : public PresentationService::ListenForSessionMessagesCallback::Runnable {
 public:
  ~PresentationService_ListenForSessionMessages_ProxyToResponder() override {
    // Is the Mojo application destroying the callback without running it
    // and without first closing the pipe?
    bool callback_was_dropped = responder_ && responder_->IsValid();
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    delete responder_;
    MOJO_DCHECK(!callback_was_dropped)  << "The callback passed to "
        "PresentationService::ListenForSessionMessages(callback) "
        "was never run.";
  }

  PresentationService_ListenForSessionMessages_ProxyToResponder(
      uint64_t request_id,
      mojo::MessageReceiverWithStatus* responder)
      : request_id_(request_id),
        responder_(responder) {
  }

  void Run(mojo::Array<SessionMessagePtr> in_messages) const override;

 private:
  uint64_t request_id_;
  mutable mojo::MessageReceiverWithStatus* responder_;
  MOJO_DISALLOW_COPY_AND_ASSIGN(PresentationService_ListenForSessionMessages_ProxyToResponder);
};
void PresentationService_ListenForSessionMessages_ProxyToResponder::Run(
    mojo::Array<SessionMessagePtr> in_messages) const {
  size_t size = sizeof(internal::PresentationService_ListenForSessionMessages_ResponseParams_Data);
  size += GetSerializedSize_(in_messages);
  mojo::internal::ResponseMessageBuilder builder(
      internal::kPresentationService_ListenForSessionMessages_Name, size, request_id_);
  internal::PresentationService_ListenForSessionMessages_ResponseParams_Data* params =
      internal::PresentationService_ListenForSessionMessages_ResponseParams_Data::New(builder.buffer());
  const mojo::internal::ArrayValidateParams messages_validate_params(
      0, false, nullptr);
  mojo::SerializeArray_(mojo::internal::Forward(in_messages), builder.buffer(),
      &params->messages.ptr, &messages_validate_params);
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = responder_->Accept(&message);
  MOJO_ALLOW_UNUSED_LOCAL(ok);
  // TODO(darin): !ok returned here indicates a malformed message, and that may
  // be good reason to close the connection. However, we don't have a way to do
  // that from here. We should add a way.
  delete responder_;
  responder_ = nullptr;
}

PresentationServiceStub::PresentationServiceStub()
    : sink_(nullptr),
      control_message_handler_(PresentationService::Version_) {
}

PresentationServiceStub::~PresentationServiceStub() {}

bool PresentationServiceStub::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return control_message_handler_.Accept(message);
  switch (message->header()->name) {
    case internal::kPresentationService_SetDefaultPresentationURL_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.presentation.PresentationService.SetDefaultPresentationURL", __FILE__, __LINE__);
      internal::PresentationService_SetDefaultPresentationURL_Params_Data* params =
          reinterpret_cast<internal::PresentationService_SetDefaultPresentationURL_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      
      mojo::String p_default_presentation_url{};
      mojo::String p_default_presentation_id{};
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
        Deserialize_(params->default_presentation_url.ptr, &p_default_presentation_url);
        Deserialize_(params->default_presentation_id.ptr, &p_default_presentation_id);
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->SetDefaultPresentationURL(p_default_presentation_url, p_default_presentation_id);
      return true;
    }
    case internal::kPresentationService_SetClient_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.presentation.PresentationService.SetClient", __FILE__, __LINE__);
      internal::PresentationService_SetClient_Params_Data* params =
          reinterpret_cast<internal::PresentationService_SetClient_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      
      PresentationServiceClientPtr p_client{};
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
        mojo::internal::InterfaceDataToPointer(&params->client, &p_client);
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->SetClient(p_client.Pass());
      return true;
    }
    case internal::kPresentationService_ListenForScreenAvailability_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.presentation.PresentationService.ListenForScreenAvailability", __FILE__, __LINE__);
      internal::PresentationService_ListenForScreenAvailability_Params_Data* params =
          reinterpret_cast<internal::PresentationService_ListenForScreenAvailability_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->ListenForScreenAvailability();
      return true;
    }
    case internal::kPresentationService_StopListeningForScreenAvailability_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.presentation.PresentationService.StopListeningForScreenAvailability", __FILE__, __LINE__);
      internal::PresentationService_StopListeningForScreenAvailability_Params_Data* params =
          reinterpret_cast<internal::PresentationService_StopListeningForScreenAvailability_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->StopListeningForScreenAvailability();
      return true;
    }
    case internal::kPresentationService_ListenForDefaultSessionStart_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.presentation.PresentationService.ListenForDefaultSessionStart", __FILE__, __LINE__);
      break;
    }
    case internal::kPresentationService_StartSession_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.presentation.PresentationService.StartSession", __FILE__, __LINE__);
      break;
    }
    case internal::kPresentationService_JoinSession_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.presentation.PresentationService.JoinSession", __FILE__, __LINE__);
      break;
    }
    case internal::kPresentationService_SendSessionMessage_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.presentation.PresentationService.SendSessionMessage", __FILE__, __LINE__);
      break;
    }
    case internal::kPresentationService_CloseSession_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.presentation.PresentationService.CloseSession", __FILE__, __LINE__);
      internal::PresentationService_CloseSession_Params_Data* params =
          reinterpret_cast<internal::PresentationService_CloseSession_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      
      mojo::String p_presentation_url{};
      mojo::String p_presentation_id{};
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
        Deserialize_(params->presentation_url.ptr, &p_presentation_url);
        Deserialize_(params->presentation_id.ptr, &p_presentation_id);
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->CloseSession(p_presentation_url, p_presentation_id);
      return true;
    }
    case internal::kPresentationService_ListenForSessionStateChange_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.presentation.PresentationService.ListenForSessionStateChange", __FILE__, __LINE__);
      internal::PresentationService_ListenForSessionStateChange_Params_Data* params =
          reinterpret_cast<internal::PresentationService_ListenForSessionStateChange_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->ListenForSessionStateChange();
      return true;
    }
    case internal::kPresentationService_ListenForSessionMessages_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.presentation.PresentationService.ListenForSessionMessages", __FILE__, __LINE__);
      break;
    }
  }
  return false;
}

bool PresentationServiceStub::AcceptWithResponder(
    mojo::Message* message, mojo::MessageReceiverWithStatus* responder) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return control_message_handler_.AcceptWithResponder(message, responder);
  switch (message->header()->name) {
    case internal::kPresentationService_SetDefaultPresentationURL_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::presentation::PresentationService::SetDefaultPresentationURL", __FILE__, __LINE__);
      break;
    }
    case internal::kPresentationService_SetClient_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::presentation::PresentationService::SetClient", __FILE__, __LINE__);
      break;
    }
    case internal::kPresentationService_ListenForScreenAvailability_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::presentation::PresentationService::ListenForScreenAvailability", __FILE__, __LINE__);
      break;
    }
    case internal::kPresentationService_StopListeningForScreenAvailability_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::presentation::PresentationService::StopListeningForScreenAvailability", __FILE__, __LINE__);
      break;
    }
    case internal::kPresentationService_ListenForDefaultSessionStart_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::presentation::PresentationService::ListenForDefaultSessionStart", __FILE__, __LINE__);
      internal::PresentationService_ListenForDefaultSessionStart_Params_Data* params =
          reinterpret_cast<internal::PresentationService_ListenForDefaultSessionStart_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      PresentationService::ListenForDefaultSessionStartCallback::Runnable* runnable =
          new PresentationService_ListenForDefaultSessionStart_ProxyToResponder(
              message->request_id(), responder);
      PresentationService::ListenForDefaultSessionStartCallback callback(runnable);
      
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->ListenForDefaultSessionStart(callback);
      return true;
    }
    case internal::kPresentationService_StartSession_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::presentation::PresentationService::StartSession", __FILE__, __LINE__);
      internal::PresentationService_StartSession_Params_Data* params =
          reinterpret_cast<internal::PresentationService_StartSession_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      PresentationService::StartSessionCallback::Runnable* runnable =
          new PresentationService_StartSession_ProxyToResponder(
              message->request_id(), responder);
      PresentationService::StartSessionCallback callback(runnable);
      
      mojo::String p_presentation_url{};
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
        Deserialize_(params->presentation_url.ptr, &p_presentation_url);
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->StartSession(p_presentation_url, callback);
      return true;
    }
    case internal::kPresentationService_JoinSession_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::presentation::PresentationService::JoinSession", __FILE__, __LINE__);
      internal::PresentationService_JoinSession_Params_Data* params =
          reinterpret_cast<internal::PresentationService_JoinSession_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      PresentationService::JoinSessionCallback::Runnable* runnable =
          new PresentationService_JoinSession_ProxyToResponder(
              message->request_id(), responder);
      PresentationService::JoinSessionCallback callback(runnable);
      
      mojo::String p_presentation_url{};
      mojo::String p_presentation_id{};
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
        Deserialize_(params->presentation_url.ptr, &p_presentation_url);
        Deserialize_(params->presentation_id.ptr, &p_presentation_id);
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->JoinSession(p_presentation_url, p_presentation_id, callback);
      return true;
    }
    case internal::kPresentationService_SendSessionMessage_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::presentation::PresentationService::SendSessionMessage", __FILE__, __LINE__);
      internal::PresentationService_SendSessionMessage_Params_Data* params =
          reinterpret_cast<internal::PresentationService_SendSessionMessage_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      PresentationService::SendSessionMessageCallback::Runnable* runnable =
          new PresentationService_SendSessionMessage_ProxyToResponder(
              message->request_id(), responder);
      PresentationService::SendSessionMessageCallback callback(runnable);
      
      SessionMessagePtr p_message_request{};
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
        Deserialize_(params->message_request.ptr, &p_message_request);
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->SendSessionMessage(p_message_request.Pass(), callback);
      return true;
    }
    case internal::kPresentationService_CloseSession_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::presentation::PresentationService::CloseSession", __FILE__, __LINE__);
      break;
    }
    case internal::kPresentationService_ListenForSessionStateChange_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::presentation::PresentationService::ListenForSessionStateChange", __FILE__, __LINE__);
      break;
    }
    case internal::kPresentationService_ListenForSessionMessages_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::presentation::PresentationService::ListenForSessionMessages", __FILE__, __LINE__);
      internal::PresentationService_ListenForSessionMessages_Params_Data* params =
          reinterpret_cast<internal::PresentationService_ListenForSessionMessages_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      PresentationService::ListenForSessionMessagesCallback::Runnable* runnable =
          new PresentationService_ListenForSessionMessages_ProxyToResponder(
              message->request_id(), responder);
      PresentationService::ListenForSessionMessagesCallback callback(runnable);
      
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->ListenForSessionMessages(callback);
      return true;
    }
  }
  return false;
}

PresentationServiceRequestValidator::PresentationServiceRequestValidator(
    mojo::MessageReceiver* sink) : MessageFilter(sink) {
}

bool PresentationServiceRequestValidator::Accept(mojo::Message* message) {
  assert(sink_);

  if (mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    if (!mojo::internal::ValidateControlRequest(message))
      return false;
    return sink_->Accept(message);
  }

  switch (message->header()->name) {
    case internal::kPresentationService_SetDefaultPresentationURL_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationService_SetDefaultPresentationURL_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kPresentationService_SetClient_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationService_SetClient_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kPresentationService_ListenForScreenAvailability_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationService_ListenForScreenAvailability_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kPresentationService_StopListeningForScreenAvailability_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationService_StopListeningForScreenAvailability_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kPresentationService_ListenForDefaultSessionStart_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationService_ListenForDefaultSessionStart_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kPresentationService_StartSession_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationService_StartSession_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kPresentationService_JoinSession_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationService_JoinSession_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kPresentationService_SendSessionMessage_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationService_SendSessionMessage_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kPresentationService_CloseSession_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationService_CloseSession_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kPresentationService_ListenForSessionStateChange_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationService_ListenForSessionStateChange_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kPresentationService_ListenForSessionMessages_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationService_ListenForSessionMessages_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

PresentationServiceResponseValidator::PresentationServiceResponseValidator(
    mojo::MessageReceiver* sink) : MessageFilter(sink) {
}

bool PresentationServiceResponseValidator::Accept(mojo::Message* message) {
  assert(sink_);

  if (mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    if (!mojo::internal::ValidateControlResponse(message))
      return false;
    return sink_->Accept(message);
  }

  if (!mojo::internal::ValidateMessageIsResponse(message))
    return false;
  switch (message->header()->name) {
    case internal::kPresentationService_ListenForDefaultSessionStart_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationService_ListenForDefaultSessionStart_ResponseParams_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kPresentationService_StartSession_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationService_StartSession_ResponseParams_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kPresentationService_JoinSession_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationService_JoinSession_ResponseParams_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kPresentationService_SendSessionMessage_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationService_SendSessionMessage_ResponseParams_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kPresentationService_ListenForSessionMessages_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationService_ListenForSessionMessages_ResponseParams_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
MOJO_STATIC_CONST_MEMBER_DEFINITION const char PresentationServiceClient::Name_[] = "presentation::PresentationServiceClient";
MOJO_STATIC_CONST_MEMBER_DEFINITION const uint32_t PresentationServiceClient::Version_;

PresentationServiceClientProxy::PresentationServiceClientProxy(mojo::MessageReceiverWithResponder* receiver)
    : ControlMessageProxy(receiver) {
}
void PresentationServiceClientProxy::OnScreenAvailabilityNotSupported(
    ) {
  size_t size = sizeof(internal::PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data);
  mojo::internal::MessageBuilder builder(internal::kPresentationServiceClient_OnScreenAvailabilityNotSupported_Name, size);

  internal::PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data* params =
      internal::PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data::New(builder.buffer());
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = receiver_->Accept(&message);
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  MOJO_ALLOW_UNUSED_LOCAL(ok);
}
void PresentationServiceClientProxy::OnScreenAvailabilityUpdated(
    bool in_available) {
  size_t size = sizeof(internal::PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data);
  mojo::internal::MessageBuilder builder(internal::kPresentationServiceClient_OnScreenAvailabilityUpdated_Name, size);

  internal::PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data* params =
      internal::PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data::New(builder.buffer());
  params->available = in_available;
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = receiver_->Accept(&message);
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  MOJO_ALLOW_UNUSED_LOCAL(ok);
}
void PresentationServiceClientProxy::OnSessionStateChanged(
    PresentationSessionInfoPtr in_sessionInfo, PresentationSessionState in_newState) {
  size_t size = sizeof(internal::PresentationServiceClient_OnSessionStateChanged_Params_Data);
  size += GetSerializedSize_(in_sessionInfo);
  mojo::internal::MessageBuilder builder(internal::kPresentationServiceClient_OnSessionStateChanged_Name, size);

  internal::PresentationServiceClient_OnSessionStateChanged_Params_Data* params =
      internal::PresentationServiceClient_OnSessionStateChanged_Params_Data::New(builder.buffer());
  Serialize_(mojo::internal::Forward(in_sessionInfo), builder.buffer(), &params->sessionInfo.ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->sessionInfo.ptr,
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null sessionInfo in PresentationServiceClient.OnSessionStateChanged request");
  params->newState = in_newState;
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = receiver_->Accept(&message);
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  MOJO_ALLOW_UNUSED_LOCAL(ok);
}

PresentationServiceClientStub::PresentationServiceClientStub()
    : sink_(nullptr),
      control_message_handler_(PresentationServiceClient::Version_) {
}

PresentationServiceClientStub::~PresentationServiceClientStub() {}

bool PresentationServiceClientStub::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return control_message_handler_.Accept(message);
  switch (message->header()->name) {
    case internal::kPresentationServiceClient_OnScreenAvailabilityNotSupported_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.presentation.PresentationServiceClient.OnScreenAvailabilityNotSupported", __FILE__, __LINE__);
      internal::PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data* params =
          reinterpret_cast<internal::PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->OnScreenAvailabilityNotSupported();
      return true;
    }
    case internal::kPresentationServiceClient_OnScreenAvailabilityUpdated_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.presentation.PresentationServiceClient.OnScreenAvailabilityUpdated", __FILE__, __LINE__);
      internal::PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data* params =
          reinterpret_cast<internal::PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      
      bool p_available{};
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
        p_available = params->available;
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->OnScreenAvailabilityUpdated(p_available);
      return true;
    }
    case internal::kPresentationServiceClient_OnSessionStateChanged_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.presentation.PresentationServiceClient.OnSessionStateChanged", __FILE__, __LINE__);
      internal::PresentationServiceClient_OnSessionStateChanged_Params_Data* params =
          reinterpret_cast<internal::PresentationServiceClient_OnSessionStateChanged_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      
      PresentationSessionInfoPtr p_sessionInfo{};
      PresentationSessionState p_newState{};
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
        Deserialize_(params->sessionInfo.ptr, &p_sessionInfo);
        p_newState = static_cast<PresentationSessionState>(params->newState);
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->OnSessionStateChanged(p_sessionInfo.Pass(), p_newState);
      return true;
    }
  }
  return false;
}

bool PresentationServiceClientStub::AcceptWithResponder(
    mojo::Message* message, mojo::MessageReceiverWithStatus* responder) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return control_message_handler_.AcceptWithResponder(message, responder);
  switch (message->header()->name) {
    case internal::kPresentationServiceClient_OnScreenAvailabilityNotSupported_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::presentation::PresentationServiceClient::OnScreenAvailabilityNotSupported", __FILE__, __LINE__);
      break;
    }
    case internal::kPresentationServiceClient_OnScreenAvailabilityUpdated_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::presentation::PresentationServiceClient::OnScreenAvailabilityUpdated", __FILE__, __LINE__);
      break;
    }
    case internal::kPresentationServiceClient_OnSessionStateChanged_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::presentation::PresentationServiceClient::OnSessionStateChanged", __FILE__, __LINE__);
      break;
    }
  }
  return false;
}

PresentationServiceClientRequestValidator::PresentationServiceClientRequestValidator(
    mojo::MessageReceiver* sink) : MessageFilter(sink) {
}

bool PresentationServiceClientRequestValidator::Accept(mojo::Message* message) {
  assert(sink_);

  if (mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    if (!mojo::internal::ValidateControlRequest(message))
      return false;
    return sink_->Accept(message);
  }

  switch (message->header()->name) {
    case internal::kPresentationServiceClient_OnScreenAvailabilityNotSupported_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationServiceClient_OnScreenAvailabilityNotSupported_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kPresentationServiceClient_OnScreenAvailabilityUpdated_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationServiceClient_OnScreenAvailabilityUpdated_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kPresentationServiceClient_OnSessionStateChanged_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::PresentationServiceClient_OnSessionStateChanged_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

size_t GetSerializedSize_(const PresentationSessionInfoPtr& input) {
  if (!input)
    return 0;
  size_t size = sizeof(internal::PresentationSessionInfo_Data);
  size += GetSerializedSize_(input->url);
  size += GetSerializedSize_(input->id);
  return size;
}

void Serialize_(PresentationSessionInfoPtr input, mojo::internal::Buffer* buf,
                internal::PresentationSessionInfo_Data** output) {
  if (input) {
    internal::PresentationSessionInfo_Data* result =
        internal::PresentationSessionInfo_Data::New(buf);
    Serialize_(mojo::internal::Forward(input->url), buf, &result->url.ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        !result->url.ptr,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null url in PresentationSessionInfo struct");
    Serialize_(mojo::internal::Forward(input->id), buf, &result->id.ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        !result->id.ptr,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null id in PresentationSessionInfo struct");
    *output = result;
  } else {
    *output = nullptr;
  }
}

void Deserialize_(internal::PresentationSessionInfo_Data* input,
                  PresentationSessionInfoPtr* output) {
  if (input) {
    PresentationSessionInfoPtr result(PresentationSessionInfo::New());
    do {
      // NOTE: The memory backing |input| may has be smaller than
      // |sizeof(*input)| if the message comes from an older version.
      Deserialize_(input->url.ptr, &result->url);
      Deserialize_(input->id.ptr, &result->id);
    } while (false);
    *output = result.Pass();
  } else {
    output->reset();
  }
}

size_t GetSerializedSize_(const PresentationErrorPtr& input) {
  if (!input)
    return 0;
  size_t size = sizeof(internal::PresentationError_Data);
  size += GetSerializedSize_(input->message);
  return size;
}

void Serialize_(PresentationErrorPtr input, mojo::internal::Buffer* buf,
                internal::PresentationError_Data** output) {
  if (input) {
    internal::PresentationError_Data* result =
        internal::PresentationError_Data::New(buf);
    result->error_type = input->error_type;
    Serialize_(mojo::internal::Forward(input->message), buf, &result->message.ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        !result->message.ptr,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null message in PresentationError struct");
    *output = result;
  } else {
    *output = nullptr;
  }
}

void Deserialize_(internal::PresentationError_Data* input,
                  PresentationErrorPtr* output) {
  if (input) {
    PresentationErrorPtr result(PresentationError::New());
    do {
      // NOTE: The memory backing |input| may has be smaller than
      // |sizeof(*input)| if the message comes from an older version.
      result->error_type = static_cast<PresentationErrorType>(input->error_type);
      Deserialize_(input->message.ptr, &result->message);
    } while (false);
    *output = result.Pass();
  } else {
    output->reset();
  }
}

size_t GetSerializedSize_(const SessionMessagePtr& input) {
  if (!input)
    return 0;
  size_t size = sizeof(internal::SessionMessage_Data);
  size += GetSerializedSize_(input->presentation_url);
  size += GetSerializedSize_(input->presentation_id);
  size += GetSerializedSize_(input->message);
  size += GetSerializedSize_(input->data);
  return size;
}

void Serialize_(SessionMessagePtr input, mojo::internal::Buffer* buf,
                internal::SessionMessage_Data** output) {
  if (input) {
    internal::SessionMessage_Data* result =
        internal::SessionMessage_Data::New(buf);
    Serialize_(mojo::internal::Forward(input->presentation_url), buf, &result->presentation_url.ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        !result->presentation_url.ptr,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null presentation_url in SessionMessage struct");
    Serialize_(mojo::internal::Forward(input->presentation_id), buf, &result->presentation_id.ptr);
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        !result->presentation_id.ptr,
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null presentation_id in SessionMessage struct");
    result->type = input->type;
    Serialize_(mojo::internal::Forward(input->message), buf, &result->message.ptr);
    const mojo::internal::ArrayValidateParams data_validate_params(
        0, false, nullptr);
    mojo::SerializeArray_(mojo::internal::Forward(input->data), buf,
        &result->data.ptr, &data_validate_params);
    *output = result;
  } else {
    *output = nullptr;
  }
}

void Deserialize_(internal::SessionMessage_Data* input,
                  SessionMessagePtr* output) {
  if (input) {
    SessionMessagePtr result(SessionMessage::New());
    do {
      // NOTE: The memory backing |input| may has be smaller than
      // |sizeof(*input)| if the message comes from an older version.
      Deserialize_(input->presentation_url.ptr, &result->presentation_url);
      Deserialize_(input->presentation_id.ptr, &result->presentation_id);
      result->type = static_cast<PresentationMessageType>(input->type);
      Deserialize_(input->message.ptr, &result->message);
      Deserialize_(input->data.ptr, &result->data);
    } while (false);
    *output = result.Pass();
  } else {
    output->reset();
  }
}

}  // namespace presentation

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif
