// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "mojo/application/public/interfaces/content_handler.mojom.h"

#include <math.h>

#include "mojo/public/cpp/bindings/lib/array_serialization.h"
#include "mojo/public/cpp/bindings/lib/bindings_serialization.h"
#include "mojo/public/cpp/bindings/lib/bounds_checker.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/map_serialization.h"
#include "mojo/public/cpp/bindings/lib/message_builder.h"
#include "mojo/public/cpp/bindings/lib/string_serialization.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "mojo/public/cpp/environment/lib/scoped_task_tracking.h"
#include "mojo/public/cpp/environment/logging.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
namespace mojo {

namespace internal {
namespace {

#pragma pack(push, 1)
const uint32_t kContentHandler_StartApplication_Name = 0;

class ContentHandler_StartApplication_Params_Data {
 public:
  static ContentHandler_StartApplication_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  mojo::MessagePipeHandle application;
  uint8_t pad0_[4];
  mojo::internal::StructPointer<mojo::internal::URLResponse_Data> response;

 private:
  ContentHandler_StartApplication_Params_Data();
  ~ContentHandler_StartApplication_Params_Data() = delete;
};
static_assert(sizeof(ContentHandler_StartApplication_Params_Data) == 24,
              "Bad sizeof(ContentHandler_StartApplication_Params_Data)");


// static
ContentHandler_StartApplication_Params_Data* ContentHandler_StartApplication_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(ContentHandler_StartApplication_Params_Data))) ContentHandler_StartApplication_Params_Data();
}

// static
bool ContentHandler_StartApplication_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const ContentHandler_StartApplication_Params_Data* object = static_cast<const ContentHandler_StartApplication_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 24 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  const mojo::Handle application_handle = object->application;
  if (application_handle.value() == mojo::internal::kEncodedInvalidHandleValue) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
        "invalid application field in ContentHandler_StartApplication_Params struct");
    return false;
  }
  if (!bounds_checker->ClaimHandle(application_handle)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_HANDLE);
    return false;
  }

  if (!object->response.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null response field in ContentHandler_StartApplication_Params struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->response.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  if (!mojo::URLResponse::Data_::Validate(
          mojo::internal::DecodePointerRaw(&object->response.offset),
          bounds_checker)) {
    return false;
  }

  return true;
}

void ContentHandler_StartApplication_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::EncodeHandle(&application, handles);
  mojo::internal::Encode(&response, handles);
}

void ContentHandler_StartApplication_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::DecodeHandle(&application, handles);
  mojo::internal::Decode(&response, handles);
}

ContentHandler_StartApplication_Params_Data::ContentHandler_StartApplication_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}


#pragma pack(pop)

}  // namespace



}  // namespace internal
MOJO_STATIC_CONST_MEMBER_DEFINITION const char ContentHandler::Name_[] = "mojo::ContentHandler";
MOJO_STATIC_CONST_MEMBER_DEFINITION const uint32_t ContentHandler::Version_;

ContentHandlerProxy::ContentHandlerProxy(mojo::MessageReceiverWithResponder* receiver)
    : ControlMessageProxy(receiver) {
}
void ContentHandlerProxy::StartApplication(
    mojo::InterfaceRequest<mojo::Application> in_application, mojo::URLResponsePtr in_response) {
  size_t size = sizeof(internal::ContentHandler_StartApplication_Params_Data);
  size += GetSerializedSize_(in_response);
  mojo::internal::MessageBuilder builder(internal::kContentHandler_StartApplication_Name, size);

  internal::ContentHandler_StartApplication_Params_Data* params =
      internal::ContentHandler_StartApplication_Params_Data::New(builder.buffer());
  params->application = in_application.PassMessagePipe().release();
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->application.is_valid(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid application in ContentHandler.StartApplication request");
  Serialize_(mojo::internal::Forward(in_response), builder.buffer(), &params->response.ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->response.ptr,
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null response in ContentHandler.StartApplication request");
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = receiver_->Accept(&message);
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  MOJO_ALLOW_UNUSED_LOCAL(ok);
}

ContentHandlerStub::ContentHandlerStub()
    : sink_(nullptr),
      control_message_handler_(ContentHandler::Version_) {
}

ContentHandlerStub::~ContentHandlerStub() {}

bool ContentHandlerStub::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return control_message_handler_.Accept(message);
  switch (message->header()->name) {
    case internal::kContentHandler_StartApplication_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.mojo.ContentHandler.StartApplication", __FILE__, __LINE__);
      internal::ContentHandler_StartApplication_Params_Data* params =
          reinterpret_cast<internal::ContentHandler_StartApplication_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      
      mojo::InterfaceRequest<mojo::Application> p_application{};
      mojo::URLResponsePtr p_response{};
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
        p_application.Bind(mojo::MakeScopedHandle(mojo::internal::FetchAndReset(&params->application)));
        Deserialize_(params->response.ptr, &p_response);
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->StartApplication(p_application.Pass(), p_response.Pass());
      return true;
    }
  }
  return false;
}

bool ContentHandlerStub::AcceptWithResponder(
    mojo::Message* message, mojo::MessageReceiverWithStatus* responder) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return control_message_handler_.AcceptWithResponder(message, responder);
  switch (message->header()->name) {
    case internal::kContentHandler_StartApplication_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::mojo::ContentHandler::StartApplication", __FILE__, __LINE__);
      break;
    }
  }
  return false;
}

ContentHandlerRequestValidator::ContentHandlerRequestValidator(
    mojo::MessageReceiver* sink) : MessageFilter(sink) {
}

bool ContentHandlerRequestValidator::Accept(mojo::Message* message) {
  assert(sink_);

  if (mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    if (!mojo::internal::ValidateControlRequest(message))
      return false;
    return sink_->Accept(message);
  }

  switch (message->header()->name) {
    case internal::kContentHandler_StartApplication_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::ContentHandler_StartApplication_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif
