// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "mojo/application/public/interfaces/shell.mojom.h"

#include <math.h>

#include "mojo/public/cpp/bindings/lib/array_serialization.h"
#include "mojo/public/cpp/bindings/lib/bindings_serialization.h"
#include "mojo/public/cpp/bindings/lib/bounds_checker.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/map_serialization.h"
#include "mojo/public/cpp/bindings/lib/message_builder.h"
#include "mojo/public/cpp/bindings/lib/string_serialization.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "mojo/public/cpp/environment/lib/scoped_task_tracking.h"
#include "mojo/public/cpp/environment/logging.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
namespace mojo {

namespace internal {
namespace {

#pragma pack(push, 1)
const uint32_t kShell_ConnectToApplication_Name = 0;

class Shell_ConnectToApplication_Params_Data {
 public:
  static Shell_ConnectToApplication_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;
  mojo::internal::StructPointer<mojo::internal::URLRequest_Data> application_url;
  mojo::MessagePipeHandle services;
  mojo::internal::Interface_Data exposed_services;
  uint8_t padfinal_[4];

 private:
  Shell_ConnectToApplication_Params_Data();
  ~Shell_ConnectToApplication_Params_Data() = delete;
};
static_assert(sizeof(Shell_ConnectToApplication_Params_Data) == 32,
              "Bad sizeof(Shell_ConnectToApplication_Params_Data)");


// static
Shell_ConnectToApplication_Params_Data* Shell_ConnectToApplication_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(Shell_ConnectToApplication_Params_Data))) Shell_ConnectToApplication_Params_Data();
}

// static
bool Shell_ConnectToApplication_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Shell_ConnectToApplication_Params_Data* object = static_cast<const Shell_ConnectToApplication_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 32 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  if (!object->application_url.offset) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null application_url field in Shell_ConnectToApplication_Params struct");
    return false;
  }
  if (!mojo::internal::ValidateEncodedPointer(&object->application_url.offset)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_POINTER);
    return false;
  }
  if (!mojo::URLRequest::Data_::Validate(
          mojo::internal::DecodePointerRaw(&object->application_url.offset),
          bounds_checker)) {
    return false;
  }

  const mojo::Handle services_handle = object->services;
  if (!bounds_checker->ClaimHandle(services_handle)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_HANDLE);
    return false;
  }

  const mojo::Handle exposed_services_handle = object->exposed_services.handle;
  if (!bounds_checker->ClaimHandle(exposed_services_handle)) {
    ReportValidationError(mojo::internal::VALIDATION_ERROR_ILLEGAL_HANDLE);
    return false;
  }

  return true;
}

void Shell_ConnectToApplication_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
  mojo::internal::Encode(&application_url, handles);
  mojo::internal::EncodeHandle(&services, handles);
  mojo::internal::EncodeHandle(&exposed_services, handles);
}

void Shell_ConnectToApplication_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
  mojo::internal::Decode(&application_url, handles);
  mojo::internal::DecodeHandle(&services, handles);
  mojo::internal::DecodeHandle(&exposed_services, handles);
}

Shell_ConnectToApplication_Params_Data::Shell_ConnectToApplication_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}

const uint32_t kShell_QuitApplication_Name = 1;

class Shell_QuitApplication_Params_Data {
 public:
  static Shell_QuitApplication_Params_Data* New(mojo::internal::Buffer* buf);

  static bool Validate(const void* data,
                       mojo::internal::BoundsChecker* bounds_checker);

  void EncodePointersAndHandles(std::vector<mojo::Handle>* handles);
  void DecodePointersAndHandles(std::vector<mojo::Handle>* handles);

  mojo::internal::StructHeader header_;

 private:
  Shell_QuitApplication_Params_Data();
  ~Shell_QuitApplication_Params_Data() = delete;
};
static_assert(sizeof(Shell_QuitApplication_Params_Data) == 8,
              "Bad sizeof(Shell_QuitApplication_Params_Data)");


// static
Shell_QuitApplication_Params_Data* Shell_QuitApplication_Params_Data::New(mojo::internal::Buffer* buf) {
  return new (buf->Allocate(sizeof(Shell_QuitApplication_Params_Data))) Shell_QuitApplication_Params_Data();
}

// static
bool Shell_QuitApplication_Params_Data::Validate(const void* data,
                              mojo::internal::BoundsChecker* bounds_checker) {
  if (!data)
    return true;

  if (!ValidateStructHeaderAndClaimMemory(data, bounds_checker))
    return false;

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  const Shell_QuitApplication_Params_Data* object = static_cast<const Shell_QuitApplication_Params_Data*>(data);

  static const struct {
    uint32_t version;
    uint32_t num_bytes;
  } kVersionSizes[] = {{ 0, 8 }};

  if (object->header_.version <=
          kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].version) {
    // Scan in reverse order to optimize for more recent versions.
    for (int i = MOJO_ARRAYSIZE(kVersionSizes) - 1; i >= 0; --i) {
      if (object->header_.version >= kVersionSizes[i].version) {
        if (object->header_.num_bytes == kVersionSizes[i].num_bytes)
          break;

        ReportValidationError(
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
        return false;
      }
    }
  } else if (object->header_.num_bytes <
                 kVersionSizes[MOJO_ARRAYSIZE(kVersionSizes) - 1].num_bytes) {
    ReportValidationError(
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_STRUCT_HEADER);
    return false;
  }

  return true;
}

void Shell_QuitApplication_Params_Data::EncodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  MOJO_CHECK(header_.version == 0);
}

void Shell_QuitApplication_Params_Data::DecodePointersAndHandles(
    std::vector<mojo::Handle>* handles) {
  // NOTE: The memory backing |this| may has be smaller than |sizeof(*this)|, if
  // the message comes from an older version.
}

Shell_QuitApplication_Params_Data::Shell_QuitApplication_Params_Data() {
  header_.num_bytes = sizeof(*this);
  header_.version = 0;
}


#pragma pack(pop)

}  // namespace



}  // namespace internal
MOJO_STATIC_CONST_MEMBER_DEFINITION const char Shell::Name_[] = "mojo::Shell";
MOJO_STATIC_CONST_MEMBER_DEFINITION const uint32_t Shell::Version_;

ShellProxy::ShellProxy(mojo::MessageReceiverWithResponder* receiver)
    : ControlMessageProxy(receiver) {
}
void ShellProxy::ConnectToApplication(
    mojo::URLRequestPtr in_application_url, mojo::InterfaceRequest<mojo::ServiceProvider> in_services, mojo::ServiceProviderPtr in_exposed_services) {
  size_t size = sizeof(internal::Shell_ConnectToApplication_Params_Data);
  size += GetSerializedSize_(in_application_url);
  mojo::internal::MessageBuilder builder(internal::kShell_ConnectToApplication_Name, size);

  internal::Shell_ConnectToApplication_Params_Data* params =
      internal::Shell_ConnectToApplication_Params_Data::New(builder.buffer());
  Serialize_(mojo::internal::Forward(in_application_url), builder.buffer(), &params->application_url.ptr);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !params->application_url.ptr,
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null application_url in Shell.ConnectToApplication request");
  params->services = in_services.PassMessagePipe().release();
  mojo::internal::InterfacePointerToData(in_exposed_services.Pass(), &params->exposed_services);
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = receiver_->Accept(&message);
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  MOJO_ALLOW_UNUSED_LOCAL(ok);
}
void ShellProxy::QuitApplication(
    ) {
  size_t size = sizeof(internal::Shell_QuitApplication_Params_Data);
  mojo::internal::MessageBuilder builder(internal::kShell_QuitApplication_Name, size);

  internal::Shell_QuitApplication_Params_Data* params =
      internal::Shell_QuitApplication_Params_Data::New(builder.buffer());
  mojo::Message message;
  params->EncodePointersAndHandles(message.mutable_handles());
  builder.Finish(&message);
  bool ok = receiver_->Accept(&message);
  // This return value may be ignored as !ok implies the Connector has
  // encountered an error, which will be visible through other means.
  MOJO_ALLOW_UNUSED_LOCAL(ok);
}

ShellStub::ShellStub()
    : sink_(nullptr),
      control_message_handler_(Shell::Version_) {
}

ShellStub::~ShellStub() {}

bool ShellStub::Accept(mojo::Message* message) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return control_message_handler_.Accept(message);
  switch (message->header()->name) {
    case internal::kShell_ConnectToApplication_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.mojo.Shell.ConnectToApplication", __FILE__, __LINE__);
      internal::Shell_ConnectToApplication_Params_Data* params =
          reinterpret_cast<internal::Shell_ConnectToApplication_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      
      mojo::URLRequestPtr p_application_url{};
      mojo::InterfaceRequest<mojo::ServiceProvider> p_services{};
      mojo::ServiceProviderPtr p_exposed_services{};
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
        Deserialize_(params->application_url.ptr, &p_application_url);
        p_services.Bind(mojo::MakeScopedHandle(mojo::internal::FetchAndReset(&params->services)));
        mojo::internal::InterfaceDataToPointer(&params->exposed_services, &p_exposed_services);
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->ConnectToApplication(p_application_url.Pass(), p_services.Pass(), p_exposed_services.Pass());
      return true;
    }
    case internal::kShell_QuitApplication_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo.mojo.Shell.QuitApplication", __FILE__, __LINE__);
      internal::Shell_QuitApplication_Params_Data* params =
          reinterpret_cast<internal::Shell_QuitApplication_Params_Data*>(
              message->mutable_payload());

      params->DecodePointersAndHandles(message->mutable_handles());
      
      do {
        // NOTE: The memory backing |params| may has be smaller than
        // |sizeof(*params)| if the message comes from an older version.
      } while (false);
      // A null |sink_| means no implementation was bound.
      assert(sink_);
      sink_->QuitApplication();
      return true;
    }
  }
  return false;
}

bool ShellStub::AcceptWithResponder(
    mojo::Message* message, mojo::MessageReceiverWithStatus* responder) {
  if (mojo::internal::ControlMessageHandler::IsControlMessage(message))
    return control_message_handler_.AcceptWithResponder(message, responder);
  switch (message->header()->name) {
    case internal::kShell_ConnectToApplication_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::mojo::Shell::ConnectToApplication", __FILE__, __LINE__);
      break;
    }
    case internal::kShell_QuitApplication_Name: {
      mojo::internal::ScopedTaskTracking task_id("mojo::mojo::Shell::QuitApplication", __FILE__, __LINE__);
      break;
    }
  }
  return false;
}

ShellRequestValidator::ShellRequestValidator(
    mojo::MessageReceiver* sink) : MessageFilter(sink) {
}

bool ShellRequestValidator::Accept(mojo::Message* message) {
  assert(sink_);

  if (mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    if (!mojo::internal::ValidateControlRequest(message))
      return false;
    return sink_->Accept(message);
  }

  switch (message->header()->name) {
    case internal::kShell_ConnectToApplication_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::Shell_ConnectToApplication_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    case internal::kShell_QuitApplication_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(message))
        return false;
      if (!mojo::internal::ValidateMessagePayload<
               internal::Shell_QuitApplication_Params_Data>(message)) {
        return false;
      }
      return sink_->Accept(message);
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif
