// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MOJO_APPLICATION_PUBLIC_INTERFACES_SHELL_MOJOM_H_
#define MOJO_APPLICATION_PUBLIC_INTERFACES_SHELL_MOJOM_H_

#include "mojo/public/cpp/bindings/array.h"
#include "mojo/public/cpp/bindings/callback.h"
#include "mojo/public/cpp/bindings/interface_impl.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/control_message_proxy.h"
#include "mojo/public/cpp/bindings/map.h"
#include "mojo/public/cpp/bindings/message_filter.h"
#include "mojo/public/cpp/bindings/no_interface.h"
#include "mojo/public/cpp/bindings/string.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/application/public/interfaces/shell.mojom-internal.h"
#include "mojo/application/public/interfaces/service_provider.mojom.h"
#include "mojo/services/network/public/interfaces/url_loader.mojom.h"
namespace mojo {

class Shell;
using ShellPtr = mojo::InterfacePtr<Shell>;


class ShellProxy;
class ShellStub;

class ShellRequestValidator;

class Shell {
 public:
  static const char Name_[];
  static const uint32_t Version_ = 0;

  using Proxy_ = ShellProxy;
  using Stub_ = ShellStub;

  using RequestValidator_ = ShellRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  virtual ~Shell() {}

  virtual void ConnectToApplication(mojo::URLRequestPtr application_url, mojo::InterfaceRequest<mojo::ServiceProvider> services, mojo::ServiceProviderPtr exposed_services) = 0;

  virtual void QuitApplication() = 0;
};


class ShellProxy
    : public Shell,
      public mojo::internal::ControlMessageProxy {
 public:
  explicit ShellProxy(mojo::MessageReceiverWithResponder* receiver);
  void ConnectToApplication(
      mojo::URLRequestPtr application_url, mojo::InterfaceRequest<mojo::ServiceProvider> services, mojo::ServiceProviderPtr exposed_services
  ) override;
  void QuitApplication(
      
  ) override;
};

class ShellStub : public mojo::MessageReceiverWithResponderStatus {
 public:
  ShellStub();
  ~ShellStub() override;
  void set_sink(Shell* sink) { sink_ = sink; }
  Shell* sink() { return sink_; }

  bool Accept(mojo::Message* message) override;
  bool AcceptWithResponder(mojo::Message* message,
      mojo::MessageReceiverWithStatus* responder) override;

 private:
  Shell* sink_;
  mojo::internal::ControlMessageHandler control_message_handler_;
};

class ShellRequestValidator : public mojo::MessageFilter {
 public:
  explicit ShellRequestValidator(mojo::MessageReceiver* sink = nullptr);

  bool Accept(mojo::Message* message) override;
};




}  // namespace mojo

#endif  // MOJO_APPLICATION_PUBLIC_INTERFACES_SHELL_MOJOM_H_
