// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MOJO_SERVICES_NETWORK_PUBLIC_INTERFACES_NETWORK_ERROR_MOJOM_H_
#define MOJO_SERVICES_NETWORK_PUBLIC_INTERFACES_NETWORK_ERROR_MOJOM_H_

#include "mojo/public/cpp/bindings/array.h"
#include "mojo/public/cpp/bindings/callback.h"
#include "mojo/public/cpp/bindings/interface_impl.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/control_message_proxy.h"
#include "mojo/public/cpp/bindings/map.h"
#include "mojo/public/cpp/bindings/message_filter.h"
#include "mojo/public/cpp/bindings/no_interface.h"
#include "mojo/public/cpp/bindings/string.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/services/network/public/interfaces/network_error.mojom-internal.h"
namespace mojo {

class NetworkError;

using NetworkErrorPtr = mojo::InlinedStructPtr<NetworkError>;






class NetworkError {
 public:
  using Data_ = internal::NetworkError_Data;

  static NetworkErrorPtr New();

  template <typename U>
  static NetworkErrorPtr From(const U& u) {
    return mojo::TypeConverter<NetworkErrorPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, NetworkError>::Convert(*this);
  }

  NetworkError();
  ~NetworkError();


  NetworkErrorPtr Clone() const;
  bool Equals(const NetworkError& other) const;

  int32_t code;
  mojo::String description;
};





size_t GetSerializedSize_(const NetworkErrorPtr& input);
void Serialize_(NetworkErrorPtr input, mojo::internal::Buffer* buffer,
                internal::NetworkError_Data** output);
void Deserialize_(internal::NetworkError_Data* input,
                  NetworkErrorPtr* output);

}  // namespace mojo

#endif  // MOJO_SERVICES_NETWORK_PUBLIC_INTERFACES_NETWORK_ERROR_MOJOM_H_
