// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated by code_generator_v8.py. DO NOT MODIFY!

#include "config.h"
#include "V8WebGL2RenderingContext.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/ScriptState.h"
#include "bindings/core/v8/ScriptValue.h"
#include "bindings/core/v8/V8ArrayBuffer.h"
#include "bindings/core/v8/V8ArrayBufferView.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "bindings/core/v8/V8Float32Array.h"
#include "bindings/core/v8/V8GCController.h"
#include "bindings/core/v8/V8HTMLCanvasElement.h"
#include "bindings/core/v8/V8HTMLImageElement.h"
#include "bindings/core/v8/V8HTMLVideoElement.h"
#include "bindings/core/v8/V8ImageData.h"
#include "bindings/core/v8/V8Int32Array.h"
#include "bindings/core/v8/V8ObjectConstructor.h"
#include "bindings/core/v8/V8Uint32Array.h"
#include "bindings/modules/v8/V8WebGLActiveInfo.h"
#include "bindings/modules/v8/V8WebGLBuffer.h"
#include "bindings/modules/v8/V8WebGLContextAttributes.h"
#include "bindings/modules/v8/V8WebGLFramebuffer.h"
#include "bindings/modules/v8/V8WebGLProgram.h"
#include "bindings/modules/v8/V8WebGLQuery.h"
#include "bindings/modules/v8/V8WebGLRenderbuffer.h"
#include "bindings/modules/v8/V8WebGLSampler.h"
#include "bindings/modules/v8/V8WebGLShader.h"
#include "bindings/modules/v8/V8WebGLShaderPrecisionFormat.h"
#include "bindings/modules/v8/V8WebGLSync.h"
#include "bindings/modules/v8/V8WebGLTexture.h"
#include "bindings/modules/v8/V8WebGLTransformFeedback.h"
#include "bindings/modules/v8/V8WebGLUniformLocation.h"
#include "bindings/modules/v8/V8WebGLVertexArrayObject.h"
#include "core/dom/ContextFeatures.h"
#include "core/dom/Document.h"
#include "core/dom/Element.h"
#include "platform/RuntimeEnabledFeatures.h"
#include "platform/TraceEvent.h"
#include "wtf/GetPtr.h"
#include "wtf/RefPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8WebGL2RenderingContext::wrapperTypeInfo = { gin::kEmbedderBlink, V8WebGL2RenderingContext::domTemplate, V8WebGL2RenderingContext::refObject, V8WebGL2RenderingContext::derefObject, V8WebGL2RenderingContext::trace, 0, V8WebGL2RenderingContext::visitDOMWrapper, V8WebGL2RenderingContext::preparePrototypeObject, V8WebGL2RenderingContext::installConditionallyEnabledProperties, "WebGL2RenderingContext", 0, WrapperTypeInfo::WrapperTypeObjectPrototype, WrapperTypeInfo::ObjectClassId, WrapperTypeInfo::NotInheritFromEventTarget, WrapperTypeInfo::Dependent, WrapperTypeInfo::WillBeGarbageCollectedObject };
#if defined(COMPONENT_BUILD) && defined(WIN32) && COMPILER(CLANG)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in WebGL2RenderingContext.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// bindings/core/v8/ScriptWrappable.h.
const WrapperTypeInfo& WebGL2RenderingContext::s_wrapperTypeInfo = V8WebGL2RenderingContext::wrapperTypeInfo;

namespace WebGL2RenderingContextV8Internal {

static void canvasAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    v8::Local<v8::Object> holder = info.Holder();
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(holder);
    v8SetReturnValueFast(info, WTF::getPtr(impl->canvas()), impl);
}

static void canvasAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMGetter");
    WebGL2RenderingContextV8Internal::canvasAttributeGetter(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void drawingBufferWidthAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    v8::Local<v8::Object> holder = info.Holder();
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(holder);
    v8SetReturnValueInt(info, impl->drawingBufferWidth());
}

static void drawingBufferWidthAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMGetter");
    WebGL2RenderingContextV8Internal::drawingBufferWidthAttributeGetter(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void drawingBufferHeightAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    v8::Local<v8::Object> holder = info.Holder();
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(holder);
    v8SetReturnValueInt(info, impl->drawingBufferHeight());
}

static void drawingBufferHeightAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMGetter");
    WebGL2RenderingContextV8Internal::drawingBufferHeightAttributeGetter(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void copyBufferSubDataMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "copyBufferSubData", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 5)) {
        setMinimumArityTypeError(exceptionState, 5, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned readTarget;
    unsigned writeTarget;
    long long readOffset;
    long long writeOffset;
    long long size;
    {
        readTarget = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        writeTarget = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        readOffset = toInt64(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        writeOffset = toInt64(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        size = toInt64(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->copyBufferSubData(readTarget, writeTarget, readOffset, writeOffset, size);
}

static void copyBufferSubDataMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::copyBufferSubDataMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getBufferSubDataMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getBufferSubData", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    long long offset;
    DOMArrayBuffer* returnedData;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        offset = toInt64(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        returnedData = info[2]->IsArrayBuffer() ? V8ArrayBuffer::toImpl(v8::Local<v8::ArrayBuffer>::Cast(info[2])) : 0;
        if (!returnedData) {
            exceptionState.throwTypeError("parameter 3 is not of type 'ArrayBuffer'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->getBufferSubData(target, offset, returnedData);
}

static void getBufferSubDataMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getBufferSubDataMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void blitFramebufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "blitFramebuffer", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 10)) {
        setMinimumArityTypeError(exceptionState, 10, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    int srcX0;
    int srcY0;
    int srcX1;
    int srcY1;
    int dstX0;
    int dstY0;
    int dstX1;
    int dstY1;
    unsigned mask;
    unsigned filter;
    {
        srcX0 = toInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        srcY0 = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        srcX1 = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        srcY1 = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        dstX0 = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        dstY0 = toInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        dstX1 = toInt32(info.GetIsolate(), info[6], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        dstY1 = toInt32(info.GetIsolate(), info[7], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        mask = toUInt32(info.GetIsolate(), info[8], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        filter = toUInt32(info.GetIsolate(), info[9], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->blitFramebuffer(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
}

static void blitFramebufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::blitFramebufferMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void framebufferTextureLayerMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "framebufferTextureLayer", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 5)) {
        setMinimumArityTypeError(exceptionState, 5, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    unsigned attachment;
    WebGLTexture* texture;
    int level;
    int layer;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        attachment = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        texture = V8WebGLTexture::toImplWithTypeCheck(info.GetIsolate(), info[2]);
        if (!texture) {
            exceptionState.throwTypeError("parameter 3 is not of type 'WebGLTexture'.");
            exceptionState.throwIfNeeded();
            return;
        }
        level = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        layer = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->framebufferTextureLayer(target, attachment, texture, level, layer);
}

static void framebufferTextureLayerMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::framebufferTextureLayerMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getInternalformatParameterMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getInternalformatParameter", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    unsigned internalformat;
    unsigned pname;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        internalformat = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pname = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptValue result = impl->getInternalformatParameter(scriptState, target, internalformat, pname);
    v8SetReturnValue(info, result.v8Value());
}

static void getInternalformatParameterMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getInternalformatParameterMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void invalidateFramebufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "invalidateFramebuffer", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    Vector<unsigned> attachments;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        attachments = toImplArray<Vector<unsigned>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->invalidateFramebuffer(target, attachments);
}

static void invalidateFramebufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::invalidateFramebufferMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void invalidateSubFramebufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "invalidateSubFramebuffer", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 6)) {
        setMinimumArityTypeError(exceptionState, 6, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    Vector<unsigned> attachments;
    int x;
    int y;
    int width;
    int height;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        attachments = toImplArray<Vector<unsigned>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        x = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->invalidateSubFramebuffer(target, attachments, x, y, width, height);
}

static void invalidateSubFramebufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::invalidateSubFramebufferMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void readBufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "readBuffer", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned mode;
    {
        mode = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->readBuffer(mode);
}

static void readBufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::readBufferMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void renderbufferStorageMultisampleMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "renderbufferStorageMultisample", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 5)) {
        setMinimumArityTypeError(exceptionState, 5, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int samples;
    unsigned internalformat;
    int width;
    int height;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        samples = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        internalformat = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->renderbufferStorageMultisample(target, samples, internalformat, width, height);
}

static void renderbufferStorageMultisampleMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::renderbufferStorageMultisampleMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void texStorage2DMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texStorage2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 5)) {
        setMinimumArityTypeError(exceptionState, 5, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int levels;
    unsigned internalformat;
    int width;
    int height;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        levels = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        internalformat = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->texStorage2D(target, levels, internalformat, width, height);
}

static void texStorage2DMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::texStorage2DMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void texStorage3DMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texStorage3D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 6)) {
        setMinimumArityTypeError(exceptionState, 6, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int levels;
    unsigned internalformat;
    int width;
    int height;
    int depth;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        levels = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        internalformat = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        depth = toInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->texStorage3D(target, levels, internalformat, width, height, depth);
}

static void texStorage3DMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::texStorage3DMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void texImage3DMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texImage3D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 10)) {
        setMinimumArityTypeError(exceptionState, 10, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    int internalformat;
    int width;
    int height;
    int depth;
    int border;
    unsigned format;
    unsigned type;
    DOMArrayBufferView* pixels;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        internalformat = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        depth = toInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        border = toInt32(info.GetIsolate(), info[6], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[7], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[8], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pixels = info[9]->IsArrayBufferView() ? V8ArrayBufferView::toImpl(v8::Local<v8::ArrayBufferView>::Cast(info[9])) : 0;
        if (!pixels && !isUndefinedOrNull(info[9])) {
            exceptionState.throwTypeError("parameter 10 is not of type 'ArrayBufferView'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->texImage3D(target, level, internalformat, width, height, depth, border, format, type, pixels);
}

static void texImage3DMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::texImage3DMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void texSubImage3D1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texSubImage3D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    int xoffset;
    int yoffset;
    int zoffset;
    int width;
    int height;
    int depth;
    unsigned format;
    unsigned type;
    DOMArrayBufferView* pixels;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        xoffset = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        yoffset = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        zoffset = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[6], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        depth = toInt32(info.GetIsolate(), info[7], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[8], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[9], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pixels = info[10]->IsArrayBufferView() ? V8ArrayBufferView::toImpl(v8::Local<v8::ArrayBufferView>::Cast(info[10])) : 0;
        if (!pixels && !isUndefinedOrNull(info[10])) {
            exceptionState.throwTypeError("parameter 11 is not of type 'ArrayBufferView'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->texSubImage3D(target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, pixels, exceptionState);
    if (exceptionState.hadException()) {
        exceptionState.throwIfNeeded();
        return;
    }
}

static void texSubImage3D2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texSubImage3D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    int xoffset;
    int yoffset;
    int zoffset;
    unsigned format;
    unsigned type;
    ImageData* data;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        xoffset = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        yoffset = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        zoffset = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[6], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        data = V8ImageData::toImplWithTypeCheck(info.GetIsolate(), info[7]);
        if (!data && !isUndefinedOrNull(info[7])) {
            exceptionState.throwTypeError("parameter 8 is not of type 'ImageData'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->texSubImage3D(target, level, xoffset, yoffset, zoffset, format, type, data, exceptionState);
    if (exceptionState.hadException()) {
        exceptionState.throwIfNeeded();
        return;
    }
}

static void texSubImage3D3Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texSubImage3D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    int xoffset;
    int yoffset;
    int zoffset;
    unsigned format;
    unsigned type;
    HTMLImageElement* image;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        xoffset = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        yoffset = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        zoffset = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[6], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        image = V8HTMLImageElement::toImplWithTypeCheck(info.GetIsolate(), info[7]);
        if (!image && !isUndefinedOrNull(info[7])) {
            exceptionState.throwTypeError("parameter 8 is not of type 'HTMLImageElement'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->texSubImage3D(target, level, xoffset, yoffset, zoffset, format, type, image, exceptionState);
    if (exceptionState.hadException()) {
        exceptionState.throwIfNeeded();
        return;
    }
}

static void texSubImage3D4Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texSubImage3D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    int xoffset;
    int yoffset;
    int zoffset;
    unsigned format;
    unsigned type;
    HTMLCanvasElement* canvas;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        xoffset = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        yoffset = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        zoffset = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[6], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        canvas = V8HTMLCanvasElement::toImplWithTypeCheck(info.GetIsolate(), info[7]);
        if (!canvas && !isUndefinedOrNull(info[7])) {
            exceptionState.throwTypeError("parameter 8 is not of type 'HTMLCanvasElement'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->texSubImage3D(target, level, xoffset, yoffset, zoffset, format, type, canvas, exceptionState);
    if (exceptionState.hadException()) {
        exceptionState.throwIfNeeded();
        return;
    }
}

static void texSubImage3D5Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texSubImage3D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    int xoffset;
    int yoffset;
    int zoffset;
    unsigned format;
    unsigned type;
    HTMLVideoElement* video;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        xoffset = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        yoffset = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        zoffset = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[6], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        video = V8HTMLVideoElement::toImplWithTypeCheck(info.GetIsolate(), info[7]);
        if (!video && !isUndefinedOrNull(info[7])) {
            exceptionState.throwTypeError("parameter 8 is not of type 'HTMLVideoElement'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->texSubImage3D(target, level, xoffset, yoffset, zoffset, format, type, video, exceptionState);
    if (exceptionState.hadException()) {
        exceptionState.throwIfNeeded();
        return;
    }
}

static void texSubImage3DMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texSubImage3D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(11, info.Length())) {
    case 8:
        if (isUndefinedOrNull(info[7])) {
            texSubImage3D2Method(info);
            return;
        }
        if (V8ImageData::hasInstance(info[7], info.GetIsolate())) {
            texSubImage3D2Method(info);
            return;
        }
        if (V8HTMLImageElement::hasInstance(info[7], info.GetIsolate())) {
            texSubImage3D3Method(info);
            return;
        }
        if (V8HTMLCanvasElement::hasInstance(info[7], info.GetIsolate())) {
            texSubImage3D4Method(info);
            return;
        }
        if (V8HTMLVideoElement::hasInstance(info[7], info.GetIsolate())) {
            texSubImage3D5Method(info);
            return;
        }
        break;
    case 11:
        if (true) {
            texSubImage3D1Method(info);
            return;
        }
        break;
    default:
        if (info.Length() >= 8) {
            setArityTypeError(exceptionState, "[8, 11]", info.Length());
            exceptionState.throwIfNeeded();
            return;
        }
        break;
    }
    if (info.Length() < 8) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(8, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void texSubImage3DMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::texSubImage3DMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void copyTexSubImage3DMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "copyTexSubImage3D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 9)) {
        setMinimumArityTypeError(exceptionState, 9, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    int xoffset;
    int yoffset;
    int zoffset;
    int x;
    int y;
    int width;
    int height;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        xoffset = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        yoffset = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        zoffset = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        x = toInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toInt32(info.GetIsolate(), info[6], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[7], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[8], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->copyTexSubImage3D(target, level, xoffset, yoffset, zoffset, x, y, width, height);
}

static void copyTexSubImage3DMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::copyTexSubImage3DMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void compressedTexImage3DMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "compressedTexImage3D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 8)) {
        setMinimumArityTypeError(exceptionState, 8, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    unsigned internalformat;
    int width;
    int height;
    int depth;
    int border;
    DOMArrayBufferView* data;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        internalformat = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        depth = toInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        border = toInt32(info.GetIsolate(), info[6], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        data = info[7]->IsArrayBufferView() ? V8ArrayBufferView::toImpl(v8::Local<v8::ArrayBufferView>::Cast(info[7])) : 0;
        if (!data) {
            exceptionState.throwTypeError("parameter 8 is not of type 'ArrayBufferView'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->compressedTexImage3D(target, level, internalformat, width, height, depth, border, data);
}

static void compressedTexImage3DMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::compressedTexImage3DMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void compressedTexSubImage3DMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "compressedTexSubImage3D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 10)) {
        setMinimumArityTypeError(exceptionState, 10, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    int xoffset;
    int yoffset;
    int zoffset;
    int width;
    int height;
    int depth;
    unsigned format;
    DOMArrayBufferView* data;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        xoffset = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        yoffset = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        zoffset = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[6], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        depth = toInt32(info.GetIsolate(), info[7], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[8], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        data = info[9]->IsArrayBufferView() ? V8ArrayBufferView::toImpl(v8::Local<v8::ArrayBufferView>::Cast(info[9])) : 0;
        if (!data) {
            exceptionState.throwTypeError("parameter 10 is not of type 'ArrayBufferView'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->compressedTexSubImage3D(target, level, xoffset, yoffset, zoffset, width, height, depth, format, data);
}

static void compressedTexSubImage3DMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::compressedTexSubImage3DMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getFragDataLocationMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 2)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "getFragDataLocation", "WebGL2RenderingContext", 2, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    V8StringResource<> name;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getFragDataLocation", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLProgram'."));
            return;
        }
        name = info[1];
        if (!name.prepare())
            return;
    }
    v8SetReturnValueInt(info, impl->getFragDataLocation(program, name));
}

static void getFragDataLocationMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getFragDataLocationMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform1uiMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform1ui", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    unsigned v0;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        v0 = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform1ui(location, v0);
}

static void uniform1uiMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform1uiMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform2uiMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform2ui", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    unsigned v0;
    unsigned v1;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        v0 = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        v1 = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform2ui(location, v0, v1);
}

static void uniform2uiMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform2uiMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform3uiMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform3ui", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 4)) {
        setMinimumArityTypeError(exceptionState, 4, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    unsigned v0;
    unsigned v1;
    unsigned v2;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        v0 = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        v1 = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        v2 = toUInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform3ui(location, v0, v1, v2);
}

static void uniform3uiMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform3uiMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform4uiMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform4ui", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 5)) {
        setMinimumArityTypeError(exceptionState, 5, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    unsigned v0;
    unsigned v1;
    unsigned v2;
    unsigned v3;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        v0 = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        v1 = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        v2 = toUInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        v3 = toUInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform4ui(location, v0, v1, v2, v3);
}

static void uniform4uiMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform4uiMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform1uivMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform1uiv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    Vector<unsigned> value;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        value = toImplArray<Vector<unsigned>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform1uiv(location, value);
}

static void uniform1uivMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform1uivMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform2uivMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform2uiv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    Vector<unsigned> value;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        value = toImplArray<Vector<unsigned>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform2uiv(location, value);
}

static void uniform2uivMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform2uivMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform3uivMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform3uiv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    Vector<unsigned> value;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        value = toImplArray<Vector<unsigned>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform3uiv(location, value);
}

static void uniform3uivMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform3uivMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform4uivMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform4uiv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    Vector<unsigned> value;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        value = toImplArray<Vector<unsigned>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform4uiv(location, value);
}

static void uniform4uivMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform4uivMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniformMatrix2x3fv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix2x3fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    DOMFloat32Array* value;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = info[2]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[2])) : 0;
        if (!value) {
            exceptionState.throwTypeError("parameter 3 is not of type 'Float32Array'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->uniformMatrix2x3fv(location, transpose, value);
}

static void uniformMatrix2x3fv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix2x3fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    Vector<float> value;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = toImplArray<Vector<float>>(info[2], 3, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniformMatrix2x3fv(location, transpose, value);
}

static void uniformMatrix2x3fvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix2x3fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(3, info.Length())) {
    case 3:
        if (V8Float32Array::hasInstance(info[2], info.GetIsolate())) {
            uniformMatrix2x3fv1Method(info);
            return;
        }
        if (info[2]->IsArray()) {
            uniformMatrix2x3fv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 3) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(3, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void uniformMatrix2x3fvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniformMatrix2x3fvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniformMatrix3x2fv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix3x2fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    DOMFloat32Array* value;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = info[2]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[2])) : 0;
        if (!value) {
            exceptionState.throwTypeError("parameter 3 is not of type 'Float32Array'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->uniformMatrix3x2fv(location, transpose, value);
}

static void uniformMatrix3x2fv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix3x2fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    Vector<float> value;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = toImplArray<Vector<float>>(info[2], 3, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniformMatrix3x2fv(location, transpose, value);
}

static void uniformMatrix3x2fvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix3x2fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(3, info.Length())) {
    case 3:
        if (V8Float32Array::hasInstance(info[2], info.GetIsolate())) {
            uniformMatrix3x2fv1Method(info);
            return;
        }
        if (info[2]->IsArray()) {
            uniformMatrix3x2fv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 3) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(3, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void uniformMatrix3x2fvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniformMatrix3x2fvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniformMatrix2x4fv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix2x4fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    DOMFloat32Array* value;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = info[2]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[2])) : 0;
        if (!value) {
            exceptionState.throwTypeError("parameter 3 is not of type 'Float32Array'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->uniformMatrix2x4fv(location, transpose, value);
}

static void uniformMatrix2x4fv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix2x4fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    Vector<float> value;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = toImplArray<Vector<float>>(info[2], 3, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniformMatrix2x4fv(location, transpose, value);
}

static void uniformMatrix2x4fvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix2x4fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(3, info.Length())) {
    case 3:
        if (V8Float32Array::hasInstance(info[2], info.GetIsolate())) {
            uniformMatrix2x4fv1Method(info);
            return;
        }
        if (info[2]->IsArray()) {
            uniformMatrix2x4fv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 3) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(3, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void uniformMatrix2x4fvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniformMatrix2x4fvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniformMatrix4x2fv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix4x2fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    DOMFloat32Array* value;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = info[2]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[2])) : 0;
        if (!value) {
            exceptionState.throwTypeError("parameter 3 is not of type 'Float32Array'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->uniformMatrix4x2fv(location, transpose, value);
}

static void uniformMatrix4x2fv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix4x2fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    Vector<float> value;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = toImplArray<Vector<float>>(info[2], 3, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniformMatrix4x2fv(location, transpose, value);
}

static void uniformMatrix4x2fvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix4x2fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(3, info.Length())) {
    case 3:
        if (V8Float32Array::hasInstance(info[2], info.GetIsolate())) {
            uniformMatrix4x2fv1Method(info);
            return;
        }
        if (info[2]->IsArray()) {
            uniformMatrix4x2fv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 3) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(3, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void uniformMatrix4x2fvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniformMatrix4x2fvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniformMatrix3x4fv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix3x4fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    DOMFloat32Array* value;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = info[2]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[2])) : 0;
        if (!value) {
            exceptionState.throwTypeError("parameter 3 is not of type 'Float32Array'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->uniformMatrix3x4fv(location, transpose, value);
}

static void uniformMatrix3x4fv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix3x4fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    Vector<float> value;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = toImplArray<Vector<float>>(info[2], 3, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniformMatrix3x4fv(location, transpose, value);
}

static void uniformMatrix3x4fvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix3x4fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(3, info.Length())) {
    case 3:
        if (V8Float32Array::hasInstance(info[2], info.GetIsolate())) {
            uniformMatrix3x4fv1Method(info);
            return;
        }
        if (info[2]->IsArray()) {
            uniformMatrix3x4fv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 3) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(3, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void uniformMatrix3x4fvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniformMatrix3x4fvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniformMatrix4x3fv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix4x3fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    DOMFloat32Array* value;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = info[2]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[2])) : 0;
        if (!value) {
            exceptionState.throwTypeError("parameter 3 is not of type 'Float32Array'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->uniformMatrix4x3fv(location, transpose, value);
}

static void uniformMatrix4x3fv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix4x3fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    Vector<float> value;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = toImplArray<Vector<float>>(info[2], 3, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniformMatrix4x3fv(location, transpose, value);
}

static void uniformMatrix4x3fvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix4x3fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(3, info.Length())) {
    case 3:
        if (V8Float32Array::hasInstance(info[2], info.GetIsolate())) {
            uniformMatrix4x3fv1Method(info);
            return;
        }
        if (info[2]->IsArray()) {
            uniformMatrix4x3fv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 3) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(3, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void uniformMatrix4x3fvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniformMatrix4x3fvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void vertexAttribI4iMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttribI4i", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 5)) {
        setMinimumArityTypeError(exceptionState, 5, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned index;
    int x;
    int y;
    int z;
    int w;
    {
        index = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        x = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        z = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        w = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->vertexAttribI4i(index, x, y, z, w);
}

static void vertexAttribI4iMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::vertexAttribI4iMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void vertexAttribI4ivMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttribI4iv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned index;
    Vector<int> v;
    {
        index = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        v = toImplArray<Vector<int>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->vertexAttribI4iv(index, v);
}

static void vertexAttribI4ivMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::vertexAttribI4ivMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void vertexAttribI4uiMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttribI4ui", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 5)) {
        setMinimumArityTypeError(exceptionState, 5, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned index;
    unsigned x;
    unsigned y;
    unsigned z;
    unsigned w;
    {
        index = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        x = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        z = toUInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        w = toUInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->vertexAttribI4ui(index, x, y, z, w);
}

static void vertexAttribI4uiMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::vertexAttribI4uiMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void vertexAttribI4uivMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttribI4uiv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned index;
    Vector<unsigned> v;
    {
        index = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        v = toImplArray<Vector<unsigned>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->vertexAttribI4uiv(index, v);
}

static void vertexAttribI4uivMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::vertexAttribI4uivMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void vertexAttribIPointerMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttribIPointer", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 5)) {
        setMinimumArityTypeError(exceptionState, 5, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned index;
    int size;
    unsigned type;
    int stride;
    long long offset;
    {
        index = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        size = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        stride = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        offset = toInt64(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->vertexAttribIPointer(index, size, type, stride, offset);
}

static void vertexAttribIPointerMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::vertexAttribIPointerMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void vertexAttribDivisorMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttribDivisor", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned index;
    unsigned divisor;
    {
        index = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        divisor = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->vertexAttribDivisor(index, divisor);
}

static void vertexAttribDivisorMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::vertexAttribDivisorMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void drawArraysInstancedMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "drawArraysInstanced", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 4)) {
        setMinimumArityTypeError(exceptionState, 4, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned mode;
    int first;
    int count;
    int instanceCount;
    {
        mode = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        first = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        count = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        instanceCount = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->drawArraysInstanced(mode, first, count, instanceCount);
}

static void drawArraysInstancedMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::drawArraysInstancedMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void drawElementsInstancedMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "drawElementsInstanced", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 5)) {
        setMinimumArityTypeError(exceptionState, 5, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned mode;
    int count;
    unsigned type;
    long long offset;
    int instanceCount;
    {
        mode = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        count = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        offset = toInt64(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        instanceCount = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->drawElementsInstanced(mode, count, type, offset, instanceCount);
}

static void drawElementsInstancedMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::drawElementsInstancedMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void drawRangeElementsMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "drawRangeElements", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 6)) {
        setMinimumArityTypeError(exceptionState, 6, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned mode;
    unsigned start;
    unsigned end;
    int count;
    unsigned type;
    long long offset;
    {
        mode = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        start = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        end = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        count = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        offset = toInt64(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->drawRangeElements(mode, start, end, count, type, offset);
}

static void drawRangeElementsMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::drawRangeElementsMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void drawBuffersMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "drawBuffers", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    Vector<unsigned> buffers;
    {
        buffers = toImplArray<Vector<unsigned>>(info[0], 1, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->drawBuffers(buffers);
}

static void drawBuffersMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::drawBuffersMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void clearBufferiv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "clearBufferiv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned buffer;
    int drawbuffer;
    DOMInt32Array* value;
    {
        buffer = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        drawbuffer = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = info[2]->IsInt32Array() ? V8Int32Array::toImpl(v8::Local<v8::Int32Array>::Cast(info[2])) : 0;
        if (!value) {
            exceptionState.throwTypeError("parameter 3 is not of type 'Int32Array'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->clearBufferiv(buffer, drawbuffer, value);
}

static void clearBufferiv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "clearBufferiv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned buffer;
    int drawbuffer;
    Vector<int> value;
    {
        buffer = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        drawbuffer = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = toImplArray<Vector<int>>(info[2], 3, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->clearBufferiv(buffer, drawbuffer, value);
}

static void clearBufferivMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "clearBufferiv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(3, info.Length())) {
    case 3:
        if (V8Int32Array::hasInstance(info[2], info.GetIsolate())) {
            clearBufferiv1Method(info);
            return;
        }
        if (info[2]->IsArray()) {
            clearBufferiv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 3) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(3, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void clearBufferivMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::clearBufferivMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void clearBufferuiv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "clearBufferuiv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned buffer;
    int drawbuffer;
    DOMUint32Array* value;
    {
        buffer = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        drawbuffer = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = info[2]->IsUint32Array() ? V8Uint32Array::toImpl(v8::Local<v8::Uint32Array>::Cast(info[2])) : 0;
        if (!value) {
            exceptionState.throwTypeError("parameter 3 is not of type 'Uint32Array'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->clearBufferuiv(buffer, drawbuffer, value);
}

static void clearBufferuiv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "clearBufferuiv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned buffer;
    int drawbuffer;
    Vector<unsigned> value;
    {
        buffer = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        drawbuffer = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = toImplArray<Vector<unsigned>>(info[2], 3, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->clearBufferuiv(buffer, drawbuffer, value);
}

static void clearBufferuivMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "clearBufferuiv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(3, info.Length())) {
    case 3:
        if (V8Uint32Array::hasInstance(info[2], info.GetIsolate())) {
            clearBufferuiv1Method(info);
            return;
        }
        if (info[2]->IsArray()) {
            clearBufferuiv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 3) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(3, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void clearBufferuivMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::clearBufferuivMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void clearBufferfv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "clearBufferfv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned buffer;
    int drawbuffer;
    DOMFloat32Array* value;
    {
        buffer = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        drawbuffer = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = info[2]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[2])) : 0;
        if (!value) {
            exceptionState.throwTypeError("parameter 3 is not of type 'Float32Array'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->clearBufferfv(buffer, drawbuffer, value);
}

static void clearBufferfv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "clearBufferfv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned buffer;
    int drawbuffer;
    Vector<float> value;
    {
        buffer = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        drawbuffer = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        value = toImplArray<Vector<float>>(info[2], 3, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->clearBufferfv(buffer, drawbuffer, value);
}

static void clearBufferfvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "clearBufferfv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(3, info.Length())) {
    case 3:
        if (V8Float32Array::hasInstance(info[2], info.GetIsolate())) {
            clearBufferfv1Method(info);
            return;
        }
        if (info[2]->IsArray()) {
            clearBufferfv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 3) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(3, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void clearBufferfvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::clearBufferfvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void clearBufferfiMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "clearBufferfi", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 4)) {
        setMinimumArityTypeError(exceptionState, 4, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned buffer;
    int drawbuffer;
    float depth;
    int stencil;
    {
        buffer = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        drawbuffer = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        depth = toFloat(info.GetIsolate(), info[2], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        stencil = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->clearBufferfi(buffer, drawbuffer, depth, stencil);
}

static void clearBufferfiMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::clearBufferfiMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void createQueryMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    v8SetReturnValue(info, impl->createQuery());
}

static void createQueryMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::createQueryMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void deleteQueryMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "deleteQuery", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLQuery* query;
    {
        query = V8WebGLQuery::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!query && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("deleteQuery", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLQuery'."));
            return;
        }
    }
    impl->deleteQuery(query);
}

static void deleteQueryMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::deleteQueryMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void isQueryMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "isQuery", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLQuery* query;
    {
        query = V8WebGLQuery::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!query && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("isQuery", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLQuery'."));
            return;
        }
    }
    v8SetReturnValueBool(info, impl->isQuery(query));
}

static void isQueryMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::isQueryMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void beginQueryMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "beginQuery", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    WebGLQuery* query;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        query = V8WebGLQuery::toImplWithTypeCheck(info.GetIsolate(), info[1]);
        if (!query && !isUndefinedOrNull(info[1])) {
            exceptionState.throwTypeError("parameter 2 is not of type 'WebGLQuery'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->beginQuery(target, query);
}

static void beginQueryMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::beginQueryMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void endQueryMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "endQuery", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->endQuery(target);
}

static void endQueryMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::endQueryMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getQueryMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getQuery", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    unsigned pname;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pname = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    v8SetReturnValue(info, impl->getQuery(target, pname));
}

static void getQueryMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getQueryMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getQueryParameterMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getQueryParameter", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLQuery* query;
    unsigned pname;
    {
        query = V8WebGLQuery::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!query && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLQuery'.");
            exceptionState.throwIfNeeded();
            return;
        }
        pname = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptValue result = impl->getQueryParameter(scriptState, query, pname);
    v8SetReturnValue(info, result.v8Value());
}

static void getQueryParameterMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getQueryParameterMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void createSamplerMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    v8SetReturnValue(info, impl->createSampler());
}

static void createSamplerMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::createSamplerMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void deleteSamplerMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "deleteSampler", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLSampler* sampler;
    {
        sampler = V8WebGLSampler::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!sampler && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("deleteSampler", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLSampler'."));
            return;
        }
    }
    impl->deleteSampler(sampler);
}

static void deleteSamplerMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::deleteSamplerMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void isSamplerMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "isSampler", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLSampler* sampler;
    {
        sampler = V8WebGLSampler::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!sampler && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("isSampler", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLSampler'."));
            return;
        }
    }
    v8SetReturnValueBool(info, impl->isSampler(sampler));
}

static void isSamplerMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::isSamplerMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void bindSamplerMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "bindSampler", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned unit;
    WebGLSampler* sampler;
    {
        unit = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        sampler = V8WebGLSampler::toImplWithTypeCheck(info.GetIsolate(), info[1]);
        if (!sampler && !isUndefinedOrNull(info[1])) {
            exceptionState.throwTypeError("parameter 2 is not of type 'WebGLSampler'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->bindSampler(unit, sampler);
}

static void bindSamplerMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::bindSamplerMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void samplerParameteriMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "samplerParameteri", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLSampler* sampler;
    unsigned pname;
    int param;
    {
        sampler = V8WebGLSampler::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!sampler && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLSampler'.");
            exceptionState.throwIfNeeded();
            return;
        }
        pname = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        param = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->samplerParameteri(sampler, pname, param);
}

static void samplerParameteriMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::samplerParameteriMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void samplerParameterfMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "samplerParameterf", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLSampler* sampler;
    unsigned pname;
    float param;
    {
        sampler = V8WebGLSampler::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!sampler && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLSampler'.");
            exceptionState.throwIfNeeded();
            return;
        }
        pname = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        param = toFloat(info.GetIsolate(), info[2], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->samplerParameterf(sampler, pname, param);
}

static void samplerParameterfMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::samplerParameterfMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getSamplerParameterMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getSamplerParameter", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLSampler* sampler;
    unsigned pname;
    {
        sampler = V8WebGLSampler::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!sampler && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLSampler'.");
            exceptionState.throwIfNeeded();
            return;
        }
        pname = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptValue result = impl->getSamplerParameter(scriptState, sampler, pname);
    v8SetReturnValue(info, result.v8Value());
}

static void getSamplerParameterMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getSamplerParameterMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void fenceSyncMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "fenceSync", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned condition;
    unsigned flags;
    {
        condition = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        flags = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    v8SetReturnValue(info, impl->fenceSync(condition, flags));
}

static void fenceSyncMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::fenceSyncMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void isSyncMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "isSync", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLSync* sync;
    {
        sync = V8WebGLSync::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!sync && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("isSync", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLSync'."));
            return;
        }
    }
    v8SetReturnValueBool(info, impl->isSync(sync));
}

static void isSyncMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::isSyncMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void deleteSyncMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "deleteSync", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLSync* sync;
    {
        sync = V8WebGLSync::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!sync && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("deleteSync", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLSync'."));
            return;
        }
    }
    impl->deleteSync(sync);
}

static void deleteSyncMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::deleteSyncMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void clientWaitSyncMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "clientWaitSync", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLSync* sync;
    unsigned flags;
    unsigned timeout;
    {
        sync = V8WebGLSync::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!sync && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLSync'.");
            exceptionState.throwIfNeeded();
            return;
        }
        flags = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        timeout = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    v8SetReturnValueUnsigned(info, impl->clientWaitSync(sync, flags, timeout));
}

static void clientWaitSyncMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::clientWaitSyncMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void waitSyncMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "waitSync", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLSync* sync;
    unsigned flags;
    unsigned timeout;
    {
        sync = V8WebGLSync::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!sync && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLSync'.");
            exceptionState.throwIfNeeded();
            return;
        }
        flags = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        timeout = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->waitSync(sync, flags, timeout);
}

static void waitSyncMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::waitSyncMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getSyncParameterMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getSyncParameter", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLSync* sync;
    unsigned pname;
    {
        sync = V8WebGLSync::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!sync) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLSync'.");
            exceptionState.throwIfNeeded();
            return;
        }
        pname = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptValue result = impl->getSyncParameter(scriptState, sync, pname);
    v8SetReturnValue(info, result.v8Value());
}

static void getSyncParameterMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getSyncParameterMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void createTransformFeedbackMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    v8SetReturnValue(info, impl->createTransformFeedback());
}

static void createTransformFeedbackMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::createTransformFeedbackMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void deleteTransformFeedbackMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "deleteTransformFeedback", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLTransformFeedback* feedback;
    {
        feedback = V8WebGLTransformFeedback::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!feedback && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("deleteTransformFeedback", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLTransformFeedback'."));
            return;
        }
    }
    impl->deleteTransformFeedback(feedback);
}

static void deleteTransformFeedbackMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::deleteTransformFeedbackMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void isTransformFeedbackMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "isTransformFeedback", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLTransformFeedback* feedback;
    {
        feedback = V8WebGLTransformFeedback::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!feedback && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("isTransformFeedback", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLTransformFeedback'."));
            return;
        }
    }
    v8SetReturnValueBool(info, impl->isTransformFeedback(feedback));
}

static void isTransformFeedbackMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::isTransformFeedbackMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void bindTransformFeedbackMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "bindTransformFeedback", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    WebGLTransformFeedback* feedback;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        feedback = V8WebGLTransformFeedback::toImplWithTypeCheck(info.GetIsolate(), info[1]);
        if (!feedback && !isUndefinedOrNull(info[1])) {
            exceptionState.throwTypeError("parameter 2 is not of type 'WebGLTransformFeedback'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->bindTransformFeedback(target, feedback);
}

static void bindTransformFeedbackMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::bindTransformFeedbackMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void beginTransformFeedbackMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "beginTransformFeedback", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned primitiveMode;
    {
        primitiveMode = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->beginTransformFeedback(primitiveMode);
}

static void beginTransformFeedbackMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::beginTransformFeedbackMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void endTransformFeedbackMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    impl->endTransformFeedback();
}

static void endTransformFeedbackMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::endTransformFeedbackMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void transformFeedbackVaryingsMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "transformFeedbackVaryings", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    Vector<String> varyings;
    unsigned bufferMode;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLProgram'.");
            exceptionState.throwIfNeeded();
            return;
        }
        varyings = toImplArray<Vector<String>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        bufferMode = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->transformFeedbackVaryings(program, varyings, bufferMode);
}

static void transformFeedbackVaryingsMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::transformFeedbackVaryingsMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getTransformFeedbackVaryingMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getTransformFeedbackVarying", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    unsigned index;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLProgram'.");
            exceptionState.throwIfNeeded();
            return;
        }
        index = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    v8SetReturnValue(info, impl->getTransformFeedbackVarying(program, index));
}

static void getTransformFeedbackVaryingMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getTransformFeedbackVaryingMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void pauseTransformFeedbackMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    impl->pauseTransformFeedback();
}

static void pauseTransformFeedbackMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::pauseTransformFeedbackMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void resumeTransformFeedbackMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    impl->resumeTransformFeedback();
}

static void resumeTransformFeedbackMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::resumeTransformFeedbackMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void bindBufferBaseMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "bindBufferBase", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    unsigned index;
    WebGLBuffer* buffer;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        index = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        buffer = V8WebGLBuffer::toImplWithTypeCheck(info.GetIsolate(), info[2]);
        if (!buffer && !isUndefinedOrNull(info[2])) {
            exceptionState.throwTypeError("parameter 3 is not of type 'WebGLBuffer'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->bindBufferBase(target, index, buffer);
}

static void bindBufferBaseMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::bindBufferBaseMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void bindBufferRangeMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "bindBufferRange", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 5)) {
        setMinimumArityTypeError(exceptionState, 5, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    unsigned index;
    WebGLBuffer* buffer;
    long long offset;
    long long size;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        index = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        buffer = V8WebGLBuffer::toImplWithTypeCheck(info.GetIsolate(), info[2]);
        if (!buffer && !isUndefinedOrNull(info[2])) {
            exceptionState.throwTypeError("parameter 3 is not of type 'WebGLBuffer'.");
            exceptionState.throwIfNeeded();
            return;
        }
        offset = toInt64(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        size = toInt64(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->bindBufferRange(target, index, buffer, offset, size);
}

static void bindBufferRangeMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::bindBufferRangeMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getIndexedParameterMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getIndexedParameter", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    unsigned index;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        index = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptValue result = impl->getIndexedParameter(scriptState, target, index);
    v8SetReturnValue(info, result.v8Value());
}

static void getIndexedParameterMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getIndexedParameterMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getUniformIndicesMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getUniformIndices", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    Vector<String> uniformNames;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLProgram'.");
            exceptionState.throwIfNeeded();
            return;
        }
        uniformNames = toImplArray<Vector<String>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    Nullable<Vector<unsigned>> result = impl->getUniformIndices(program, uniformNames);
    if (result.isNull())
        v8SetReturnValueNull(info);
    else
        v8SetReturnValue(info, toV8(result.get(), info.Holder(), info.GetIsolate()));
}

static void getUniformIndicesMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getUniformIndicesMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getActiveUniformsMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getActiveUniforms", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    Vector<unsigned> uniformIndices;
    unsigned pname;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLProgram'.");
            exceptionState.throwIfNeeded();
            return;
        }
        uniformIndices = toImplArray<Vector<unsigned>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pname = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    Nullable<Vector<int>> result = impl->getActiveUniforms(program, uniformIndices, pname);
    if (result.isNull())
        v8SetReturnValueNull(info);
    else
        v8SetReturnValue(info, toV8(result.get(), info.Holder(), info.GetIsolate()));
}

static void getActiveUniformsMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getActiveUniformsMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getUniformBlockIndexMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 2)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "getUniformBlockIndex", "WebGL2RenderingContext", 2, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    V8StringResource<> uniformBlockName;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getUniformBlockIndex", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLProgram'."));
            return;
        }
        uniformBlockName = info[1];
        if (!uniformBlockName.prepare())
            return;
    }
    v8SetReturnValueUnsigned(info, impl->getUniformBlockIndex(program, uniformBlockName));
}

static void getUniformBlockIndexMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getUniformBlockIndexMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getActiveUniformBlockParameterMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getActiveUniformBlockParameter", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    unsigned uniformBlockIndex;
    unsigned pname;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLProgram'.");
            exceptionState.throwIfNeeded();
            return;
        }
        uniformBlockIndex = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pname = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptValue result = impl->getActiveUniformBlockParameter(scriptState, program, uniformBlockIndex, pname);
    v8SetReturnValue(info, result.v8Value());
}

static void getActiveUniformBlockParameterMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getActiveUniformBlockParameterMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getActiveUniformBlockNameMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getActiveUniformBlockName", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    unsigned uniformBlockIndex;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLProgram'.");
            exceptionState.throwIfNeeded();
            return;
        }
        uniformBlockIndex = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    v8SetReturnValueString(info, impl->getActiveUniformBlockName(program, uniformBlockIndex), info.GetIsolate());
}

static void getActiveUniformBlockNameMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getActiveUniformBlockNameMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniformBlockBindingMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformBlockBinding", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    unsigned uniformBlockIndex;
    unsigned uniformBlockBinding;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLProgram'.");
            exceptionState.throwIfNeeded();
            return;
        }
        uniformBlockIndex = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        uniformBlockBinding = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniformBlockBinding(program, uniformBlockIndex, uniformBlockBinding);
}

static void uniformBlockBindingMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniformBlockBindingMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void createVertexArrayMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    v8SetReturnValue(info, impl->createVertexArray());
}

static void createVertexArrayMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::createVertexArrayMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void deleteVertexArrayMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "deleteVertexArray", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLVertexArrayObject* vertexArray;
    {
        vertexArray = V8WebGLVertexArrayObject::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!vertexArray && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("deleteVertexArray", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLVertexArrayObject'."));
            return;
        }
    }
    impl->deleteVertexArray(vertexArray);
}

static void deleteVertexArrayMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::deleteVertexArrayMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void isVertexArrayMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "isVertexArray", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLVertexArrayObject* vertexArray;
    {
        vertexArray = V8WebGLVertexArrayObject::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!vertexArray && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("isVertexArray", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLVertexArrayObject'."));
            return;
        }
    }
    v8SetReturnValueBool(info, impl->isVertexArray(vertexArray));
}

static void isVertexArrayMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::isVertexArrayMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void bindVertexArrayMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "bindVertexArray", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLVertexArrayObject* vertexArray;
    {
        vertexArray = V8WebGLVertexArrayObject::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!vertexArray && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("bindVertexArray", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLVertexArrayObject'."));
            return;
        }
    }
    impl->bindVertexArray(vertexArray);
}

static void bindVertexArrayMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::bindVertexArrayMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void activeTextureMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "activeTexture", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned texture;
    {
        texture = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->activeTexture(texture);
}

static void activeTextureMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::activeTextureMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void attachShaderMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 2)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "attachShader", "WebGL2RenderingContext", 2, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    WebGLShader* shader;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("attachShader", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLProgram'."));
            return;
        }
        shader = V8WebGLShader::toImplWithTypeCheck(info.GetIsolate(), info[1]);
        if (!shader && !isUndefinedOrNull(info[1])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("attachShader", "WebGL2RenderingContext", "parameter 2 is not of type 'WebGLShader'."));
            return;
        }
    }
    impl->attachShader(program, shader);
}

static void attachShaderMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::attachShaderMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void bindAttribLocationMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "bindAttribLocation", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    unsigned index;
    V8StringResource<> name;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLProgram'.");
            exceptionState.throwIfNeeded();
            return;
        }
        index = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        name = info[2];
        if (!name.prepare())
            return;
    }
    impl->bindAttribLocation(program, index, name);
}

static void bindAttribLocationMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::bindAttribLocationMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void bindBufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "bindBuffer", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    WebGLBuffer* buffer;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        buffer = V8WebGLBuffer::toImplWithTypeCheck(info.GetIsolate(), info[1]);
        if (!buffer && !isUndefinedOrNull(info[1])) {
            exceptionState.throwTypeError("parameter 2 is not of type 'WebGLBuffer'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->bindBuffer(target, buffer);
}

static void bindBufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::bindBufferMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void bindFramebufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "bindFramebuffer", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    WebGLFramebuffer* framebuffer;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        framebuffer = V8WebGLFramebuffer::toImplWithTypeCheck(info.GetIsolate(), info[1]);
        if (!framebuffer && !isUndefinedOrNull(info[1])) {
            exceptionState.throwTypeError("parameter 2 is not of type 'WebGLFramebuffer'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->bindFramebuffer(target, framebuffer);
}

static void bindFramebufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::bindFramebufferMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void bindRenderbufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "bindRenderbuffer", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    WebGLRenderbuffer* renderbuffer;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        renderbuffer = V8WebGLRenderbuffer::toImplWithTypeCheck(info.GetIsolate(), info[1]);
        if (!renderbuffer && !isUndefinedOrNull(info[1])) {
            exceptionState.throwTypeError("parameter 2 is not of type 'WebGLRenderbuffer'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->bindRenderbuffer(target, renderbuffer);
}

static void bindRenderbufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::bindRenderbufferMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void bindTextureMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "bindTexture", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    WebGLTexture* texture;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        texture = V8WebGLTexture::toImplWithTypeCheck(info.GetIsolate(), info[1]);
        if (!texture && !isUndefinedOrNull(info[1])) {
            exceptionState.throwTypeError("parameter 2 is not of type 'WebGLTexture'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->bindTexture(target, texture);
}

static void bindTextureMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::bindTextureMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void blendColorMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "blendColor", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 4)) {
        setMinimumArityTypeError(exceptionState, 4, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    float red;
    float green;
    float blue;
    float alpha;
    {
        red = toFloat(info.GetIsolate(), info[0], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        green = toFloat(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        blue = toFloat(info.GetIsolate(), info[2], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        alpha = toFloat(info.GetIsolate(), info[3], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->blendColor(red, green, blue, alpha);
}

static void blendColorMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::blendColorMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void blendEquationMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "blendEquation", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned mode;
    {
        mode = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->blendEquation(mode);
}

static void blendEquationMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::blendEquationMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void blendEquationSeparateMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "blendEquationSeparate", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned modeRGB;
    unsigned modeAlpha;
    {
        modeRGB = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        modeAlpha = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->blendEquationSeparate(modeRGB, modeAlpha);
}

static void blendEquationSeparateMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::blendEquationSeparateMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void blendFuncMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "blendFunc", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned sfactor;
    unsigned dfactor;
    {
        sfactor = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        dfactor = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->blendFunc(sfactor, dfactor);
}

static void blendFuncMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::blendFuncMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void blendFuncSeparateMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "blendFuncSeparate", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 4)) {
        setMinimumArityTypeError(exceptionState, 4, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned srcRGB;
    unsigned dstRGB;
    unsigned srcAlpha;
    unsigned dstAlpha;
    {
        srcRGB = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        dstRGB = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        srcAlpha = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        dstAlpha = toUInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->blendFuncSeparate(srcRGB, dstRGB, srcAlpha, dstAlpha);
}

static void blendFuncSeparateMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::blendFuncSeparateMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void bufferData1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "bufferData", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    long long size;
    unsigned usage;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        size = toInt64(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        usage = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->bufferData(target, size, usage);
}

static void bufferData2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "bufferData", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    DOMArrayBufferView* data;
    unsigned usage;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        data = info[1]->IsArrayBufferView() ? V8ArrayBufferView::toImpl(v8::Local<v8::ArrayBufferView>::Cast(info[1])) : 0;
        if (!data) {
            exceptionState.throwTypeError("parameter 2 is not of type 'ArrayBufferView'.");
            exceptionState.throwIfNeeded();
            return;
        }
        usage = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->bufferData(target, data, usage);
}

static void bufferData3Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "bufferData", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    DOMArrayBuffer* data;
    unsigned usage;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        data = info[1]->IsArrayBuffer() ? V8ArrayBuffer::toImpl(v8::Local<v8::ArrayBuffer>::Cast(info[1])) : 0;
        if (!data && !isUndefinedOrNull(info[1])) {
            exceptionState.throwTypeError("parameter 2 is not of type 'ArrayBuffer'.");
            exceptionState.throwIfNeeded();
            return;
        }
        usage = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->bufferData(target, data, usage);
}

static void bufferDataMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "bufferData", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(3, info.Length())) {
    case 3:
        if (isUndefinedOrNull(info[1])) {
            bufferData3Method(info);
            return;
        }
        if (V8ArrayBufferView::hasInstance(info[1], info.GetIsolate())) {
            bufferData2Method(info);
            return;
        }
        if (V8ArrayBuffer::hasInstance(info[1], info.GetIsolate())) {
            bufferData3Method(info);
            return;
        }
        if (true) {
            bufferData1Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 3) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(3, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void bufferDataMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::bufferDataMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void bufferSubData1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "bufferSubData", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    long long offset;
    DOMArrayBufferView* data;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        offset = toInt64(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        data = info[2]->IsArrayBufferView() ? V8ArrayBufferView::toImpl(v8::Local<v8::ArrayBufferView>::Cast(info[2])) : 0;
        if (!data) {
            exceptionState.throwTypeError("parameter 3 is not of type 'ArrayBufferView'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->bufferSubData(target, offset, data);
}

static void bufferSubData2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "bufferSubData", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    long long offset;
    DOMArrayBuffer* data;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        offset = toInt64(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        data = info[2]->IsArrayBuffer() ? V8ArrayBuffer::toImpl(v8::Local<v8::ArrayBuffer>::Cast(info[2])) : 0;
        if (!data && !isUndefinedOrNull(info[2])) {
            exceptionState.throwTypeError("parameter 3 is not of type 'ArrayBuffer'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->bufferSubData(target, offset, data);
}

static void bufferSubDataMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "bufferSubData", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(3, info.Length())) {
    case 3:
        if (isUndefinedOrNull(info[2])) {
            bufferSubData2Method(info);
            return;
        }
        if (V8ArrayBufferView::hasInstance(info[2], info.GetIsolate())) {
            bufferSubData1Method(info);
            return;
        }
        if (V8ArrayBuffer::hasInstance(info[2], info.GetIsolate())) {
            bufferSubData2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 3) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(3, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void bufferSubDataMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::bufferSubDataMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void checkFramebufferStatusMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "checkFramebufferStatus", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    v8SetReturnValueUnsigned(info, impl->checkFramebufferStatus(target));
}

static void checkFramebufferStatusMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::checkFramebufferStatusMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void clearMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "clear", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned mask;
    {
        mask = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->clear(mask);
}

static void clearMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::clearMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void clearColorMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "clearColor", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 4)) {
        setMinimumArityTypeError(exceptionState, 4, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    float red;
    float green;
    float blue;
    float alpha;
    {
        red = toFloat(info.GetIsolate(), info[0], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        green = toFloat(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        blue = toFloat(info.GetIsolate(), info[2], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        alpha = toFloat(info.GetIsolate(), info[3], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->clearColor(red, green, blue, alpha);
}

static void clearColorMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::clearColorMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void clearDepthMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "clearDepth", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    float depth;
    {
        depth = toFloat(info.GetIsolate(), info[0], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->clearDepth(depth);
}

static void clearDepthMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::clearDepthMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void clearStencilMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "clearStencil", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    int s;
    {
        s = toInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->clearStencil(s);
}

static void clearStencilMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::clearStencilMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void colorMaskMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "colorMask", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 4)) {
        setMinimumArityTypeError(exceptionState, 4, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    bool red;
    bool green;
    bool blue;
    bool alpha;
    {
        red = toBoolean(info.GetIsolate(), info[0], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        green = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        blue = toBoolean(info.GetIsolate(), info[2], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        alpha = toBoolean(info.GetIsolate(), info[3], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->colorMask(red, green, blue, alpha);
}

static void colorMaskMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::colorMaskMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void compileShaderMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "compileShader", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLShader* shader;
    {
        shader = V8WebGLShader::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!shader && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("compileShader", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLShader'."));
            return;
        }
    }
    impl->compileShader(shader);
}

static void compileShaderMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::compileShaderMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void compressedTexImage2DMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "compressedTexImage2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 7)) {
        setMinimumArityTypeError(exceptionState, 7, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    unsigned internalformat;
    int width;
    int height;
    int border;
    DOMArrayBufferView* data;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        internalformat = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        border = toInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        data = info[6]->IsArrayBufferView() ? V8ArrayBufferView::toImpl(v8::Local<v8::ArrayBufferView>::Cast(info[6])) : 0;
        if (!data && !isUndefinedOrNull(info[6])) {
            exceptionState.throwTypeError("parameter 7 is not of type 'ArrayBufferView'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->compressedTexImage2D(target, level, internalformat, width, height, border, data);
}

static void compressedTexImage2DMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::compressedTexImage2DMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void compressedTexSubImage2DMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "compressedTexSubImage2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 8)) {
        setMinimumArityTypeError(exceptionState, 8, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    int xoffset;
    int yoffset;
    int width;
    int height;
    unsigned format;
    DOMArrayBufferView* data;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        xoffset = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        yoffset = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[6], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        data = info[7]->IsArrayBufferView() ? V8ArrayBufferView::toImpl(v8::Local<v8::ArrayBufferView>::Cast(info[7])) : 0;
        if (!data && !isUndefinedOrNull(info[7])) {
            exceptionState.throwTypeError("parameter 8 is not of type 'ArrayBufferView'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->compressedTexSubImage2D(target, level, xoffset, yoffset, width, height, format, data);
}

static void compressedTexSubImage2DMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::compressedTexSubImage2DMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void copyTexImage2DMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "copyTexImage2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 8)) {
        setMinimumArityTypeError(exceptionState, 8, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    unsigned internalformat;
    int x;
    int y;
    int width;
    int height;
    int border;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        internalformat = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        x = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[6], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        border = toInt32(info.GetIsolate(), info[7], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->copyTexImage2D(target, level, internalformat, x, y, width, height, border);
}

static void copyTexImage2DMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::copyTexImage2DMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void copyTexSubImage2DMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "copyTexSubImage2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 8)) {
        setMinimumArityTypeError(exceptionState, 8, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    int xoffset;
    int yoffset;
    int x;
    int y;
    int width;
    int height;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        xoffset = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        yoffset = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        x = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[6], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[7], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->copyTexSubImage2D(target, level, xoffset, yoffset, x, y, width, height);
}

static void copyTexSubImage2DMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::copyTexSubImage2DMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void createBufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    v8SetReturnValue(info, impl->createBuffer());
}

static void createBufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::createBufferMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void createFramebufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    v8SetReturnValue(info, impl->createFramebuffer());
}

static void createFramebufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::createFramebufferMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void createProgramMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    v8SetReturnValue(info, impl->createProgram());
}

static void createProgramMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::createProgramMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void createRenderbufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    v8SetReturnValue(info, impl->createRenderbuffer());
}

static void createRenderbufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::createRenderbufferMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void createShaderMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "createShader", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned type;
    {
        type = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    v8SetReturnValue(info, impl->createShader(type));
}

static void createShaderMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::createShaderMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void createTextureMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    v8SetReturnValue(info, impl->createTexture());
}

static void createTextureMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::createTextureMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void cullFaceMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "cullFace", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned mode;
    {
        mode = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->cullFace(mode);
}

static void cullFaceMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::cullFaceMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void deleteBufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "deleteBuffer", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLBuffer* buffer;
    {
        buffer = V8WebGLBuffer::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!buffer && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("deleteBuffer", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLBuffer'."));
            return;
        }
    }
    impl->deleteBuffer(buffer);
}

static void deleteBufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::deleteBufferMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void deleteFramebufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "deleteFramebuffer", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLFramebuffer* framebuffer;
    {
        framebuffer = V8WebGLFramebuffer::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!framebuffer && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("deleteFramebuffer", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLFramebuffer'."));
            return;
        }
    }
    impl->deleteFramebuffer(framebuffer);
}

static void deleteFramebufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::deleteFramebufferMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void deleteProgramMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "deleteProgram", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("deleteProgram", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLProgram'."));
            return;
        }
    }
    impl->deleteProgram(program);
}

static void deleteProgramMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::deleteProgramMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void deleteRenderbufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "deleteRenderbuffer", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLRenderbuffer* renderbuffer;
    {
        renderbuffer = V8WebGLRenderbuffer::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!renderbuffer && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("deleteRenderbuffer", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLRenderbuffer'."));
            return;
        }
    }
    impl->deleteRenderbuffer(renderbuffer);
}

static void deleteRenderbufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::deleteRenderbufferMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void deleteShaderMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "deleteShader", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLShader* shader;
    {
        shader = V8WebGLShader::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!shader && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("deleteShader", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLShader'."));
            return;
        }
    }
    impl->deleteShader(shader);
}

static void deleteShaderMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::deleteShaderMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void deleteTextureMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "deleteTexture", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLTexture* texture;
    {
        texture = V8WebGLTexture::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!texture && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("deleteTexture", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLTexture'."));
            return;
        }
    }
    impl->deleteTexture(texture);
}

static void deleteTextureMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::deleteTextureMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void depthFuncMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "depthFunc", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned func;
    {
        func = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->depthFunc(func);
}

static void depthFuncMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::depthFuncMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void depthMaskMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "depthMask", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    bool flag;
    {
        flag = toBoolean(info.GetIsolate(), info[0], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->depthMask(flag);
}

static void depthMaskMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::depthMaskMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void depthRangeMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "depthRange", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    float zNear;
    float zFar;
    {
        zNear = toFloat(info.GetIsolate(), info[0], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        zFar = toFloat(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->depthRange(zNear, zFar);
}

static void depthRangeMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::depthRangeMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void detachShaderMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 2)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "detachShader", "WebGL2RenderingContext", 2, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    WebGLShader* shader;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("detachShader", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLProgram'."));
            return;
        }
        shader = V8WebGLShader::toImplWithTypeCheck(info.GetIsolate(), info[1]);
        if (!shader && !isUndefinedOrNull(info[1])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("detachShader", "WebGL2RenderingContext", "parameter 2 is not of type 'WebGLShader'."));
            return;
        }
    }
    impl->detachShader(program, shader);
}

static void detachShaderMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::detachShaderMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void disableMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "disable", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned cap;
    {
        cap = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->disable(cap);
}

static void disableMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::disableMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void disableVertexAttribArrayMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "disableVertexAttribArray", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned index;
    {
        index = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->disableVertexAttribArray(index);
}

static void disableVertexAttribArrayMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::disableVertexAttribArrayMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void drawArraysMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "drawArrays", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned mode;
    int first;
    int count;
    {
        mode = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        first = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        count = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->drawArrays(mode, first, count);
}

static void drawArraysMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::drawArraysMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void drawElementsMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "drawElements", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 4)) {
        setMinimumArityTypeError(exceptionState, 4, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned mode;
    int count;
    unsigned type;
    long long offset;
    {
        mode = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        count = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        offset = toInt64(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->drawElements(mode, count, type, offset);
}

static void drawElementsMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::drawElementsMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void enableMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "enable", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned cap;
    {
        cap = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->enable(cap);
}

static void enableMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::enableMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void enableVertexAttribArrayMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "enableVertexAttribArray", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned index;
    {
        index = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->enableVertexAttribArray(index);
}

static void enableVertexAttribArrayMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::enableVertexAttribArrayMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void finishMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    impl->finish();
}

static void finishMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::finishMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void flushMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    impl->flush();
}

static void flushMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::flushMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void framebufferRenderbufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "framebufferRenderbuffer", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 4)) {
        setMinimumArityTypeError(exceptionState, 4, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    unsigned attachment;
    unsigned renderbuffertarget;
    WebGLRenderbuffer* renderbuffer;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        attachment = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        renderbuffertarget = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        renderbuffer = V8WebGLRenderbuffer::toImplWithTypeCheck(info.GetIsolate(), info[3]);
        if (!renderbuffer && !isUndefinedOrNull(info[3])) {
            exceptionState.throwTypeError("parameter 4 is not of type 'WebGLRenderbuffer'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->framebufferRenderbuffer(target, attachment, renderbuffertarget, renderbuffer);
}

static void framebufferRenderbufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::framebufferRenderbufferMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void framebufferTexture2DMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "framebufferTexture2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 5)) {
        setMinimumArityTypeError(exceptionState, 5, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    unsigned attachment;
    unsigned textarget;
    WebGLTexture* texture;
    int level;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        attachment = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        textarget = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        texture = V8WebGLTexture::toImplWithTypeCheck(info.GetIsolate(), info[3]);
        if (!texture && !isUndefinedOrNull(info[3])) {
            exceptionState.throwTypeError("parameter 4 is not of type 'WebGLTexture'.");
            exceptionState.throwIfNeeded();
            return;
        }
        level = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->framebufferTexture2D(target, attachment, textarget, texture, level);
}

static void framebufferTexture2DMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::framebufferTexture2DMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void frontFaceMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "frontFace", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned mode;
    {
        mode = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->frontFace(mode);
}

static void frontFaceMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::frontFaceMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void generateMipmapMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "generateMipmap", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->generateMipmap(target);
}

static void generateMipmapMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::generateMipmapMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getActiveAttribMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getActiveAttrib", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    unsigned index;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLProgram'.");
            exceptionState.throwIfNeeded();
            return;
        }
        index = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    v8SetReturnValue(info, impl->getActiveAttrib(program, index));
}

static void getActiveAttribMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getActiveAttribMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getActiveUniformMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getActiveUniform", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    unsigned index;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLProgram'.");
            exceptionState.throwIfNeeded();
            return;
        }
        index = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    v8SetReturnValue(info, impl->getActiveUniform(program, index));
}

static void getActiveUniformMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getActiveUniformMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getAttachedShadersMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "getAttachedShaders", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getAttachedShaders", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLProgram'."));
            return;
        }
    }
    Nullable<WillBeHeapVector<RefPtrWillBeMember<WebGLShader>>> result = impl->getAttachedShaders(program);
    if (result.isNull())
        v8SetReturnValueNull(info);
    else
        v8SetReturnValue(info, toV8(result.get(), info.Holder(), info.GetIsolate()));
}

static void getAttachedShadersMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getAttachedShadersMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getAttribLocationMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 2)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "getAttribLocation", "WebGL2RenderingContext", 2, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    V8StringResource<> name;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getAttribLocation", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLProgram'."));
            return;
        }
        name = info[1];
        if (!name.prepare())
            return;
    }
    v8SetReturnValueInt(info, impl->getAttribLocation(program, name));
}

static void getAttribLocationMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getAttribLocationMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getBufferParameterMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getBufferParameter", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    unsigned pname;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pname = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptValue result = impl->getBufferParameter(scriptState, target, pname);
    v8SetReturnValue(info, result.v8Value());
}

static void getBufferParameterMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getBufferParameterMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getContextAttributesMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    Nullable<WebGLContextAttributes> result;
    impl->getContextAttributes(result);
    if (result.isNull())
        v8SetReturnValueNull(info);
    else
        v8SetReturnValue(info, result.get());
}

static void getContextAttributesMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getContextAttributesMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getErrorMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    v8SetReturnValueUnsigned(info, impl->getError());
}

static void getErrorMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getErrorMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getExtensionMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "getExtension", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    V8StringResource<> name;
    {
        name = info[0];
        if (!name.prepare())
            return;
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptValue result = impl->getExtension(scriptState, name);
    v8SetReturnValue(info, result.v8Value());
}

static void getExtensionMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getExtensionMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getFramebufferAttachmentParameterMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getFramebufferAttachmentParameter", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    unsigned attachment;
    unsigned pname;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        attachment = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pname = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptValue result = impl->getFramebufferAttachmentParameter(scriptState, target, attachment, pname);
    v8SetReturnValue(info, result.v8Value());
}

static void getFramebufferAttachmentParameterMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getFramebufferAttachmentParameterMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getParameterMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getParameter", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned pname;
    {
        pname = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptValue result = impl->getParameter(scriptState, pname);
    v8SetReturnValue(info, result.v8Value());
}

static void getParameterMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getParameterMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getProgramParameterMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getProgramParameter", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    unsigned pname;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLProgram'.");
            exceptionState.throwIfNeeded();
            return;
        }
        pname = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptValue result = impl->getProgramParameter(scriptState, program, pname);
    v8SetReturnValue(info, result.v8Value());
}

static void getProgramParameterMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getProgramParameterMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getProgramInfoLogMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "getProgramInfoLog", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getProgramInfoLog", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLProgram'."));
            return;
        }
    }
    v8SetReturnValueStringOrNull(info, impl->getProgramInfoLog(program), info.GetIsolate());
}

static void getProgramInfoLogMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getProgramInfoLogMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getRenderbufferParameterMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getRenderbufferParameter", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    unsigned pname;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pname = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptValue result = impl->getRenderbufferParameter(scriptState, target, pname);
    v8SetReturnValue(info, result.v8Value());
}

static void getRenderbufferParameterMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getRenderbufferParameterMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getShaderParameterMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getShaderParameter", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLShader* shader;
    unsigned pname;
    {
        shader = V8WebGLShader::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!shader && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLShader'.");
            exceptionState.throwIfNeeded();
            return;
        }
        pname = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptValue result = impl->getShaderParameter(scriptState, shader, pname);
    v8SetReturnValue(info, result.v8Value());
}

static void getShaderParameterMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getShaderParameterMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getShaderInfoLogMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "getShaderInfoLog", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLShader* shader;
    {
        shader = V8WebGLShader::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!shader && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getShaderInfoLog", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLShader'."));
            return;
        }
    }
    v8SetReturnValueStringOrNull(info, impl->getShaderInfoLog(shader), info.GetIsolate());
}

static void getShaderInfoLogMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getShaderInfoLogMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getShaderPrecisionFormatMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getShaderPrecisionFormat", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned shadertype;
    unsigned precisiontype;
    {
        shadertype = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        precisiontype = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    v8SetReturnValue(info, impl->getShaderPrecisionFormat(shadertype, precisiontype));
}

static void getShaderPrecisionFormatMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getShaderPrecisionFormatMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getShaderSourceMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "getShaderSource", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLShader* shader;
    {
        shader = V8WebGLShader::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!shader && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getShaderSource", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLShader'."));
            return;
        }
    }
    v8SetReturnValueStringOrNull(info, impl->getShaderSource(shader), info.GetIsolate());
}

static void getShaderSourceMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getShaderSourceMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getSupportedExtensionsMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    Nullable<Vector<String>> result = impl->getSupportedExtensions();
    if (result.isNull())
        v8SetReturnValueNull(info);
    else
        v8SetReturnValue(info, toV8(result.get(), info.Holder(), info.GetIsolate()));
}

static void getSupportedExtensionsMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getSupportedExtensionsMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getTexParameterMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getTexParameter", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    unsigned pname;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pname = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptValue result = impl->getTexParameter(scriptState, target, pname);
    v8SetReturnValue(info, result.v8Value());
}

static void getTexParameterMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getTexParameterMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getUniformMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 2)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "getUniform", "WebGL2RenderingContext", 2, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    WebGLUniformLocation* location;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getUniform", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLProgram'."));
            return;
        }
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[1]);
        if (!location && !isUndefinedOrNull(info[1])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getUniform", "WebGL2RenderingContext", "parameter 2 is not of type 'WebGLUniformLocation'."));
            return;
        }
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptValue result = impl->getUniform(scriptState, program, location);
    v8SetReturnValue(info, result.v8Value());
}

static void getUniformMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getUniformMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getUniformLocationMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 2)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "getUniformLocation", "WebGL2RenderingContext", 2, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    V8StringResource<> name;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("getUniformLocation", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLProgram'."));
            return;
        }
        name = info[1];
        if (!name.prepare())
            return;
    }
    v8SetReturnValue(info, impl->getUniformLocation(program, name));
}

static void getUniformLocationMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getUniformLocationMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getVertexAttribMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getVertexAttrib", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned index;
    unsigned pname;
    {
        index = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pname = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    ScriptState* scriptState = ScriptState::current(info.GetIsolate());
    ScriptValue result = impl->getVertexAttrib(scriptState, index, pname);
    v8SetReturnValue(info, result.v8Value());
}

static void getVertexAttribMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getVertexAttribMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void getVertexAttribOffsetMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "getVertexAttribOffset", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned index;
    unsigned pname;
    {
        index = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pname = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    v8SetReturnValue(info, static_cast<double>(impl->getVertexAttribOffset(index, pname)));
}

static void getVertexAttribOffsetMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::getVertexAttribOffsetMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void hintMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "hint", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    unsigned mode;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        mode = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->hint(target, mode);
}

static void hintMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::hintMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void isBufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "isBuffer", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLBuffer* buffer;
    {
        buffer = V8WebGLBuffer::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!buffer && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("isBuffer", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLBuffer'."));
            return;
        }
    }
    v8SetReturnValueBool(info, impl->isBuffer(buffer));
}

static void isBufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::isBufferMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void isContextLostMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    v8SetReturnValueBool(info, impl->isContextLost());
}

static void isContextLostMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::isContextLostMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void isEnabledMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "isEnabled", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned cap;
    {
        cap = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    v8SetReturnValueBool(info, impl->isEnabled(cap));
}

static void isEnabledMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::isEnabledMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void isFramebufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "isFramebuffer", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLFramebuffer* framebuffer;
    {
        framebuffer = V8WebGLFramebuffer::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!framebuffer && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("isFramebuffer", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLFramebuffer'."));
            return;
        }
    }
    v8SetReturnValueBool(info, impl->isFramebuffer(framebuffer));
}

static void isFramebufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::isFramebufferMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void isProgramMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "isProgram", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("isProgram", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLProgram'."));
            return;
        }
    }
    v8SetReturnValueBool(info, impl->isProgram(program));
}

static void isProgramMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::isProgramMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void isRenderbufferMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "isRenderbuffer", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLRenderbuffer* renderbuffer;
    {
        renderbuffer = V8WebGLRenderbuffer::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!renderbuffer && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("isRenderbuffer", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLRenderbuffer'."));
            return;
        }
    }
    v8SetReturnValueBool(info, impl->isRenderbuffer(renderbuffer));
}

static void isRenderbufferMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::isRenderbufferMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void isShaderMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "isShader", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLShader* shader;
    {
        shader = V8WebGLShader::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!shader && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("isShader", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLShader'."));
            return;
        }
    }
    v8SetReturnValueBool(info, impl->isShader(shader));
}

static void isShaderMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::isShaderMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void isTextureMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "isTexture", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLTexture* texture;
    {
        texture = V8WebGLTexture::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!texture && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("isTexture", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLTexture'."));
            return;
        }
    }
    v8SetReturnValueBool(info, impl->isTexture(texture));
}

static void isTextureMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::isTextureMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void lineWidthMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "lineWidth", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    float width;
    {
        width = toFloat(info.GetIsolate(), info[0], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->lineWidth(width);
}

static void lineWidthMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::lineWidthMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void linkProgramMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "linkProgram", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("linkProgram", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLProgram'."));
            return;
        }
    }
    impl->linkProgram(program);
}

static void linkProgramMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::linkProgramMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void pixelStoreiMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "pixelStorei", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned pname;
    int param;
    {
        pname = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        param = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->pixelStorei(pname, param);
}

static void pixelStoreiMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::pixelStoreiMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void polygonOffsetMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "polygonOffset", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    float factor;
    float units;
    {
        factor = toFloat(info.GetIsolate(), info[0], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        units = toFloat(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->polygonOffset(factor, units);
}

static void polygonOffsetMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::polygonOffsetMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void readPixelsMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "readPixels", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 7)) {
        setMinimumArityTypeError(exceptionState, 7, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    int x;
    int y;
    int width;
    int height;
    unsigned format;
    unsigned type;
    DOMArrayBufferView* pixels;
    {
        x = toInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pixels = info[6]->IsArrayBufferView() ? V8ArrayBufferView::toImpl(v8::Local<v8::ArrayBufferView>::Cast(info[6])) : 0;
        if (!pixels && !isUndefinedOrNull(info[6])) {
            exceptionState.throwTypeError("parameter 7 is not of type 'ArrayBufferView'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->readPixels(x, y, width, height, format, type, pixels);
}

static void readPixelsMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::readPixelsMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void renderbufferStorageMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "renderbufferStorage", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 4)) {
        setMinimumArityTypeError(exceptionState, 4, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    unsigned internalformat;
    int width;
    int height;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        internalformat = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->renderbufferStorage(target, internalformat, width, height);
}

static void renderbufferStorageMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::renderbufferStorageMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void sampleCoverageMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "sampleCoverage", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    float value;
    bool invert;
    {
        value = toFloat(info.GetIsolate(), info[0], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        invert = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->sampleCoverage(value, invert);
}

static void sampleCoverageMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::sampleCoverageMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void scissorMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "scissor", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 4)) {
        setMinimumArityTypeError(exceptionState, 4, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    int x;
    int y;
    int width;
    int height;
    {
        x = toInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->scissor(x, y, width, height);
}

static void scissorMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::scissorMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void shaderSourceMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 2)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "shaderSource", "WebGL2RenderingContext", 2, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLShader* shader;
    V8StringResource<> string;
    {
        shader = V8WebGLShader::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!shader && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("shaderSource", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLShader'."));
            return;
        }
        string = info[1];
        if (!string.prepare())
            return;
    }
    impl->shaderSource(shader, string);
}

static void shaderSourceMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::shaderSourceMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void stencilFuncMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "stencilFunc", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned func;
    int ref;
    unsigned mask;
    {
        func = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        ref = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        mask = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->stencilFunc(func, ref, mask);
}

static void stencilFuncMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::stencilFuncMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void stencilFuncSeparateMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "stencilFuncSeparate", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 4)) {
        setMinimumArityTypeError(exceptionState, 4, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned face;
    unsigned func;
    int ref;
    unsigned mask;
    {
        face = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        func = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        ref = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        mask = toUInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->stencilFuncSeparate(face, func, ref, mask);
}

static void stencilFuncSeparateMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::stencilFuncSeparateMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void stencilMaskMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "stencilMask", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 1)) {
        setMinimumArityTypeError(exceptionState, 1, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned mask;
    {
        mask = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->stencilMask(mask);
}

static void stencilMaskMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::stencilMaskMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void stencilMaskSeparateMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "stencilMaskSeparate", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned face;
    unsigned mask;
    {
        face = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        mask = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->stencilMaskSeparate(face, mask);
}

static void stencilMaskSeparateMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::stencilMaskSeparateMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void stencilOpMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "stencilOp", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned fail;
    unsigned zfail;
    unsigned zpass;
    {
        fail = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        zfail = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        zpass = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->stencilOp(fail, zfail, zpass);
}

static void stencilOpMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::stencilOpMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void stencilOpSeparateMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "stencilOpSeparate", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 4)) {
        setMinimumArityTypeError(exceptionState, 4, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned face;
    unsigned fail;
    unsigned zfail;
    unsigned zpass;
    {
        face = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        fail = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        zfail = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        zpass = toUInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->stencilOpSeparate(face, fail, zfail, zpass);
}

static void stencilOpSeparateMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::stencilOpSeparateMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void texParameterfMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texParameterf", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    unsigned pname;
    float param;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pname = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        param = toFloat(info.GetIsolate(), info[2], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->texParameterf(target, pname, param);
}

static void texParameterfMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::texParameterfMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void texParameteriMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texParameteri", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    unsigned pname;
    int param;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pname = toUInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        param = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->texParameteri(target, pname, param);
}

static void texParameteriMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::texParameteriMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void texImage2D1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texImage2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    unsigned internalformat;
    int width;
    int height;
    int border;
    unsigned format;
    unsigned type;
    DOMArrayBufferView* pixels;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        internalformat = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        border = toInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[6], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[7], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pixels = info[8]->IsArrayBufferView() ? V8ArrayBufferView::toImpl(v8::Local<v8::ArrayBufferView>::Cast(info[8])) : 0;
        if (!pixels && !isUndefinedOrNull(info[8])) {
            exceptionState.throwTypeError("parameter 9 is not of type 'ArrayBufferView'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->texImage2D(target, level, internalformat, width, height, border, format, type, pixels, exceptionState);
    if (exceptionState.hadException()) {
        exceptionState.throwIfNeeded();
        return;
    }
}

static void texImage2D2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texImage2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    unsigned internalformat;
    unsigned format;
    unsigned type;
    ImageData* pixels;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        internalformat = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pixels = V8ImageData::toImplWithTypeCheck(info.GetIsolate(), info[5]);
        if (!pixels && !isUndefinedOrNull(info[5])) {
            exceptionState.throwTypeError("parameter 6 is not of type 'ImageData'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->texImage2D(target, level, internalformat, format, type, pixels, exceptionState);
    if (exceptionState.hadException()) {
        exceptionState.throwIfNeeded();
        return;
    }
}

static void texImage2D3Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texImage2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    unsigned internalformat;
    unsigned format;
    unsigned type;
    HTMLImageElement* image;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        internalformat = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        image = V8HTMLImageElement::toImplWithTypeCheck(info.GetIsolate(), info[5]);
        if (!image) {
            exceptionState.throwTypeError("parameter 6 is not of type 'HTMLImageElement'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->texImage2D(target, level, internalformat, format, type, image, exceptionState);
    if (exceptionState.hadException()) {
        exceptionState.throwIfNeeded();
        return;
    }
}

static void texImage2D4Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texImage2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    unsigned internalformat;
    unsigned format;
    unsigned type;
    HTMLCanvasElement* canvas;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        internalformat = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        canvas = V8HTMLCanvasElement::toImplWithTypeCheck(info.GetIsolate(), info[5]);
        if (!canvas) {
            exceptionState.throwTypeError("parameter 6 is not of type 'HTMLCanvasElement'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->texImage2D(target, level, internalformat, format, type, canvas, exceptionState);
    if (exceptionState.hadException()) {
        exceptionState.throwIfNeeded();
        return;
    }
}

static void texImage2D5Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texImage2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    unsigned internalformat;
    unsigned format;
    unsigned type;
    HTMLVideoElement* video;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        internalformat = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        video = V8HTMLVideoElement::toImplWithTypeCheck(info.GetIsolate(), info[5]);
        if (!video) {
            exceptionState.throwTypeError("parameter 6 is not of type 'HTMLVideoElement'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->texImage2D(target, level, internalformat, format, type, video, exceptionState);
    if (exceptionState.hadException()) {
        exceptionState.throwIfNeeded();
        return;
    }
}

static void texImage2DMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texImage2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(9, info.Length())) {
    case 6:
        if (isUndefinedOrNull(info[5])) {
            texImage2D2Method(info);
            return;
        }
        if (V8ImageData::hasInstance(info[5], info.GetIsolate())) {
            texImage2D2Method(info);
            return;
        }
        if (V8HTMLImageElement::hasInstance(info[5], info.GetIsolate())) {
            texImage2D3Method(info);
            return;
        }
        if (V8HTMLCanvasElement::hasInstance(info[5], info.GetIsolate())) {
            texImage2D4Method(info);
            return;
        }
        if (V8HTMLVideoElement::hasInstance(info[5], info.GetIsolate())) {
            texImage2D5Method(info);
            return;
        }
        break;
    case 9:
        if (true) {
            texImage2D1Method(info);
            return;
        }
        break;
    default:
        if (info.Length() >= 6) {
            setArityTypeError(exceptionState, "[6, 9]", info.Length());
            exceptionState.throwIfNeeded();
            return;
        }
        break;
    }
    if (info.Length() < 6) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(6, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void texImage2DMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::texImage2DMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void texSubImage2D1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texSubImage2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    int xoffset;
    int yoffset;
    int width;
    int height;
    unsigned format;
    unsigned type;
    DOMArrayBufferView* pixels;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        xoffset = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        yoffset = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[6], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[7], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pixels = info[8]->IsArrayBufferView() ? V8ArrayBufferView::toImpl(v8::Local<v8::ArrayBufferView>::Cast(info[8])) : 0;
        if (!pixels && !isUndefinedOrNull(info[8])) {
            exceptionState.throwTypeError("parameter 9 is not of type 'ArrayBufferView'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->texSubImage2D(target, level, xoffset, yoffset, width, height, format, type, pixels, exceptionState);
    if (exceptionState.hadException()) {
        exceptionState.throwIfNeeded();
        return;
    }
}

static void texSubImage2D2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texSubImage2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    int xoffset;
    int yoffset;
    unsigned format;
    unsigned type;
    ImageData* pixels;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        xoffset = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        yoffset = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        pixels = V8ImageData::toImplWithTypeCheck(info.GetIsolate(), info[6]);
        if (!pixels && !isUndefinedOrNull(info[6])) {
            exceptionState.throwTypeError("parameter 7 is not of type 'ImageData'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->texSubImage2D(target, level, xoffset, yoffset, format, type, pixels, exceptionState);
    if (exceptionState.hadException()) {
        exceptionState.throwIfNeeded();
        return;
    }
}

static void texSubImage2D3Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texSubImage2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    int xoffset;
    int yoffset;
    unsigned format;
    unsigned type;
    HTMLImageElement* image;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        xoffset = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        yoffset = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        image = V8HTMLImageElement::toImplWithTypeCheck(info.GetIsolate(), info[6]);
        if (!image) {
            exceptionState.throwTypeError("parameter 7 is not of type 'HTMLImageElement'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->texSubImage2D(target, level, xoffset, yoffset, format, type, image, exceptionState);
    if (exceptionState.hadException()) {
        exceptionState.throwIfNeeded();
        return;
    }
}

static void texSubImage2D4Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texSubImage2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    int xoffset;
    int yoffset;
    unsigned format;
    unsigned type;
    HTMLCanvasElement* canvas;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        xoffset = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        yoffset = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        canvas = V8HTMLCanvasElement::toImplWithTypeCheck(info.GetIsolate(), info[6]);
        if (!canvas) {
            exceptionState.throwTypeError("parameter 7 is not of type 'HTMLCanvasElement'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->texSubImage2D(target, level, xoffset, yoffset, format, type, canvas, exceptionState);
    if (exceptionState.hadException()) {
        exceptionState.throwIfNeeded();
        return;
    }
}

static void texSubImage2D5Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texSubImage2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned target;
    int level;
    int xoffset;
    int yoffset;
    unsigned format;
    unsigned type;
    HTMLVideoElement* video;
    {
        target = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        level = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        xoffset = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        yoffset = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        format = toUInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        video = V8HTMLVideoElement::toImplWithTypeCheck(info.GetIsolate(), info[6]);
        if (!video) {
            exceptionState.throwTypeError("parameter 7 is not of type 'HTMLVideoElement'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->texSubImage2D(target, level, xoffset, yoffset, format, type, video, exceptionState);
    if (exceptionState.hadException()) {
        exceptionState.throwIfNeeded();
        return;
    }
}

static void texSubImage2DMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "texSubImage2D", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(9, info.Length())) {
    case 7:
        if (isUndefinedOrNull(info[6])) {
            texSubImage2D2Method(info);
            return;
        }
        if (V8ImageData::hasInstance(info[6], info.GetIsolate())) {
            texSubImage2D2Method(info);
            return;
        }
        if (V8HTMLImageElement::hasInstance(info[6], info.GetIsolate())) {
            texSubImage2D3Method(info);
            return;
        }
        if (V8HTMLCanvasElement::hasInstance(info[6], info.GetIsolate())) {
            texSubImage2D4Method(info);
            return;
        }
        if (V8HTMLVideoElement::hasInstance(info[6], info.GetIsolate())) {
            texSubImage2D5Method(info);
            return;
        }
        break;
    case 9:
        if (true) {
            texSubImage2D1Method(info);
            return;
        }
        break;
    default:
        if (info.Length() >= 7) {
            setArityTypeError(exceptionState, "[7, 9]", info.Length());
            exceptionState.throwIfNeeded();
            return;
        }
        break;
    }
    if (info.Length() < 7) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(7, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void texSubImage2DMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::texSubImage2DMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform1fMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform1f", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    float x;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        x = toFloat(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform1f(location, x);
}

static void uniform1fMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform1fMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform1fv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    DOMFloat32Array* v;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("uniform1fv", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLUniformLocation'."));
            return;
        }
        v = info[1]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[1])) : 0;
        if (!v) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("uniform1fv", "WebGL2RenderingContext", "parameter 2 is not of type 'Float32Array'."));
            return;
        }
    }
    impl->uniform1fv(location, v);
}

static void uniform1fv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform1fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    Vector<float> v;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        v = toImplArray<Vector<float>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform1fv(location, v);
}

static void uniform1fvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform1fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(2, info.Length())) {
    case 2:
        if (V8Float32Array::hasInstance(info[1], info.GetIsolate())) {
            uniform1fv1Method(info);
            return;
        }
        if (info[1]->IsArray()) {
            uniform1fv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 2) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(2, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void uniform1fvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform1fvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform1iMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform1i", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    int x;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        x = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform1i(location, x);
}

static void uniform1iMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform1iMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform1iv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    DOMInt32Array* v;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("uniform1iv", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLUniformLocation'."));
            return;
        }
        v = info[1]->IsInt32Array() ? V8Int32Array::toImpl(v8::Local<v8::Int32Array>::Cast(info[1])) : 0;
        if (!v) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("uniform1iv", "WebGL2RenderingContext", "parameter 2 is not of type 'Int32Array'."));
            return;
        }
    }
    impl->uniform1iv(location, v);
}

static void uniform1iv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform1iv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    Vector<int> v;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        v = toImplArray<Vector<int>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform1iv(location, v);
}

static void uniform1ivMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform1iv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(2, info.Length())) {
    case 2:
        if (V8Int32Array::hasInstance(info[1], info.GetIsolate())) {
            uniform1iv1Method(info);
            return;
        }
        if (info[1]->IsArray()) {
            uniform1iv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 2) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(2, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void uniform1ivMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform1ivMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform2fMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform2f", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    float x;
    float y;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        x = toFloat(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toFloat(info.GetIsolate(), info[2], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform2f(location, x, y);
}

static void uniform2fMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform2fMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform2fv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    DOMFloat32Array* v;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("uniform2fv", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLUniformLocation'."));
            return;
        }
        v = info[1]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[1])) : 0;
        if (!v) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("uniform2fv", "WebGL2RenderingContext", "parameter 2 is not of type 'Float32Array'."));
            return;
        }
    }
    impl->uniform2fv(location, v);
}

static void uniform2fv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform2fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    Vector<float> v;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        v = toImplArray<Vector<float>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform2fv(location, v);
}

static void uniform2fvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform2fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(2, info.Length())) {
    case 2:
        if (V8Float32Array::hasInstance(info[1], info.GetIsolate())) {
            uniform2fv1Method(info);
            return;
        }
        if (info[1]->IsArray()) {
            uniform2fv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 2) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(2, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void uniform2fvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform2fvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform2iMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform2i", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    int x;
    int y;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        x = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform2i(location, x, y);
}

static void uniform2iMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform2iMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform2iv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    DOMInt32Array* v;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("uniform2iv", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLUniformLocation'."));
            return;
        }
        v = info[1]->IsInt32Array() ? V8Int32Array::toImpl(v8::Local<v8::Int32Array>::Cast(info[1])) : 0;
        if (!v) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("uniform2iv", "WebGL2RenderingContext", "parameter 2 is not of type 'Int32Array'."));
            return;
        }
    }
    impl->uniform2iv(location, v);
}

static void uniform2iv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform2iv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    Vector<int> v;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        v = toImplArray<Vector<int>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform2iv(location, v);
}

static void uniform2ivMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform2iv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(2, info.Length())) {
    case 2:
        if (V8Int32Array::hasInstance(info[1], info.GetIsolate())) {
            uniform2iv1Method(info);
            return;
        }
        if (info[1]->IsArray()) {
            uniform2iv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 2) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(2, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void uniform2ivMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform2ivMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform3fMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform3f", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 4)) {
        setMinimumArityTypeError(exceptionState, 4, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    float x;
    float y;
    float z;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        x = toFloat(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toFloat(info.GetIsolate(), info[2], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        z = toFloat(info.GetIsolate(), info[3], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform3f(location, x, y, z);
}

static void uniform3fMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform3fMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform3fv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    DOMFloat32Array* v;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("uniform3fv", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLUniformLocation'."));
            return;
        }
        v = info[1]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[1])) : 0;
        if (!v) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("uniform3fv", "WebGL2RenderingContext", "parameter 2 is not of type 'Float32Array'."));
            return;
        }
    }
    impl->uniform3fv(location, v);
}

static void uniform3fv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform3fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    Vector<float> v;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        v = toImplArray<Vector<float>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform3fv(location, v);
}

static void uniform3fvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform3fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(2, info.Length())) {
    case 2:
        if (V8Float32Array::hasInstance(info[1], info.GetIsolate())) {
            uniform3fv1Method(info);
            return;
        }
        if (info[1]->IsArray()) {
            uniform3fv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 2) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(2, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void uniform3fvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform3fvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform3iMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform3i", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 4)) {
        setMinimumArityTypeError(exceptionState, 4, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    int x;
    int y;
    int z;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        x = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        z = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform3i(location, x, y, z);
}

static void uniform3iMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform3iMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform3iv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    DOMInt32Array* v;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("uniform3iv", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLUniformLocation'."));
            return;
        }
        v = info[1]->IsInt32Array() ? V8Int32Array::toImpl(v8::Local<v8::Int32Array>::Cast(info[1])) : 0;
        if (!v) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("uniform3iv", "WebGL2RenderingContext", "parameter 2 is not of type 'Int32Array'."));
            return;
        }
    }
    impl->uniform3iv(location, v);
}

static void uniform3iv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform3iv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    Vector<int> v;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        v = toImplArray<Vector<int>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform3iv(location, v);
}

static void uniform3ivMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform3iv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(2, info.Length())) {
    case 2:
        if (V8Int32Array::hasInstance(info[1], info.GetIsolate())) {
            uniform3iv1Method(info);
            return;
        }
        if (info[1]->IsArray()) {
            uniform3iv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 2) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(2, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void uniform3ivMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform3ivMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform4fMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform4f", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 5)) {
        setMinimumArityTypeError(exceptionState, 5, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    float x;
    float y;
    float z;
    float w;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        x = toFloat(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toFloat(info.GetIsolate(), info[2], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        z = toFloat(info.GetIsolate(), info[3], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        w = toFloat(info.GetIsolate(), info[4], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform4f(location, x, y, z, w);
}

static void uniform4fMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform4fMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform4fv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    DOMFloat32Array* v;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("uniform4fv", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLUniformLocation'."));
            return;
        }
        v = info[1]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[1])) : 0;
        if (!v) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("uniform4fv", "WebGL2RenderingContext", "parameter 2 is not of type 'Float32Array'."));
            return;
        }
    }
    impl->uniform4fv(location, v);
}

static void uniform4fv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform4fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    Vector<float> v;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        v = toImplArray<Vector<float>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform4fv(location, v);
}

static void uniform4fvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform4fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(2, info.Length())) {
    case 2:
        if (V8Float32Array::hasInstance(info[1], info.GetIsolate())) {
            uniform4fv1Method(info);
            return;
        }
        if (info[1]->IsArray()) {
            uniform4fv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 2) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(2, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void uniform4fvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform4fvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform4iMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform4i", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 5)) {
        setMinimumArityTypeError(exceptionState, 5, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    int x;
    int y;
    int z;
    int w;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        x = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        z = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        w = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform4i(location, x, y, z, w);
}

static void uniform4iMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform4iMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniform4iv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    DOMInt32Array* v;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("uniform4iv", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLUniformLocation'."));
            return;
        }
        v = info[1]->IsInt32Array() ? V8Int32Array::toImpl(v8::Local<v8::Int32Array>::Cast(info[1])) : 0;
        if (!v) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("uniform4iv", "WebGL2RenderingContext", "parameter 2 is not of type 'Int32Array'."));
            return;
        }
    }
    impl->uniform4iv(location, v);
}

static void uniform4iv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform4iv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    Vector<int> v;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        v = toImplArray<Vector<int>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniform4iv(location, v);
}

static void uniform4ivMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniform4iv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(2, info.Length())) {
    case 2:
        if (V8Int32Array::hasInstance(info[1], info.GetIsolate())) {
            uniform4iv1Method(info);
            return;
        }
        if (info[1]->IsArray()) {
            uniform4iv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 2) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(2, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void uniform4ivMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniform4ivMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniformMatrix2fv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix2fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    DOMFloat32Array* array;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        array = info[2]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[2])) : 0;
        if (!array) {
            exceptionState.throwTypeError("parameter 3 is not of type 'Float32Array'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->uniformMatrix2fv(location, transpose, array);
}

static void uniformMatrix2fv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix2fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    Vector<float> array;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        array = toImplArray<Vector<float>>(info[2], 3, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniformMatrix2fv(location, transpose, array);
}

static void uniformMatrix2fvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix2fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(3, info.Length())) {
    case 3:
        if (V8Float32Array::hasInstance(info[2], info.GetIsolate())) {
            uniformMatrix2fv1Method(info);
            return;
        }
        if (info[2]->IsArray()) {
            uniformMatrix2fv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 3) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(3, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void uniformMatrix2fvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniformMatrix2fvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniformMatrix3fv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix3fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    DOMFloat32Array* array;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        array = info[2]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[2])) : 0;
        if (!array) {
            exceptionState.throwTypeError("parameter 3 is not of type 'Float32Array'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->uniformMatrix3fv(location, transpose, array);
}

static void uniformMatrix3fv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix3fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    Vector<float> array;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        array = toImplArray<Vector<float>>(info[2], 3, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniformMatrix3fv(location, transpose, array);
}

static void uniformMatrix3fvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix3fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(3, info.Length())) {
    case 3:
        if (V8Float32Array::hasInstance(info[2], info.GetIsolate())) {
            uniformMatrix3fv1Method(info);
            return;
        }
        if (info[2]->IsArray()) {
            uniformMatrix3fv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 3) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(3, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void uniformMatrix3fvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniformMatrix3fvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void uniformMatrix4fv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix4fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    DOMFloat32Array* array;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        array = info[2]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[2])) : 0;
        if (!array) {
            exceptionState.throwTypeError("parameter 3 is not of type 'Float32Array'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->uniformMatrix4fv(location, transpose, array);
}

static void uniformMatrix4fv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix4fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLUniformLocation* location;
    bool transpose;
    Vector<float> array;
    {
        location = V8WebGLUniformLocation::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!location && !isUndefinedOrNull(info[0])) {
            exceptionState.throwTypeError("parameter 1 is not of type 'WebGLUniformLocation'.");
            exceptionState.throwIfNeeded();
            return;
        }
        transpose = toBoolean(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        array = toImplArray<Vector<float>>(info[2], 3, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->uniformMatrix4fv(location, transpose, array);
}

static void uniformMatrix4fvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "uniformMatrix4fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(3, info.Length())) {
    case 3:
        if (V8Float32Array::hasInstance(info[2], info.GetIsolate())) {
            uniformMatrix4fv1Method(info);
            return;
        }
        if (info[2]->IsArray()) {
            uniformMatrix4fv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 3) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(3, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void uniformMatrix4fvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::uniformMatrix4fvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void useProgramMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "useProgram", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("useProgram", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLProgram'."));
            return;
        }
    }
    impl->useProgram(program);
}

static void useProgramMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::useProgramMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void validateProgramMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    if (UNLIKELY(info.Length() < 1)) {
        V8ThrowException::throwException(createMinimumArityTypeErrorForMethod(info.GetIsolate(), "validateProgram", "WebGL2RenderingContext", 1, info.Length()), info.GetIsolate());
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    WebGLProgram* program;
    {
        program = V8WebGLProgram::toImplWithTypeCheck(info.GetIsolate(), info[0]);
        if (!program && !isUndefinedOrNull(info[0])) {
            V8ThrowException::throwTypeError(info.GetIsolate(), ExceptionMessages::failedToExecute("validateProgram", "WebGL2RenderingContext", "parameter 1 is not of type 'WebGLProgram'."));
            return;
        }
    }
    impl->validateProgram(program);
}

static void validateProgramMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::validateProgramMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void vertexAttrib1fMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttrib1f", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 2)) {
        setMinimumArityTypeError(exceptionState, 2, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned indx;
    float x;
    {
        indx = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        x = toFloat(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->vertexAttrib1f(indx, x);
}

static void vertexAttrib1fMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::vertexAttrib1fMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void vertexAttrib1fv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttrib1fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned indx;
    DOMFloat32Array* values;
    {
        indx = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        values = info[1]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[1])) : 0;
        if (!values) {
            exceptionState.throwTypeError("parameter 2 is not of type 'Float32Array'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->vertexAttrib1fv(indx, values);
}

static void vertexAttrib1fv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttrib1fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned indx;
    Vector<float> values;
    {
        indx = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        values = toImplArray<Vector<float>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->vertexAttrib1fv(indx, values);
}

static void vertexAttrib1fvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttrib1fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(2, info.Length())) {
    case 2:
        if (V8Float32Array::hasInstance(info[1], info.GetIsolate())) {
            vertexAttrib1fv1Method(info);
            return;
        }
        if (info[1]->IsArray()) {
            vertexAttrib1fv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 2) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(2, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void vertexAttrib1fvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::vertexAttrib1fvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void vertexAttrib2fMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttrib2f", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 3)) {
        setMinimumArityTypeError(exceptionState, 3, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned indx;
    float x;
    float y;
    {
        indx = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        x = toFloat(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toFloat(info.GetIsolate(), info[2], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->vertexAttrib2f(indx, x, y);
}

static void vertexAttrib2fMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::vertexAttrib2fMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void vertexAttrib2fv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttrib2fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned indx;
    DOMFloat32Array* values;
    {
        indx = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        values = info[1]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[1])) : 0;
        if (!values) {
            exceptionState.throwTypeError("parameter 2 is not of type 'Float32Array'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->vertexAttrib2fv(indx, values);
}

static void vertexAttrib2fv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttrib2fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned indx;
    Vector<float> values;
    {
        indx = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        values = toImplArray<Vector<float>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->vertexAttrib2fv(indx, values);
}

static void vertexAttrib2fvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttrib2fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(2, info.Length())) {
    case 2:
        if (V8Float32Array::hasInstance(info[1], info.GetIsolate())) {
            vertexAttrib2fv1Method(info);
            return;
        }
        if (info[1]->IsArray()) {
            vertexAttrib2fv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 2) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(2, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void vertexAttrib2fvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::vertexAttrib2fvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void vertexAttrib3fMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttrib3f", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 4)) {
        setMinimumArityTypeError(exceptionState, 4, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned indx;
    float x;
    float y;
    float z;
    {
        indx = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        x = toFloat(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toFloat(info.GetIsolate(), info[2], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        z = toFloat(info.GetIsolate(), info[3], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->vertexAttrib3f(indx, x, y, z);
}

static void vertexAttrib3fMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::vertexAttrib3fMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void vertexAttrib3fv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttrib3fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned indx;
    DOMFloat32Array* values;
    {
        indx = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        values = info[1]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[1])) : 0;
        if (!values) {
            exceptionState.throwTypeError("parameter 2 is not of type 'Float32Array'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->vertexAttrib3fv(indx, values);
}

static void vertexAttrib3fv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttrib3fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned indx;
    Vector<float> values;
    {
        indx = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        values = toImplArray<Vector<float>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->vertexAttrib3fv(indx, values);
}

static void vertexAttrib3fvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttrib3fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(2, info.Length())) {
    case 2:
        if (V8Float32Array::hasInstance(info[1], info.GetIsolate())) {
            vertexAttrib3fv1Method(info);
            return;
        }
        if (info[1]->IsArray()) {
            vertexAttrib3fv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 2) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(2, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void vertexAttrib3fvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::vertexAttrib3fvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void vertexAttrib4fMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttrib4f", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 5)) {
        setMinimumArityTypeError(exceptionState, 5, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned indx;
    float x;
    float y;
    float z;
    float w;
    {
        indx = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        x = toFloat(info.GetIsolate(), info[1], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toFloat(info.GetIsolate(), info[2], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        z = toFloat(info.GetIsolate(), info[3], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        w = toFloat(info.GetIsolate(), info[4], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->vertexAttrib4f(indx, x, y, z, w);
}

static void vertexAttrib4fMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::vertexAttrib4fMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void vertexAttrib4fv1Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttrib4fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned indx;
    DOMFloat32Array* values;
    {
        indx = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        values = info[1]->IsFloat32Array() ? V8Float32Array::toImpl(v8::Local<v8::Float32Array>::Cast(info[1])) : 0;
        if (!values) {
            exceptionState.throwTypeError("parameter 2 is not of type 'Float32Array'.");
            exceptionState.throwIfNeeded();
            return;
        }
    }
    impl->vertexAttrib4fv(indx, values);
}

static void vertexAttrib4fv2Method(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttrib4fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned indx;
    Vector<float> values;
    {
        indx = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        values = toImplArray<Vector<float>>(info[1], 2, info.GetIsolate(), exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->vertexAttrib4fv(indx, values);
}

static void vertexAttrib4fvMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttrib4fv", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    switch (std::min(2, info.Length())) {
    case 2:
        if (V8Float32Array::hasInstance(info[1], info.GetIsolate())) {
            vertexAttrib4fv1Method(info);
            return;
        }
        if (info[1]->IsArray()) {
            vertexAttrib4fv2Method(info);
            return;
        }
        break;
    default:
        break;
    }
    if (info.Length() < 2) {
        exceptionState.throwTypeError(ExceptionMessages::notEnoughArguments(2, info.Length()));
        exceptionState.throwIfNeeded();
        return;
    }
    exceptionState.throwTypeError("No function was found that matched the signature provided.");
    exceptionState.throwIfNeeded();
    return;
}

static void vertexAttrib4fvMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::vertexAttrib4fvMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void vertexAttribPointerMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "vertexAttribPointer", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 6)) {
        setMinimumArityTypeError(exceptionState, 6, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    unsigned indx;
    int size;
    unsigned type;
    bool normalized;
    int stride;
    long long offset;
    {
        indx = toUInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        size = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        type = toUInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        normalized = toBoolean(info.GetIsolate(), info[3], exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        stride = toInt32(info.GetIsolate(), info[4], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        offset = toInt64(info.GetIsolate(), info[5], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->vertexAttribPointer(indx, size, type, normalized, stride, offset);
}

static void vertexAttribPointerMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::vertexAttribPointerMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

static void viewportMethod(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    ExceptionState exceptionState(ExceptionState::ExecutionContext, "viewport", "WebGL2RenderingContext", info.Holder(), info.GetIsolate());
    if (UNLIKELY(info.Length() < 4)) {
        setMinimumArityTypeError(exceptionState, 4, info.Length());
        exceptionState.throwIfNeeded();
        return;
    }
    WebGL2RenderingContext* impl = V8WebGL2RenderingContext::toImpl(info.Holder());
    int x;
    int y;
    int width;
    int height;
    {
        x = toInt32(info.GetIsolate(), info[0], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        y = toInt32(info.GetIsolate(), info[1], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        width = toInt32(info.GetIsolate(), info[2], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
        height = toInt32(info.GetIsolate(), info[3], NormalConversion, exceptionState);
        if (exceptionState.throwIfNeeded())
            return;
    }
    impl->viewport(x, y, width, height);
}

static void viewportMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info)
{
    TRACE_EVENT_SET_SAMPLING_STATE("blink", "DOMMethod");
    WebGL2RenderingContextV8Internal::viewportMethod(info);
    TRACE_EVENT_SET_SAMPLING_STATE("v8", "V8Execution");
}

} // namespace WebGL2RenderingContextV8Internal

void V8WebGL2RenderingContext::visitDOMWrapper(v8::Isolate* isolate, ScriptWrappable* scriptWrappable, const v8::Persistent<v8::Object>& wrapper)
{
    WebGL2RenderingContext* impl = scriptWrappable->toImpl<WebGL2RenderingContext>();
    // The canvas() method may return a reference or a pointer.
    if (Node* owner = WTF::getPtr(impl->canvas())) {
        Node* root = V8GCController::opaqueRootForGC(isolate, owner);
        isolate->SetReferenceFromGroup(v8::UniqueId(reinterpret_cast<intptr_t>(root)), wrapper);
        return;
    }
}

static const V8DOMConfiguration::AccessorConfiguration V8WebGL2RenderingContextAccessors[] = {
    {"canvas", WebGL2RenderingContextV8Internal::canvasAttributeGetterCallback, 0, 0, 0, 0, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"drawingBufferWidth", WebGL2RenderingContextV8Internal::drawingBufferWidthAttributeGetterCallback, 0, 0, 0, 0, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
    {"drawingBufferHeight", WebGL2RenderingContextV8Internal::drawingBufferHeightAttributeGetterCallback, 0, 0, 0, 0, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::ExposedToAllScripts, V8DOMConfiguration::OnPrototype, V8DOMConfiguration::CheckHolder},
};

static const V8DOMConfiguration::MethodConfiguration V8WebGL2RenderingContextMethods[] = {
    {"activeTexture", WebGL2RenderingContextV8Internal::activeTextureMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"attachShader", WebGL2RenderingContextV8Internal::attachShaderMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"bindAttribLocation", WebGL2RenderingContextV8Internal::bindAttribLocationMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts},
    {"bindBuffer", WebGL2RenderingContextV8Internal::bindBufferMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"bindFramebuffer", WebGL2RenderingContextV8Internal::bindFramebufferMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"bindRenderbuffer", WebGL2RenderingContextV8Internal::bindRenderbufferMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"bindTexture", WebGL2RenderingContextV8Internal::bindTextureMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"blendColor", WebGL2RenderingContextV8Internal::blendColorMethodCallback, 0, 4, V8DOMConfiguration::ExposedToAllScripts},
    {"blendEquation", WebGL2RenderingContextV8Internal::blendEquationMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"blendEquationSeparate", WebGL2RenderingContextV8Internal::blendEquationSeparateMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"blendFunc", WebGL2RenderingContextV8Internal::blendFuncMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"blendFuncSeparate", WebGL2RenderingContextV8Internal::blendFuncSeparateMethodCallback, 0, 4, V8DOMConfiguration::ExposedToAllScripts},
    {"bufferData", WebGL2RenderingContextV8Internal::bufferDataMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts},
    {"bufferSubData", WebGL2RenderingContextV8Internal::bufferSubDataMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts},
    {"checkFramebufferStatus", WebGL2RenderingContextV8Internal::checkFramebufferStatusMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"clear", WebGL2RenderingContextV8Internal::clearMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"clearColor", WebGL2RenderingContextV8Internal::clearColorMethodCallback, 0, 4, V8DOMConfiguration::ExposedToAllScripts},
    {"clearDepth", WebGL2RenderingContextV8Internal::clearDepthMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"clearStencil", WebGL2RenderingContextV8Internal::clearStencilMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"colorMask", WebGL2RenderingContextV8Internal::colorMaskMethodCallback, 0, 4, V8DOMConfiguration::ExposedToAllScripts},
    {"compileShader", WebGL2RenderingContextV8Internal::compileShaderMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"compressedTexImage2D", WebGL2RenderingContextV8Internal::compressedTexImage2DMethodCallback, 0, 7, V8DOMConfiguration::ExposedToAllScripts},
    {"compressedTexSubImage2D", WebGL2RenderingContextV8Internal::compressedTexSubImage2DMethodCallback, 0, 8, V8DOMConfiguration::ExposedToAllScripts},
    {"copyTexImage2D", WebGL2RenderingContextV8Internal::copyTexImage2DMethodCallback, 0, 8, V8DOMConfiguration::ExposedToAllScripts},
    {"copyTexSubImage2D", WebGL2RenderingContextV8Internal::copyTexSubImage2DMethodCallback, 0, 8, V8DOMConfiguration::ExposedToAllScripts},
    {"createBuffer", WebGL2RenderingContextV8Internal::createBufferMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts},
    {"createFramebuffer", WebGL2RenderingContextV8Internal::createFramebufferMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts},
    {"createProgram", WebGL2RenderingContextV8Internal::createProgramMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts},
    {"createRenderbuffer", WebGL2RenderingContextV8Internal::createRenderbufferMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts},
    {"createShader", WebGL2RenderingContextV8Internal::createShaderMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"createTexture", WebGL2RenderingContextV8Internal::createTextureMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts},
    {"cullFace", WebGL2RenderingContextV8Internal::cullFaceMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"deleteBuffer", WebGL2RenderingContextV8Internal::deleteBufferMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"deleteFramebuffer", WebGL2RenderingContextV8Internal::deleteFramebufferMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"deleteProgram", WebGL2RenderingContextV8Internal::deleteProgramMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"deleteRenderbuffer", WebGL2RenderingContextV8Internal::deleteRenderbufferMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"deleteShader", WebGL2RenderingContextV8Internal::deleteShaderMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"deleteTexture", WebGL2RenderingContextV8Internal::deleteTextureMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"depthFunc", WebGL2RenderingContextV8Internal::depthFuncMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"depthMask", WebGL2RenderingContextV8Internal::depthMaskMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"depthRange", WebGL2RenderingContextV8Internal::depthRangeMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"detachShader", WebGL2RenderingContextV8Internal::detachShaderMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"disable", WebGL2RenderingContextV8Internal::disableMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"disableVertexAttribArray", WebGL2RenderingContextV8Internal::disableVertexAttribArrayMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"drawArrays", WebGL2RenderingContextV8Internal::drawArraysMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts},
    {"drawElements", WebGL2RenderingContextV8Internal::drawElementsMethodCallback, 0, 4, V8DOMConfiguration::ExposedToAllScripts},
    {"enable", WebGL2RenderingContextV8Internal::enableMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"enableVertexAttribArray", WebGL2RenderingContextV8Internal::enableVertexAttribArrayMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"finish", WebGL2RenderingContextV8Internal::finishMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts},
    {"flush", WebGL2RenderingContextV8Internal::flushMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts},
    {"framebufferRenderbuffer", WebGL2RenderingContextV8Internal::framebufferRenderbufferMethodCallback, 0, 4, V8DOMConfiguration::ExposedToAllScripts},
    {"framebufferTexture2D", WebGL2RenderingContextV8Internal::framebufferTexture2DMethodCallback, 0, 5, V8DOMConfiguration::ExposedToAllScripts},
    {"frontFace", WebGL2RenderingContextV8Internal::frontFaceMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"generateMipmap", WebGL2RenderingContextV8Internal::generateMipmapMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"getActiveAttrib", WebGL2RenderingContextV8Internal::getActiveAttribMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"getActiveUniform", WebGL2RenderingContextV8Internal::getActiveUniformMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"getAttachedShaders", WebGL2RenderingContextV8Internal::getAttachedShadersMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"getAttribLocation", WebGL2RenderingContextV8Internal::getAttribLocationMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"getBufferParameter", WebGL2RenderingContextV8Internal::getBufferParameterMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"getContextAttributes", WebGL2RenderingContextV8Internal::getContextAttributesMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts},
    {"getError", WebGL2RenderingContextV8Internal::getErrorMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts},
    {"getExtension", WebGL2RenderingContextV8Internal::getExtensionMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"getFramebufferAttachmentParameter", WebGL2RenderingContextV8Internal::getFramebufferAttachmentParameterMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts},
    {"getParameter", WebGL2RenderingContextV8Internal::getParameterMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"getProgramParameter", WebGL2RenderingContextV8Internal::getProgramParameterMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"getProgramInfoLog", WebGL2RenderingContextV8Internal::getProgramInfoLogMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"getRenderbufferParameter", WebGL2RenderingContextV8Internal::getRenderbufferParameterMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"getShaderParameter", WebGL2RenderingContextV8Internal::getShaderParameterMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"getShaderInfoLog", WebGL2RenderingContextV8Internal::getShaderInfoLogMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"getShaderPrecisionFormat", WebGL2RenderingContextV8Internal::getShaderPrecisionFormatMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"getShaderSource", WebGL2RenderingContextV8Internal::getShaderSourceMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"getSupportedExtensions", WebGL2RenderingContextV8Internal::getSupportedExtensionsMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts},
    {"getTexParameter", WebGL2RenderingContextV8Internal::getTexParameterMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"getUniform", WebGL2RenderingContextV8Internal::getUniformMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"getUniformLocation", WebGL2RenderingContextV8Internal::getUniformLocationMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"getVertexAttrib", WebGL2RenderingContextV8Internal::getVertexAttribMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"getVertexAttribOffset", WebGL2RenderingContextV8Internal::getVertexAttribOffsetMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"hint", WebGL2RenderingContextV8Internal::hintMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"isBuffer", WebGL2RenderingContextV8Internal::isBufferMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"isContextLost", WebGL2RenderingContextV8Internal::isContextLostMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts},
    {"isEnabled", WebGL2RenderingContextV8Internal::isEnabledMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"isFramebuffer", WebGL2RenderingContextV8Internal::isFramebufferMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"isProgram", WebGL2RenderingContextV8Internal::isProgramMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"isRenderbuffer", WebGL2RenderingContextV8Internal::isRenderbufferMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"isShader", WebGL2RenderingContextV8Internal::isShaderMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"isTexture", WebGL2RenderingContextV8Internal::isTextureMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"lineWidth", WebGL2RenderingContextV8Internal::lineWidthMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"linkProgram", WebGL2RenderingContextV8Internal::linkProgramMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"pixelStorei", WebGL2RenderingContextV8Internal::pixelStoreiMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"polygonOffset", WebGL2RenderingContextV8Internal::polygonOffsetMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"readPixels", WebGL2RenderingContextV8Internal::readPixelsMethodCallback, 0, 7, V8DOMConfiguration::ExposedToAllScripts},
    {"renderbufferStorage", WebGL2RenderingContextV8Internal::renderbufferStorageMethodCallback, 0, 4, V8DOMConfiguration::ExposedToAllScripts},
    {"sampleCoverage", WebGL2RenderingContextV8Internal::sampleCoverageMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"scissor", WebGL2RenderingContextV8Internal::scissorMethodCallback, 0, 4, V8DOMConfiguration::ExposedToAllScripts},
    {"shaderSource", WebGL2RenderingContextV8Internal::shaderSourceMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"stencilFunc", WebGL2RenderingContextV8Internal::stencilFuncMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts},
    {"stencilFuncSeparate", WebGL2RenderingContextV8Internal::stencilFuncSeparateMethodCallback, 0, 4, V8DOMConfiguration::ExposedToAllScripts},
    {"stencilMask", WebGL2RenderingContextV8Internal::stencilMaskMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"stencilMaskSeparate", WebGL2RenderingContextV8Internal::stencilMaskSeparateMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"stencilOp", WebGL2RenderingContextV8Internal::stencilOpMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts},
    {"stencilOpSeparate", WebGL2RenderingContextV8Internal::stencilOpSeparateMethodCallback, 0, 4, V8DOMConfiguration::ExposedToAllScripts},
    {"texParameterf", WebGL2RenderingContextV8Internal::texParameterfMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts},
    {"texParameteri", WebGL2RenderingContextV8Internal::texParameteriMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts},
    {"texImage2D", WebGL2RenderingContextV8Internal::texImage2DMethodCallback, 0, 6, V8DOMConfiguration::ExposedToAllScripts},
    {"texSubImage2D", WebGL2RenderingContextV8Internal::texSubImage2DMethodCallback, 0, 7, V8DOMConfiguration::ExposedToAllScripts},
    {"uniform1f", WebGL2RenderingContextV8Internal::uniform1fMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"uniform1fv", WebGL2RenderingContextV8Internal::uniform1fvMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"uniform1i", WebGL2RenderingContextV8Internal::uniform1iMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"uniform1iv", WebGL2RenderingContextV8Internal::uniform1ivMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"uniform2f", WebGL2RenderingContextV8Internal::uniform2fMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts},
    {"uniform2fv", WebGL2RenderingContextV8Internal::uniform2fvMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"uniform2i", WebGL2RenderingContextV8Internal::uniform2iMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts},
    {"uniform2iv", WebGL2RenderingContextV8Internal::uniform2ivMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"uniform3f", WebGL2RenderingContextV8Internal::uniform3fMethodCallback, 0, 4, V8DOMConfiguration::ExposedToAllScripts},
    {"uniform3fv", WebGL2RenderingContextV8Internal::uniform3fvMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"uniform3i", WebGL2RenderingContextV8Internal::uniform3iMethodCallback, 0, 4, V8DOMConfiguration::ExposedToAllScripts},
    {"uniform3iv", WebGL2RenderingContextV8Internal::uniform3ivMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"uniform4f", WebGL2RenderingContextV8Internal::uniform4fMethodCallback, 0, 5, V8DOMConfiguration::ExposedToAllScripts},
    {"uniform4fv", WebGL2RenderingContextV8Internal::uniform4fvMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"uniform4i", WebGL2RenderingContextV8Internal::uniform4iMethodCallback, 0, 5, V8DOMConfiguration::ExposedToAllScripts},
    {"uniform4iv", WebGL2RenderingContextV8Internal::uniform4ivMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"uniformMatrix2fv", WebGL2RenderingContextV8Internal::uniformMatrix2fvMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts},
    {"uniformMatrix3fv", WebGL2RenderingContextV8Internal::uniformMatrix3fvMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts},
    {"uniformMatrix4fv", WebGL2RenderingContextV8Internal::uniformMatrix4fvMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts},
    {"useProgram", WebGL2RenderingContextV8Internal::useProgramMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"validateProgram", WebGL2RenderingContextV8Internal::validateProgramMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts},
    {"vertexAttrib1f", WebGL2RenderingContextV8Internal::vertexAttrib1fMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"vertexAttrib1fv", WebGL2RenderingContextV8Internal::vertexAttrib1fvMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"vertexAttrib2f", WebGL2RenderingContextV8Internal::vertexAttrib2fMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts},
    {"vertexAttrib2fv", WebGL2RenderingContextV8Internal::vertexAttrib2fvMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"vertexAttrib3f", WebGL2RenderingContextV8Internal::vertexAttrib3fMethodCallback, 0, 4, V8DOMConfiguration::ExposedToAllScripts},
    {"vertexAttrib3fv", WebGL2RenderingContextV8Internal::vertexAttrib3fvMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"vertexAttrib4f", WebGL2RenderingContextV8Internal::vertexAttrib4fMethodCallback, 0, 5, V8DOMConfiguration::ExposedToAllScripts},
    {"vertexAttrib4fv", WebGL2RenderingContextV8Internal::vertexAttrib4fvMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts},
    {"vertexAttribPointer", WebGL2RenderingContextV8Internal::vertexAttribPointerMethodCallback, 0, 6, V8DOMConfiguration::ExposedToAllScripts},
    {"viewport", WebGL2RenderingContextV8Internal::viewportMethodCallback, 0, 4, V8DOMConfiguration::ExposedToAllScripts},
};

static void installV8WebGL2RenderingContextTemplate(v8::Local<v8::FunctionTemplate> functionTemplate, v8::Isolate* isolate)
{
    functionTemplate->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    if (!RuntimeEnabledFeatures::unsafeES3APIsEnabled())
        defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "WebGL2RenderingContext", v8::Local<v8::FunctionTemplate>(), V8WebGL2RenderingContext::internalFieldCount, 0, 0, 0, 0, 0, 0);
    else
        defaultSignature = V8DOMConfiguration::installDOMClassTemplate(isolate, functionTemplate, "WebGL2RenderingContext", v8::Local<v8::FunctionTemplate>(), V8WebGL2RenderingContext::internalFieldCount,
            0, 0,
            V8WebGL2RenderingContextAccessors, WTF_ARRAY_LENGTH(V8WebGL2RenderingContextAccessors),
            V8WebGL2RenderingContextMethods, WTF_ARRAY_LENGTH(V8WebGL2RenderingContextMethods));
    v8::Local<v8::ObjectTemplate> instanceTemplate = functionTemplate->InstanceTemplate();
    ALLOW_UNUSED_LOCAL(instanceTemplate);
    v8::Local<v8::ObjectTemplate> prototypeTemplate = functionTemplate->PrototypeTemplate();
    ALLOW_UNUSED_LOCAL(prototypeTemplate);
    static const V8DOMConfiguration::ConstantConfiguration V8WebGL2RenderingContextConstants[] = {
        {"DEPTH_BUFFER_BIT", 0x00000100, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_BUFFER_BIT", 0x00000400, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"COLOR_BUFFER_BIT", 0x00004000, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"POINTS", 0x0000, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"LINES", 0x0001, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"LINE_LOOP", 0x0002, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"LINE_STRIP", 0x0003, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TRIANGLES", 0x0004, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TRIANGLE_STRIP", 0x0005, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TRIANGLE_FAN", 0x0006, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ZERO", 0, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ONE", 1, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"SRC_COLOR", 0x0300, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ONE_MINUS_SRC_COLOR", 0x0301, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"SRC_ALPHA", 0x0302, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ONE_MINUS_SRC_ALPHA", 0x0303, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DST_ALPHA", 0x0304, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ONE_MINUS_DST_ALPHA", 0x0305, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DST_COLOR", 0x0306, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ONE_MINUS_DST_COLOR", 0x0307, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"SRC_ALPHA_SATURATE", 0x0308, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FUNC_ADD", 0x8006, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BLEND_EQUATION", 0x8009, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BLEND_EQUATION_RGB", 0x8009, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BLEND_EQUATION_ALPHA", 0x883D, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FUNC_SUBTRACT", 0x800A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FUNC_REVERSE_SUBTRACT", 0x800B, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BLEND_DST_RGB", 0x80C8, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BLEND_SRC_RGB", 0x80C9, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BLEND_DST_ALPHA", 0x80CA, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BLEND_SRC_ALPHA", 0x80CB, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"CONSTANT_COLOR", 0x8001, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ONE_MINUS_CONSTANT_COLOR", 0x8002, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"CONSTANT_ALPHA", 0x8003, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ONE_MINUS_CONSTANT_ALPHA", 0x8004, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BLEND_COLOR", 0x8005, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ARRAY_BUFFER", 0x8892, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ELEMENT_ARRAY_BUFFER", 0x8893, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ARRAY_BUFFER_BINDING", 0x8894, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ELEMENT_ARRAY_BUFFER_BINDING", 0x8895, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STREAM_DRAW", 0x88E0, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STATIC_DRAW", 0x88E4, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DYNAMIC_DRAW", 0x88E8, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BUFFER_SIZE", 0x8764, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BUFFER_USAGE", 0x8765, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"CURRENT_VERTEX_ATTRIB", 0x8626, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FRONT", 0x0404, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BACK", 0x0405, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FRONT_AND_BACK", 0x0408, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE_2D", 0x0DE1, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"CULL_FACE", 0x0B44, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BLEND", 0x0BE2, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DITHER", 0x0BD0, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_TEST", 0x0B90, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DEPTH_TEST", 0x0B71, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"SCISSOR_TEST", 0x0C11, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"POLYGON_OFFSET_FILL", 0x8037, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"SAMPLE_ALPHA_TO_COVERAGE", 0x809E, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"SAMPLE_COVERAGE", 0x80A0, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"NO_ERROR", 0, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"INVALID_ENUM", 0x0500, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"INVALID_VALUE", 0x0501, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"INVALID_OPERATION", 0x0502, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"OUT_OF_MEMORY", 0x0505, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"CW", 0x0900, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"CCW", 0x0901, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"LINE_WIDTH", 0x0B21, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ALIASED_POINT_SIZE_RANGE", 0x846D, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ALIASED_LINE_WIDTH_RANGE", 0x846E, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"CULL_FACE_MODE", 0x0B45, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FRONT_FACE", 0x0B46, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DEPTH_RANGE", 0x0B70, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DEPTH_WRITEMASK", 0x0B72, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DEPTH_CLEAR_VALUE", 0x0B73, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DEPTH_FUNC", 0x0B74, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_CLEAR_VALUE", 0x0B91, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_FUNC", 0x0B92, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_FAIL", 0x0B94, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_PASS_DEPTH_FAIL", 0x0B95, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_PASS_DEPTH_PASS", 0x0B96, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_REF", 0x0B97, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_VALUE_MASK", 0x0B93, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_WRITEMASK", 0x0B98, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_BACK_FUNC", 0x8800, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_BACK_FAIL", 0x8801, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_BACK_PASS_DEPTH_FAIL", 0x8802, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_BACK_PASS_DEPTH_PASS", 0x8803, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_BACK_REF", 0x8CA3, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_BACK_VALUE_MASK", 0x8CA4, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_BACK_WRITEMASK", 0x8CA5, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"VIEWPORT", 0x0BA2, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"SCISSOR_BOX", 0x0C10, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"COLOR_CLEAR_VALUE", 0x0C22, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"COLOR_WRITEMASK", 0x0C23, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"UNPACK_ALIGNMENT", 0x0CF5, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"PACK_ALIGNMENT", 0x0D05, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"MAX_TEXTURE_SIZE", 0x0D33, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"MAX_VIEWPORT_DIMS", 0x0D3A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"SUBPIXEL_BITS", 0x0D50, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RED_BITS", 0x0D52, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"GREEN_BITS", 0x0D53, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BLUE_BITS", 0x0D54, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ALPHA_BITS", 0x0D55, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DEPTH_BITS", 0x0D56, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_BITS", 0x0D57, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"POLYGON_OFFSET_UNITS", 0x2A00, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"POLYGON_OFFSET_FACTOR", 0x8038, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE_BINDING_2D", 0x8069, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"SAMPLE_BUFFERS", 0x80A8, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"SAMPLES", 0x80A9, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"SAMPLE_COVERAGE_VALUE", 0x80AA, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"SAMPLE_COVERAGE_INVERT", 0x80AB, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"COMPRESSED_TEXTURE_FORMATS", 0x86A3, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DONT_CARE", 0x1100, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FASTEST", 0x1101, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"NICEST", 0x1102, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"GENERATE_MIPMAP_HINT", 0x8192, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BYTE", 0x1400, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"UNSIGNED_BYTE", 0x1401, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"SHORT", 0x1402, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"UNSIGNED_SHORT", 0x1403, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"INT", 0x1404, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"UNSIGNED_INT", 0x1405, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FLOAT", 0x1406, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DEPTH_COMPONENT", 0x1902, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ALPHA", 0x1906, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RGB", 0x1907, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RGBA", 0x1908, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"LUMINANCE", 0x1909, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"LUMINANCE_ALPHA", 0x190A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"UNSIGNED_SHORT_4_4_4_4", 0x8033, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"UNSIGNED_SHORT_5_5_5_1", 0x8034, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"UNSIGNED_SHORT_5_6_5", 0x8363, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FRAGMENT_SHADER", 0x8B30, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"VERTEX_SHADER", 0x8B31, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"MAX_VERTEX_ATTRIBS", 0x8869, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"MAX_VERTEX_UNIFORM_VECTORS", 0x8DFB, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"MAX_VARYING_VECTORS", 0x8DFC, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"MAX_COMBINED_TEXTURE_IMAGE_UNITS", 0x8B4D, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"MAX_VERTEX_TEXTURE_IMAGE_UNITS", 0x8B4C, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"MAX_TEXTURE_IMAGE_UNITS", 0x8872, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"MAX_FRAGMENT_UNIFORM_VECTORS", 0x8DFD, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"SHADER_TYPE", 0x8B4F, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DELETE_STATUS", 0x8B80, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"LINK_STATUS", 0x8B82, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"VALIDATE_STATUS", 0x8B83, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ATTACHED_SHADERS", 0x8B85, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ACTIVE_UNIFORMS", 0x8B86, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ACTIVE_ATTRIBUTES", 0x8B89, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"SHADING_LANGUAGE_VERSION", 0x8B8C, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"CURRENT_PROGRAM", 0x8B8D, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"NEVER", 0x0200, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"LESS", 0x0201, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"EQUAL", 0x0202, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"LEQUAL", 0x0203, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"GREATER", 0x0204, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"NOTEQUAL", 0x0205, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"GEQUAL", 0x0206, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ALWAYS", 0x0207, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"KEEP", 0x1E00, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"REPLACE", 0x1E01, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"INCR", 0x1E02, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DECR", 0x1E03, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"INVERT", 0x150A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"INCR_WRAP", 0x8507, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DECR_WRAP", 0x8508, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"VENDOR", 0x1F00, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RENDERER", 0x1F01, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"VERSION", 0x1F02, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"NEAREST", 0x2600, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"LINEAR", 0x2601, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"NEAREST_MIPMAP_NEAREST", 0x2700, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"LINEAR_MIPMAP_NEAREST", 0x2701, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"NEAREST_MIPMAP_LINEAR", 0x2702, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"LINEAR_MIPMAP_LINEAR", 0x2703, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE_MAG_FILTER", 0x2800, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE_MIN_FILTER", 0x2801, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE_WRAP_S", 0x2802, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE_WRAP_T", 0x2803, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE", 0x1702, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE_CUBE_MAP", 0x8513, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE_BINDING_CUBE_MAP", 0x8514, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE_CUBE_MAP_POSITIVE_X", 0x8515, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE_CUBE_MAP_NEGATIVE_X", 0x8516, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE_CUBE_MAP_POSITIVE_Y", 0x8517, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE_CUBE_MAP_NEGATIVE_Y", 0x8518, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE_CUBE_MAP_POSITIVE_Z", 0x8519, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE_CUBE_MAP_NEGATIVE_Z", 0x851A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"MAX_CUBE_MAP_TEXTURE_SIZE", 0x851C, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE0", 0x84C0, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE1", 0x84C1, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE2", 0x84C2, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE3", 0x84C3, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE4", 0x84C4, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE5", 0x84C5, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE6", 0x84C6, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE7", 0x84C7, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE8", 0x84C8, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE9", 0x84C9, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE10", 0x84CA, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE11", 0x84CB, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE12", 0x84CC, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE13", 0x84CD, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE14", 0x84CE, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE15", 0x84CF, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE16", 0x84D0, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE17", 0x84D1, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE18", 0x84D2, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE19", 0x84D3, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE20", 0x84D4, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE21", 0x84D5, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE22", 0x84D6, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE23", 0x84D7, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE24", 0x84D8, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE25", 0x84D9, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE26", 0x84DA, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE27", 0x84DB, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE28", 0x84DC, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE29", 0x84DD, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE30", 0x84DE, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"TEXTURE31", 0x84DF, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"ACTIVE_TEXTURE", 0x84E0, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"REPEAT", 0x2901, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"CLAMP_TO_EDGE", 0x812F, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"MIRRORED_REPEAT", 0x8370, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FLOAT_VEC2", 0x8B50, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FLOAT_VEC3", 0x8B51, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FLOAT_VEC4", 0x8B52, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"INT_VEC2", 0x8B53, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"INT_VEC3", 0x8B54, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"INT_VEC4", 0x8B55, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BOOL", 0x8B56, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BOOL_VEC2", 0x8B57, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BOOL_VEC3", 0x8B58, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BOOL_VEC4", 0x8B59, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FLOAT_MAT2", 0x8B5A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FLOAT_MAT3", 0x8B5B, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FLOAT_MAT4", 0x8B5C, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"SAMPLER_2D", 0x8B5E, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"SAMPLER_CUBE", 0x8B60, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"VERTEX_ATTRIB_ARRAY_ENABLED", 0x8622, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"VERTEX_ATTRIB_ARRAY_SIZE", 0x8623, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"VERTEX_ATTRIB_ARRAY_STRIDE", 0x8624, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"VERTEX_ATTRIB_ARRAY_TYPE", 0x8625, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"VERTEX_ATTRIB_ARRAY_NORMALIZED", 0x886A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"VERTEX_ATTRIB_ARRAY_POINTER", 0x8645, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"VERTEX_ATTRIB_ARRAY_BUFFER_BINDING", 0x889F, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"IMPLEMENTATION_COLOR_READ_TYPE", 0x8B9A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"IMPLEMENTATION_COLOR_READ_FORMAT", 0x8B9B, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"COMPILE_STATUS", 0x8B81, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"LOW_FLOAT", 0x8DF0, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"MEDIUM_FLOAT", 0x8DF1, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"HIGH_FLOAT", 0x8DF2, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"LOW_INT", 0x8DF3, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"MEDIUM_INT", 0x8DF4, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"HIGH_INT", 0x8DF5, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FRAMEBUFFER", 0x8D40, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RENDERBUFFER", 0x8D41, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RGBA4", 0x8056, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RGB5_A1", 0x8057, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RGB565", 0x8D62, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DEPTH_COMPONENT16", 0x81A5, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_INDEX", 0x1901, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_INDEX8", 0x8D48, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DEPTH_STENCIL", 0x84F9, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RENDERBUFFER_WIDTH", 0x8D42, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RENDERBUFFER_HEIGHT", 0x8D43, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RENDERBUFFER_INTERNAL_FORMAT", 0x8D44, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RENDERBUFFER_RED_SIZE", 0x8D50, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RENDERBUFFER_GREEN_SIZE", 0x8D51, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RENDERBUFFER_BLUE_SIZE", 0x8D52, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RENDERBUFFER_ALPHA_SIZE", 0x8D53, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RENDERBUFFER_DEPTH_SIZE", 0x8D54, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RENDERBUFFER_STENCIL_SIZE", 0x8D55, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE", 0x8CD0, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FRAMEBUFFER_ATTACHMENT_OBJECT_NAME", 0x8CD1, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL", 0x8CD2, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE", 0x8CD3, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"COLOR_ATTACHMENT0", 0x8CE0, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DEPTH_ATTACHMENT", 0x8D00, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"STENCIL_ATTACHMENT", 0x8D20, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"DEPTH_STENCIL_ATTACHMENT", 0x821A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"NONE", 0, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FRAMEBUFFER_COMPLETE", 0x8CD5, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FRAMEBUFFER_INCOMPLETE_ATTACHMENT", 0x8CD6, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT", 0x8CD7, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FRAMEBUFFER_INCOMPLETE_DIMENSIONS", 0x8CD9, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FRAMEBUFFER_UNSUPPORTED", 0x8CDD, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"FRAMEBUFFER_BINDING", 0x8CA6, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"RENDERBUFFER_BINDING", 0x8CA7, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"MAX_RENDERBUFFER_SIZE", 0x84E8, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"INVALID_FRAMEBUFFER_OPERATION", 0x0506, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"UNPACK_FLIP_Y_WEBGL", 0x9240, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"UNPACK_PREMULTIPLY_ALPHA_WEBGL", 0x9241, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"CONTEXT_LOST_WEBGL", 0x9242, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"UNPACK_COLORSPACE_CONVERSION_WEBGL", 0x9243, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
        {"BROWSER_DEFAULT_WEBGL", 0x9244, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong},
    };
    V8DOMConfiguration::installConstants(isolate, functionTemplate, prototypeTemplate, V8WebGL2RenderingContextConstants, WTF_ARRAY_LENGTH(V8WebGL2RenderingContextConstants));
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"READ_BUFFER", 0x0C02, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNPACK_ROW_LENGTH", 0x0CF2, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNPACK_SKIP_ROWS", 0x0CF3, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNPACK_SKIP_PIXELS", 0x0CF4, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"PACK_ROW_LENGTH", 0x0D02, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"PACK_SKIP_ROWS", 0x0D03, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"PACK_SKIP_PIXELS", 0x0D04, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COLOR", 0x1800, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DEPTH", 0x1801, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"STENCIL", 0x1802, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RED", 0x1903, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGB8", 0x8051, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGBA8", 0x8058, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGB10_A2", 0x8059, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TEXTURE_BINDING_3D", 0x806A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNPACK_SKIP_IMAGES", 0x806D, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNPACK_IMAGE_HEIGHT", 0x806E, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TEXTURE_3D", 0x806F, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TEXTURE_WRAP_R", 0x8072, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_3D_TEXTURE_SIZE", 0x8073, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNSIGNED_INT_2_10_10_10_REV", 0x8368, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_ELEMENTS_VERTICES", 0x80E8, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_ELEMENTS_INDICES", 0x80E9, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TEXTURE_MIN_LOD", 0x813A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TEXTURE_MAX_LOD", 0x813B, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TEXTURE_BASE_LEVEL", 0x813C, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TEXTURE_MAX_LEVEL", 0x813D, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MIN", 0x8007, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX", 0x8008, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DEPTH_COMPONENT24", 0x81A6, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_TEXTURE_LOD_BIAS", 0x84FD, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TEXTURE_COMPARE_MODE", 0x884C, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TEXTURE_COMPARE_FUNC", 0x884D, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"CURRENT_QUERY", 0x8865, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"QUERY_RESULT", 0x8866, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"QUERY_RESULT_AVAILABLE", 0x8867, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"STREAM_READ", 0x88E1, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"STREAM_COPY", 0x88E2, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"STATIC_READ", 0x88E5, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"STATIC_COPY", 0x88E6, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DYNAMIC_READ", 0x88E9, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DYNAMIC_COPY", 0x88EA, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_DRAW_BUFFERS", 0x8824, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_BUFFER0", 0x8825, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_BUFFER1", 0x8826, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_BUFFER2", 0x8827, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_BUFFER3", 0x8828, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_BUFFER4", 0x8829, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_BUFFER5", 0x882A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_BUFFER6", 0x882B, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_BUFFER7", 0x882C, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_BUFFER8", 0x882D, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_BUFFER9", 0x882E, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_BUFFER10", 0x882F, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_BUFFER11", 0x8830, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_BUFFER12", 0x8831, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_BUFFER13", 0x8832, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_BUFFER14", 0x8833, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_BUFFER15", 0x8834, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_FRAGMENT_UNIFORM_COMPONENTS", 0x8B49, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_VERTEX_UNIFORM_COMPONENTS", 0x8B4A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SAMPLER_3D", 0x8B5F, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SAMPLER_2D_SHADOW", 0x8B62, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FRAGMENT_SHADER_DERIVATIVE_HINT", 0x8B8B, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"PIXEL_PACK_BUFFER", 0x88EB, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"PIXEL_UNPACK_BUFFER", 0x88EC, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"PIXEL_PACK_BUFFER_BINDING", 0x88ED, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"PIXEL_UNPACK_BUFFER_BINDING", 0x88EF, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FLOAT_MAT2x3", 0x8B65, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FLOAT_MAT2x4", 0x8B66, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FLOAT_MAT3x2", 0x8B67, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FLOAT_MAT3x4", 0x8B68, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FLOAT_MAT4x2", 0x8B69, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FLOAT_MAT4x3", 0x8B6A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SRGB", 0x8C40, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SRGB8", 0x8C41, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SRGB8_ALPHA8", 0x8C43, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COMPARE_REF_TO_TEXTURE", 0x884E, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGBA32F", 0x8814, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGB32F", 0x8815, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGBA16F", 0x881A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGB16F", 0x881B, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"VERTEX_ATTRIB_ARRAY_INTEGER", 0x88FD, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_ARRAY_TEXTURE_LAYERS", 0x88FF, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MIN_PROGRAM_TEXEL_OFFSET", 0x8904, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_PROGRAM_TEXEL_OFFSET", 0x8905, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_VARYING_COMPONENTS", 0x8B4B, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TEXTURE_2D_ARRAY", 0x8C1A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TEXTURE_BINDING_2D_ARRAY", 0x8C1D, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"R11F_G11F_B10F", 0x8C3A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNSIGNED_INT_10F_11F_11F_REV", 0x8C3B, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGB9_E5", 0x8C3D, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNSIGNED_INT_5_9_9_9_REV", 0x8C3E, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TRANSFORM_FEEDBACK_BUFFER_MODE", 0x8C7F, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS", 0x8C80, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TRANSFORM_FEEDBACK_VARYINGS", 0x8C83, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TRANSFORM_FEEDBACK_BUFFER_START", 0x8C84, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TRANSFORM_FEEDBACK_BUFFER_SIZE", 0x8C85, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN", 0x8C88, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RASTERIZER_DISCARD", 0x8C89, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS", 0x8C8A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS", 0x8C8B, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"INTERLEAVED_ATTRIBS", 0x8C8C, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SEPARATE_ATTRIBS", 0x8C8D, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TRANSFORM_FEEDBACK_BUFFER", 0x8C8E, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TRANSFORM_FEEDBACK_BUFFER_BINDING", 0x8C8F, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGBA32UI", 0x8D70, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGB32UI", 0x8D71, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGBA16UI", 0x8D76, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGB16UI", 0x8D77, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGBA8UI", 0x8D7C, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGB8UI", 0x8D7D, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGBA32I", 0x8D82, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGB32I", 0x8D83, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGBA16I", 0x8D88, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGB16I", 0x8D89, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGBA8I", 0x8D8E, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGB8I", 0x8D8F, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RED_INTEGER", 0x8D94, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGB_INTEGER", 0x8D98, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGBA_INTEGER", 0x8D99, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SAMPLER_2D_ARRAY", 0x8DC1, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SAMPLER_2D_ARRAY_SHADOW", 0x8DC4, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SAMPLER_CUBE_SHADOW", 0x8DC5, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNSIGNED_INT_VEC2", 0x8DC6, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNSIGNED_INT_VEC3", 0x8DC7, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNSIGNED_INT_VEC4", 0x8DC8, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"INT_SAMPLER_2D", 0x8DCA, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"INT_SAMPLER_3D", 0x8DCB, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"INT_SAMPLER_CUBE", 0x8DCC, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"INT_SAMPLER_2D_ARRAY", 0x8DCF, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNSIGNED_INT_SAMPLER_2D", 0x8DD2, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNSIGNED_INT_SAMPLER_3D", 0x8DD3, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNSIGNED_INT_SAMPLER_CUBE", 0x8DD4, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNSIGNED_INT_SAMPLER_2D_ARRAY", 0x8DD7, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DEPTH_COMPONENT32F", 0x8CAC, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DEPTH32F_STENCIL8", 0x8CAD, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FLOAT_32_UNSIGNED_INT_24_8_REV", 0x8DAD, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING", 0x8210, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE", 0x8211, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FRAMEBUFFER_ATTACHMENT_RED_SIZE", 0x8212, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FRAMEBUFFER_ATTACHMENT_GREEN_SIZE", 0x8213, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FRAMEBUFFER_ATTACHMENT_BLUE_SIZE", 0x8214, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE", 0x8215, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE", 0x8216, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE", 0x8217, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FRAMEBUFFER_DEFAULT", 0x8218, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNSIGNED_INT_24_8", 0x84FA, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DEPTH24_STENCIL8", 0x88F0, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNSIGNED_NORMALIZED", 0x8C17, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_FRAMEBUFFER_BINDING", 0x8CA6, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"READ_FRAMEBUFFER", 0x8CA8, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"DRAW_FRAMEBUFFER", 0x8CA9, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"READ_FRAMEBUFFER_BINDING", 0x8CAA, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RENDERBUFFER_SAMPLES", 0x8CAB, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER", 0x8CD4, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_COLOR_ATTACHMENTS", 0x8CDF, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COLOR_ATTACHMENT1", 0x8CE1, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COLOR_ATTACHMENT2", 0x8CE2, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COLOR_ATTACHMENT3", 0x8CE3, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COLOR_ATTACHMENT4", 0x8CE4, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COLOR_ATTACHMENT5", 0x8CE5, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COLOR_ATTACHMENT6", 0x8CE6, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COLOR_ATTACHMENT7", 0x8CE7, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COLOR_ATTACHMENT8", 0x8CE8, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COLOR_ATTACHMENT9", 0x8CE9, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COLOR_ATTACHMENT10", 0x8CEA, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COLOR_ATTACHMENT11", 0x8CEB, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COLOR_ATTACHMENT12", 0x8CEC, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COLOR_ATTACHMENT13", 0x8CED, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COLOR_ATTACHMENT14", 0x8CEE, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COLOR_ATTACHMENT15", 0x8CEF, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"FRAMEBUFFER_INCOMPLETE_MULTISAMPLE", 0x8D56, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_SAMPLES", 0x8D57, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"HALF_FLOAT", 0x140B, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RG", 0x8227, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RG_INTEGER", 0x8228, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"R8", 0x8229, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RG8", 0x822B, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"R16F", 0x822D, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"R32F", 0x822E, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RG16F", 0x822F, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RG32F", 0x8230, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"R8I", 0x8231, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"R8UI", 0x8232, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"R16I", 0x8233, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"R16UI", 0x8234, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"R32I", 0x8235, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"R32UI", 0x8236, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RG8I", 0x8237, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RG8UI", 0x8238, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RG16I", 0x8239, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RG16UI", 0x823A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RG32I", 0x823B, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RG32UI", 0x823C, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"VERTEX_ARRAY_BINDING", 0x85B5, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"R8_SNORM", 0x8F94, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RG8_SNORM", 0x8F95, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGB8_SNORM", 0x8F96, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGBA8_SNORM", 0x8F97, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SIGNED_NORMALIZED", 0x8F9C, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COPY_READ_BUFFER", 0x8F36, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COPY_WRITE_BUFFER", 0x8F37, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COPY_READ_BUFFER_BINDING", 0x8F36, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COPY_WRITE_BUFFER_BINDING", 0x8F37, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_BUFFER", 0x8A11, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_BUFFER_BINDING", 0x8A28, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_BUFFER_START", 0x8A29, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_BUFFER_SIZE", 0x8A2A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_VERTEX_UNIFORM_BLOCKS", 0x8A2B, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_FRAGMENT_UNIFORM_BLOCKS", 0x8A2D, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_COMBINED_UNIFORM_BLOCKS", 0x8A2E, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_UNIFORM_BUFFER_BINDINGS", 0x8A2F, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_UNIFORM_BLOCK_SIZE", 0x8A30, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS", 0x8A31, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS", 0x8A33, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_BUFFER_OFFSET_ALIGNMENT", 0x8A34, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"ACTIVE_UNIFORM_BLOCKS", 0x8A36, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_TYPE", 0x8A37, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_SIZE", 0x8A38, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_BLOCK_INDEX", 0x8A3A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_OFFSET", 0x8A3B, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_ARRAY_STRIDE", 0x8A3C, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_MATRIX_STRIDE", 0x8A3D, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_IS_ROW_MAJOR", 0x8A3E, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_BLOCK_BINDING", 0x8A3F, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_BLOCK_DATA_SIZE", 0x8A40, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_BLOCK_ACTIVE_UNIFORMS", 0x8A42, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES", 0x8A43, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER", 0x8A44, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER", 0x8A46, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"INVALID_INDEX", 0xFFFFFFFF, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_VERTEX_OUTPUT_COMPONENTS", 0x9122, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_FRAGMENT_INPUT_COMPONENTS", 0x9125, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_SERVER_WAIT_TIMEOUT", 0x9111, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"OBJECT_TYPE", 0x9112, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SYNC_CONDITION", 0x9113, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SYNC_STATUS", 0x9114, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SYNC_FLAGS", 0x9115, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SYNC_FENCE", 0x9116, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SYNC_GPU_COMMANDS_COMPLETE", 0x9117, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"UNSIGNALED", 0x9118, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SIGNALED", 0x9119, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"ALREADY_SIGNALED", 0x911A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TIMEOUT_EXPIRED", 0x911B, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"CONDITION_SATISFIED", 0x911C, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"WAIT_FAILED", 0x911D, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SYNC_FLUSH_COMMANDS_BIT", 0x00000001, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"VERTEX_ATTRIB_ARRAY_DIVISOR", 0x88FE, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"ANY_SAMPLES_PASSED", 0x8C2F, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"ANY_SAMPLES_PASSED_CONSERVATIVE", 0x8D6A, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"SAMPLER_BINDING", 0x8919, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"RGB10_A2UI", 0x906F, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"GREEN", 0x1904, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"BLUE", 0x1905, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"INT_2_10_10_10_REV", 0x8D9F, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TRANSFORM_FEEDBACK", 0x8E22, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TRANSFORM_FEEDBACK_PAUSED", 0x8E23, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TRANSFORM_FEEDBACK_ACTIVE", 0x8E24, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TRANSFORM_FEEDBACK_BINDING", 0x8E25, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COMPRESSED_R11_EAC", 0x9270, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COMPRESSED_SIGNED_R11_EAC", 0x9271, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COMPRESSED_RG11_EAC", 0x9272, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COMPRESSED_SIGNED_RG11_EAC", 0x9273, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COMPRESSED_RGB8_ETC2", 0x9274, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COMPRESSED_SRGB8_ETC2", 0x9275, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2", 0x9276, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2", 0x9277, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COMPRESSED_RGBA8_ETC2_EAC", 0x9278, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"COMPRESSED_SRGB8_ALPHA8_ETC2_EAC", 0x9279, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TEXTURE_IMMUTABLE_FORMAT", 0x912F, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_ELEMENT_INDEX", 0x8D6B, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"NUM_SAMPLE_COUNTS", 0x9380, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TEXTURE_IMMUTABLE_LEVELS", 0x82DF, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"TIMEOUT_IGNORED", 0xFFFFFFFF, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        static const V8DOMConfiguration::ConstantConfiguration constantConfiguration = {"MAX_CLIENT_WAIT_TIMEOUT_WEBGL", 0x9247, 0, 0, V8DOMConfiguration::ConstantTypeUnsignedLong};
        V8DOMConfiguration::installConstant(isolate, functionTemplate, prototypeTemplate, constantConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration copyBufferSubDataMethodConfiguration = {
            "copyBufferSubData", WebGL2RenderingContextV8Internal::copyBufferSubDataMethodCallback, 0, 5, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, copyBufferSubDataMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration getBufferSubDataMethodConfiguration = {
            "getBufferSubData", WebGL2RenderingContextV8Internal::getBufferSubDataMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, getBufferSubDataMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration blitFramebufferMethodConfiguration = {
            "blitFramebuffer", WebGL2RenderingContextV8Internal::blitFramebufferMethodCallback, 0, 10, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, blitFramebufferMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration framebufferTextureLayerMethodConfiguration = {
            "framebufferTextureLayer", WebGL2RenderingContextV8Internal::framebufferTextureLayerMethodCallback, 0, 5, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, framebufferTextureLayerMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration getInternalformatParameterMethodConfiguration = {
            "getInternalformatParameter", WebGL2RenderingContextV8Internal::getInternalformatParameterMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, getInternalformatParameterMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration invalidateFramebufferMethodConfiguration = {
            "invalidateFramebuffer", WebGL2RenderingContextV8Internal::invalidateFramebufferMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, invalidateFramebufferMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration invalidateSubFramebufferMethodConfiguration = {
            "invalidateSubFramebuffer", WebGL2RenderingContextV8Internal::invalidateSubFramebufferMethodCallback, 0, 6, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, invalidateSubFramebufferMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration readBufferMethodConfiguration = {
            "readBuffer", WebGL2RenderingContextV8Internal::readBufferMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, readBufferMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration renderbufferStorageMultisampleMethodConfiguration = {
            "renderbufferStorageMultisample", WebGL2RenderingContextV8Internal::renderbufferStorageMultisampleMethodCallback, 0, 5, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, renderbufferStorageMultisampleMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration texStorage2DMethodConfiguration = {
            "texStorage2D", WebGL2RenderingContextV8Internal::texStorage2DMethodCallback, 0, 5, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, texStorage2DMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration texStorage3DMethodConfiguration = {
            "texStorage3D", WebGL2RenderingContextV8Internal::texStorage3DMethodCallback, 0, 6, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, texStorage3DMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration texImage3DMethodConfiguration = {
            "texImage3D", WebGL2RenderingContextV8Internal::texImage3DMethodCallback, 0, 10, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, texImage3DMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration texSubImage3DMethodConfiguration = {
            "texSubImage3D", WebGL2RenderingContextV8Internal::texSubImage3DMethodCallback, 0, 8, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, texSubImage3DMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration copyTexSubImage3DMethodConfiguration = {
            "copyTexSubImage3D", WebGL2RenderingContextV8Internal::copyTexSubImage3DMethodCallback, 0, 9, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, copyTexSubImage3DMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration compressedTexImage3DMethodConfiguration = {
            "compressedTexImage3D", WebGL2RenderingContextV8Internal::compressedTexImage3DMethodCallback, 0, 8, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, compressedTexImage3DMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration compressedTexSubImage3DMethodConfiguration = {
            "compressedTexSubImage3D", WebGL2RenderingContextV8Internal::compressedTexSubImage3DMethodCallback, 0, 10, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, compressedTexSubImage3DMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration getFragDataLocationMethodConfiguration = {
            "getFragDataLocation", WebGL2RenderingContextV8Internal::getFragDataLocationMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, getFragDataLocationMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration uniform1uiMethodConfiguration = {
            "uniform1ui", WebGL2RenderingContextV8Internal::uniform1uiMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, uniform1uiMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration uniform2uiMethodConfiguration = {
            "uniform2ui", WebGL2RenderingContextV8Internal::uniform2uiMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, uniform2uiMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration uniform3uiMethodConfiguration = {
            "uniform3ui", WebGL2RenderingContextV8Internal::uniform3uiMethodCallback, 0, 4, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, uniform3uiMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration uniform4uiMethodConfiguration = {
            "uniform4ui", WebGL2RenderingContextV8Internal::uniform4uiMethodCallback, 0, 5, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, uniform4uiMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration uniform1uivMethodConfiguration = {
            "uniform1uiv", WebGL2RenderingContextV8Internal::uniform1uivMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, uniform1uivMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration uniform2uivMethodConfiguration = {
            "uniform2uiv", WebGL2RenderingContextV8Internal::uniform2uivMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, uniform2uivMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration uniform3uivMethodConfiguration = {
            "uniform3uiv", WebGL2RenderingContextV8Internal::uniform3uivMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, uniform3uivMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration uniform4uivMethodConfiguration = {
            "uniform4uiv", WebGL2RenderingContextV8Internal::uniform4uivMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, uniform4uivMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration uniformMatrix2x3fvMethodConfiguration = {
            "uniformMatrix2x3fv", WebGL2RenderingContextV8Internal::uniformMatrix2x3fvMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, uniformMatrix2x3fvMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration uniformMatrix3x2fvMethodConfiguration = {
            "uniformMatrix3x2fv", WebGL2RenderingContextV8Internal::uniformMatrix3x2fvMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, uniformMatrix3x2fvMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration uniformMatrix2x4fvMethodConfiguration = {
            "uniformMatrix2x4fv", WebGL2RenderingContextV8Internal::uniformMatrix2x4fvMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, uniformMatrix2x4fvMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration uniformMatrix4x2fvMethodConfiguration = {
            "uniformMatrix4x2fv", WebGL2RenderingContextV8Internal::uniformMatrix4x2fvMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, uniformMatrix4x2fvMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration uniformMatrix3x4fvMethodConfiguration = {
            "uniformMatrix3x4fv", WebGL2RenderingContextV8Internal::uniformMatrix3x4fvMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, uniformMatrix3x4fvMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration uniformMatrix4x3fvMethodConfiguration = {
            "uniformMatrix4x3fv", WebGL2RenderingContextV8Internal::uniformMatrix4x3fvMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, uniformMatrix4x3fvMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration vertexAttribI4iMethodConfiguration = {
            "vertexAttribI4i", WebGL2RenderingContextV8Internal::vertexAttribI4iMethodCallback, 0, 5, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, vertexAttribI4iMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration vertexAttribI4ivMethodConfiguration = {
            "vertexAttribI4iv", WebGL2RenderingContextV8Internal::vertexAttribI4ivMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, vertexAttribI4ivMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration vertexAttribI4uiMethodConfiguration = {
            "vertexAttribI4ui", WebGL2RenderingContextV8Internal::vertexAttribI4uiMethodCallback, 0, 5, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, vertexAttribI4uiMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration vertexAttribI4uivMethodConfiguration = {
            "vertexAttribI4uiv", WebGL2RenderingContextV8Internal::vertexAttribI4uivMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, vertexAttribI4uivMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration vertexAttribIPointerMethodConfiguration = {
            "vertexAttribIPointer", WebGL2RenderingContextV8Internal::vertexAttribIPointerMethodCallback, 0, 5, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, vertexAttribIPointerMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration vertexAttribDivisorMethodConfiguration = {
            "vertexAttribDivisor", WebGL2RenderingContextV8Internal::vertexAttribDivisorMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, vertexAttribDivisorMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration drawArraysInstancedMethodConfiguration = {
            "drawArraysInstanced", WebGL2RenderingContextV8Internal::drawArraysInstancedMethodCallback, 0, 4, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, drawArraysInstancedMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration drawElementsInstancedMethodConfiguration = {
            "drawElementsInstanced", WebGL2RenderingContextV8Internal::drawElementsInstancedMethodCallback, 0, 5, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, drawElementsInstancedMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration drawRangeElementsMethodConfiguration = {
            "drawRangeElements", WebGL2RenderingContextV8Internal::drawRangeElementsMethodCallback, 0, 6, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, drawRangeElementsMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration drawBuffersMethodConfiguration = {
            "drawBuffers", WebGL2RenderingContextV8Internal::drawBuffersMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, drawBuffersMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration clearBufferivMethodConfiguration = {
            "clearBufferiv", WebGL2RenderingContextV8Internal::clearBufferivMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, clearBufferivMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration clearBufferuivMethodConfiguration = {
            "clearBufferuiv", WebGL2RenderingContextV8Internal::clearBufferuivMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, clearBufferuivMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration clearBufferfvMethodConfiguration = {
            "clearBufferfv", WebGL2RenderingContextV8Internal::clearBufferfvMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, clearBufferfvMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration clearBufferfiMethodConfiguration = {
            "clearBufferfi", WebGL2RenderingContextV8Internal::clearBufferfiMethodCallback, 0, 4, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, clearBufferfiMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration createQueryMethodConfiguration = {
            "createQuery", WebGL2RenderingContextV8Internal::createQueryMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, createQueryMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration deleteQueryMethodConfiguration = {
            "deleteQuery", WebGL2RenderingContextV8Internal::deleteQueryMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, deleteQueryMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration isQueryMethodConfiguration = {
            "isQuery", WebGL2RenderingContextV8Internal::isQueryMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, isQueryMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration beginQueryMethodConfiguration = {
            "beginQuery", WebGL2RenderingContextV8Internal::beginQueryMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, beginQueryMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration endQueryMethodConfiguration = {
            "endQuery", WebGL2RenderingContextV8Internal::endQueryMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, endQueryMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration getQueryMethodConfiguration = {
            "getQuery", WebGL2RenderingContextV8Internal::getQueryMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, getQueryMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration getQueryParameterMethodConfiguration = {
            "getQueryParameter", WebGL2RenderingContextV8Internal::getQueryParameterMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, getQueryParameterMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration createSamplerMethodConfiguration = {
            "createSampler", WebGL2RenderingContextV8Internal::createSamplerMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, createSamplerMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration deleteSamplerMethodConfiguration = {
            "deleteSampler", WebGL2RenderingContextV8Internal::deleteSamplerMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, deleteSamplerMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration isSamplerMethodConfiguration = {
            "isSampler", WebGL2RenderingContextV8Internal::isSamplerMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, isSamplerMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration bindSamplerMethodConfiguration = {
            "bindSampler", WebGL2RenderingContextV8Internal::bindSamplerMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, bindSamplerMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration samplerParameteriMethodConfiguration = {
            "samplerParameteri", WebGL2RenderingContextV8Internal::samplerParameteriMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, samplerParameteriMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration samplerParameterfMethodConfiguration = {
            "samplerParameterf", WebGL2RenderingContextV8Internal::samplerParameterfMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, samplerParameterfMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration getSamplerParameterMethodConfiguration = {
            "getSamplerParameter", WebGL2RenderingContextV8Internal::getSamplerParameterMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, getSamplerParameterMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration fenceSyncMethodConfiguration = {
            "fenceSync", WebGL2RenderingContextV8Internal::fenceSyncMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, fenceSyncMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration isSyncMethodConfiguration = {
            "isSync", WebGL2RenderingContextV8Internal::isSyncMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, isSyncMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration deleteSyncMethodConfiguration = {
            "deleteSync", WebGL2RenderingContextV8Internal::deleteSyncMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, deleteSyncMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration clientWaitSyncMethodConfiguration = {
            "clientWaitSync", WebGL2RenderingContextV8Internal::clientWaitSyncMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, clientWaitSyncMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration waitSyncMethodConfiguration = {
            "waitSync", WebGL2RenderingContextV8Internal::waitSyncMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, waitSyncMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration getSyncParameterMethodConfiguration = {
            "getSyncParameter", WebGL2RenderingContextV8Internal::getSyncParameterMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, getSyncParameterMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration createTransformFeedbackMethodConfiguration = {
            "createTransformFeedback", WebGL2RenderingContextV8Internal::createTransformFeedbackMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, createTransformFeedbackMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration deleteTransformFeedbackMethodConfiguration = {
            "deleteTransformFeedback", WebGL2RenderingContextV8Internal::deleteTransformFeedbackMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, deleteTransformFeedbackMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration isTransformFeedbackMethodConfiguration = {
            "isTransformFeedback", WebGL2RenderingContextV8Internal::isTransformFeedbackMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, isTransformFeedbackMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration bindTransformFeedbackMethodConfiguration = {
            "bindTransformFeedback", WebGL2RenderingContextV8Internal::bindTransformFeedbackMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, bindTransformFeedbackMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration beginTransformFeedbackMethodConfiguration = {
            "beginTransformFeedback", WebGL2RenderingContextV8Internal::beginTransformFeedbackMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, beginTransformFeedbackMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration endTransformFeedbackMethodConfiguration = {
            "endTransformFeedback", WebGL2RenderingContextV8Internal::endTransformFeedbackMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, endTransformFeedbackMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration transformFeedbackVaryingsMethodConfiguration = {
            "transformFeedbackVaryings", WebGL2RenderingContextV8Internal::transformFeedbackVaryingsMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, transformFeedbackVaryingsMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration getTransformFeedbackVaryingMethodConfiguration = {
            "getTransformFeedbackVarying", WebGL2RenderingContextV8Internal::getTransformFeedbackVaryingMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, getTransformFeedbackVaryingMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration pauseTransformFeedbackMethodConfiguration = {
            "pauseTransformFeedback", WebGL2RenderingContextV8Internal::pauseTransformFeedbackMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, pauseTransformFeedbackMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration resumeTransformFeedbackMethodConfiguration = {
            "resumeTransformFeedback", WebGL2RenderingContextV8Internal::resumeTransformFeedbackMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, resumeTransformFeedbackMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration bindBufferBaseMethodConfiguration = {
            "bindBufferBase", WebGL2RenderingContextV8Internal::bindBufferBaseMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, bindBufferBaseMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration bindBufferRangeMethodConfiguration = {
            "bindBufferRange", WebGL2RenderingContextV8Internal::bindBufferRangeMethodCallback, 0, 5, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, bindBufferRangeMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration getIndexedParameterMethodConfiguration = {
            "getIndexedParameter", WebGL2RenderingContextV8Internal::getIndexedParameterMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, getIndexedParameterMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration getUniformIndicesMethodConfiguration = {
            "getUniformIndices", WebGL2RenderingContextV8Internal::getUniformIndicesMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, getUniformIndicesMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration getActiveUniformsMethodConfiguration = {
            "getActiveUniforms", WebGL2RenderingContextV8Internal::getActiveUniformsMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, getActiveUniformsMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration getUniformBlockIndexMethodConfiguration = {
            "getUniformBlockIndex", WebGL2RenderingContextV8Internal::getUniformBlockIndexMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, getUniformBlockIndexMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration getActiveUniformBlockParameterMethodConfiguration = {
            "getActiveUniformBlockParameter", WebGL2RenderingContextV8Internal::getActiveUniformBlockParameterMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, getActiveUniformBlockParameterMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration getActiveUniformBlockNameMethodConfiguration = {
            "getActiveUniformBlockName", WebGL2RenderingContextV8Internal::getActiveUniformBlockNameMethodCallback, 0, 2, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, getActiveUniformBlockNameMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration uniformBlockBindingMethodConfiguration = {
            "uniformBlockBinding", WebGL2RenderingContextV8Internal::uniformBlockBindingMethodCallback, 0, 3, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, uniformBlockBindingMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration createVertexArrayMethodConfiguration = {
            "createVertexArray", WebGL2RenderingContextV8Internal::createVertexArrayMethodCallback, 0, 0, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, createVertexArrayMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration deleteVertexArrayMethodConfiguration = {
            "deleteVertexArray", WebGL2RenderingContextV8Internal::deleteVertexArrayMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, deleteVertexArrayMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration isVertexArrayMethodConfiguration = {
            "isVertexArray", WebGL2RenderingContextV8Internal::isVertexArrayMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, isVertexArrayMethodConfiguration);
    }
    if (RuntimeEnabledFeatures::unsafeES3APIsEnabled()) {
        const V8DOMConfiguration::MethodConfiguration bindVertexArrayMethodConfiguration = {
            "bindVertexArray", WebGL2RenderingContextV8Internal::bindVertexArrayMethodCallback, 0, 1, V8DOMConfiguration::ExposedToAllScripts,
        };
        V8DOMConfiguration::installMethod(isolate, prototypeTemplate, defaultSignature, v8::None, bindVertexArrayMethodConfiguration);
    }

    // Custom toString template
    functionTemplate->Set(v8AtomicString(isolate, "toString"), V8PerIsolateData::from(isolate)->toStringTemplate());
}

v8::Local<v8::FunctionTemplate> V8WebGL2RenderingContext::domTemplate(v8::Isolate* isolate)
{
    return V8DOMConfiguration::domClassTemplate(isolate, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8WebGL2RenderingContextTemplate);
}

bool V8WebGL2RenderingContext::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->hasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8WebGL2RenderingContext::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate)
{
    return V8PerIsolateData::from(isolate)->findInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

WebGL2RenderingContext* V8WebGL2RenderingContext::toImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value)
{
    return hasInstance(value, isolate) ? toImpl(v8::Local<v8::Object>::Cast(value)) : 0;
}

void V8WebGL2RenderingContext::refObject(ScriptWrappable* scriptWrappable)
{
#if !ENABLE(OILPAN)
    scriptWrappable->toImpl<WebGL2RenderingContext>()->ref();
#endif
}

void V8WebGL2RenderingContext::derefObject(ScriptWrappable* scriptWrappable)
{
#if !ENABLE(OILPAN)
    scriptWrappable->toImpl<WebGL2RenderingContext>()->deref();
#endif
}

} // namespace blink
